<?php

/*
Addon: Button
*/

class MPAVC_Button {

	/*
	 * Contruct
	 */
    public function __construct() {

        add_action('wp_enqueue_scripts', array($this, 'load_scripts'));

        add_shortcode('mpavc_button', array($this, 'shortcode_addon_func'));

        add_action('init', array($this, 'map_vc_addon'));

    }

    function load_scripts() {
		
		wp_enqueue_style( 'bootstrap' );
        wp_enqueue_style( 'mpavc-style' );
		wp_enqueue_style( 'font-awesome' );
		wp_enqueue_style( 'animations' );
		wp_enqueue_script( 'appear' );
		wp_enqueue_script( 'animations' );
		wp_enqueue_script( 'easypiechart' );
		
    }
	
	/*
	 * Addon View
	 */
    public function shortcode_addon_func($atts, $content = null, $tag) {
		static $instance;
		$instance++;
		
        $date = '';

        extract(shortcode_atts(array(

			'button_type' => 'flat-button-mini', 
			'button_text' => '',
			'button_url' => '',
			'button_target_url' => '_self',
			'button_align' => 'mpavc-align-center',
			'button_custom_padding' => '',
			'button_custom_margin' => '',
			'button_custom_border_radius' => '',
			'button_display' => 'block', 
			'button_icon_show' => 'mpavc-icon-hidden',
			'button_icon' => 'fa fa-instagram',  
			'button_font_type' => 'mpavc-font-default', 
			'google_fonts' => '',
			'button_size' => 'off',
			'button_text_color' => '#FC615D',
			'button_over_color' => '#FC615D',
			'button_background_color' => '#FC615D',
			'button_border_color' => '#FC615D',
			'button_border_type' => 'mpavc-border-square',
			'button_border_style' => 'solid',
			'button_custom_border_active' => 'on',
			'button_custom_border_color' => '#FC615D',
			'button_custom_border_width' => '', 
			'button_custom_border_style' => 'solid',
			'button_custom_text_over_color' => '',
			'button_custom_background_over_color' => '#FC615D',
			'addon_animate'				=> 'off',
			'effect'					=> 'fade-in',
			'delay'						=> '0',
			

        ), $atts));
		
		$css_i_inline = $css_container_inline = $css_a_inline = 'style="';
		$css_style_to_append = '';
		
		// Google Fonts
		if($button_font_type == 'mpavc-google-font') :
			 
			// Build the data array
			$text_font_data = $this->mpavc_getFontsData( $google_fonts );
			 
			// Build the inline style
			$css_a_inline .= $this->mpavc_googleFontsStyles( $text_font_data );   
					 
			// Enqueue the right font   
			$this->mpavc_enqueueGoogleFonts( $text_font_data );

		endif;
		
		$css_container_inline .= 'display:'.esc_html($button_display).';';
		$css_i_inline .= 'font-size:'.esc_html($button_size).';';				
		$css_a_inline .= 'font-size:'.esc_html($button_size).';';

		
		if(	$button_type == 'flat-button-mini' || 
			$button_type == 'flat-button-small' || 
			$button_type == 'flat-button-medium' || 
			$button_type == 'flat-button-large') :

			$css_a_inline .= 'color:'.esc_html($button_text_color).';
							  background:'.esc_html($button_background_color).';
							  border-color:'.esc_html($button_background_color).';
							  border-style:'.esc_html($button_border_style).';';


							  
			$css_style_to_append = '<style>
			.mpavc-button.'.esc_html($button_type).'.mpavc-button-'.esc_html($instance).' a:hover {
							color:'.esc_html($button_background_color).'!important;
							background:'.esc_html($button_text_color).'!important;
							border-color:'.esc_html($button_text_color).'!important; 
			}
			</style>';
		endif;

		if(	$button_type == 'bg-none-button-mini' || 
			$button_type == 'bg-none-button-small' || 
			$button_type == 'bg-none-button-medium' || 
			$button_type == 'bg-none-button-large') :

			$css_a_inline .= 'color:'.esc_html($button_text_color).';
							border-color:'.esc_html($button_text_color).';
							border-style:'.esc_html($button_border_style).';';
			
			
			$css_style_to_append = '<style>
					.mpavc-button.'.esc_html($button_type).'.mpavc-button-'.esc_html($instance).' a:hover {
						color:'.esc_html($button_over_color).'!important;
						border-color:'.esc_html($button_over_color).'!important;					
					}
			</style>';

		endif;
		
		if(	$button_type == 'd-button-mini' || 
			$button_type == 'd-button-small' || 
			$button_type == 'd-button-medium' || 
			$button_type == 'd-button-large') :							
			
			if($button_type == 'd-button-mini') { $shadow_size = '4'; }
			if($button_type == 'd-button-small') { $shadow_size = '6'; }
			if($button_type == 'd-button-medium') { $shadow_size = '8'; }
			if($button_type == 'd-button-large') { $shadow_size = '10'; }
			
			
			$css_a_inline .= 'color:'.esc_html($button_text_color).';
							background:'.esc_html($button_background_color).';
							box-shadow: 0 '.esc_html($shadow_size).'px 0 '.esc_html($button_border_color).';';
							
			$css_style_to_append = '<style>				
						.mpavc-button.'.esc_html($button_type).'.mpavc-button-'.esc_html($instance).' a:hover {
							box-shadow: 0 2px 0 '.esc_html($button_border_color).'!important;					
						}
			</style>';
		endif;		
		
		if($button_type == 'button-custom') {
			$css_a_inline .= '
							color:'.esc_html($button_text_color).';
							background:'.esc_html($button_background_color).';
							padding:'.esc_html($button_custom_padding).';
							margin:'.esc_html($button_custom_margin).';
							border-radius:'.esc_html($button_custom_border_radius).';
						';
			$css_style_to_append = '<style>				
						.mpavc-button.'.esc_html($button_type).'.mpavc-button-'.esc_html($instance).' a:hover {
							color:'.esc_html($button_custom_text_over_color).'!important;
							background:'.esc_html($button_custom_background_over_color).'!important;
							border-color:'.esc_html($button_text_color).'!important;					
						}
			</style>';
			
			if($button_custom_border_active == 'on') {
				$css_a_inline .= '
							border-color:'.esc_html($vcop_button_custom_border_color).';	
							border-width:'.esc_html($vcop_button_custom_border_width).';
							border-style:'.esc_html($vcop_button_custom_border_style).';			
				}';
			}
		}		
		

		$css_i_inline .= '"';
		$css_container_inline .= '"';
		$css_a_inline .= '"';
		
		
		
		
		$data_value = 'data-mpavc-custom-css="'.$css_style_to_append.'"';
		
				
		$inline_block = '';
		if($button_display == 'inline-block') {
			$inline_block .= 'mpavc-inline-block';
		}		
		
		$output .= '<span '.$css_container_inline.' '.$data_value.' class="mpavc-button mpavc-custom-js '.esc_html($button_type).' '.esc_html($inline_block).' '.esc_html($button_border_type).' '.esc_html($button_align).' mpavc-button-'.esc_html($instance).mpavc_animate_class($addon_animate,$effect,$delay).'>';
			$output .= '<a '.$css_a_inline.' href="'.esc_url($button_url).'" target="'.esc_html($button_target_url).'">';
				
			if($button_icon_show == 'mpavc-icon-show') {
				$output	.= '<i '.$css_i_inline.' class="'.esc_html($button_icon).'"></i>';
			}				
					
			$output .= esc_html($button_text) . '</a>';
		$output .= '</span>';		
		
        return $output;
    }

	/*
	 * Google Fonts Help
	 */	
     
    // Build the string of values in an Array
    protected function mpavc_getFontsData( $fontsString ) {   
     
        // Font data Extraction
        $googleFontsParam = new Vc_Google_Fonts();      
        $fieldSettings = array();
        $fontsData = strlen( $fontsString ) > 0 ? $googleFontsParam->_vc_google_fonts_parse_attributes( $fieldSettings, $fontsString ) : '';
        return $fontsData;
         
    }
     
    // Build the inline style starting from the data
    protected function mpavc_googleFontsStyles( $fontsData ) {
         
        // Inline styles
        $fontFamily = explode( ':', $fontsData['values']['font_family'] );
        $styles[] = 'font-family:' . $fontFamily[0];
        $fontStyles = explode( ':', $fontsData['values']['font_style'] );
        $styles[] = 'font-weight:' . $fontStyles[1];
        $styles[] = 'font-style:' . $fontStyles[2];
         
        $inline_style = '';     
        foreach( $styles as $attribute ){           
            $inline_style .= $attribute.'; ';       
        }   
         
        return $inline_style;
         
    }
     
    // Enqueue right google font from Googleapis
    protected function mpavc_enqueueGoogleFonts( $fontsData ) {
         
        // Get extra subsets for settings (latin/cyrillic/etc)
        $settings = get_option( 'wpb_js_google_fonts_subsets' );
        if ( is_array( $settings ) && ! empty( $settings ) ) {
            $subsets = '&subset=' . implode( ',', $settings );
        } else {
            $subsets = '';
        }
         
        // We also need to enqueue font from googleapis
        if ( isset( $fontsData['values']['font_family'] ) ) {
            wp_enqueue_style( 
                'vc_google_fonts_' . vc_build_safe_css_class( $fontsData['values']['font_family'] ), 
                '//fonts.googleapis.com/css?family=' . $fontsData['values']['font_family'] . $subsets
            );
        }
         
    }
	
	/*
	 * Addon Backend
	 */	
    function map_vc_addon() {
        if (function_exists("vc_map")) {

            vc_map(array(
                "name" => esc_html__("Button", "mpavc"),
                "base" => "mpavc_button",
                "content_element" => true,
                "show_settings_on_create" => true,
                "category" => esc_html__("MP Addons", "mpavc"),
                'description' => esc_html__('Add your Button', 'mpavc'),
                "icon" => MPAVC_URL . '/assets/img/vc-button.png',
                "params" => array(
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Button Type", 'mpavc'),
						"param_name" => "button_type",
						"value" => array(
										esc_html__('Flat Button Mini','mpavc') 						=> 'flat-button-mini',
										esc_html__('Flat Button Small','mpavc')  					=> 'flat-button-small',
										esc_html__('Flat Button Medium','mpavc')  					=> 'flat-button-medium',
										esc_html__('Flat Button Large','mpavc')  					=> 'flat-button-large',
										esc_html__('Backgraund Transparent Button Mini','mpavc') 	=> 'bg-none-button-mini',
										esc_html__('Backgraund Transparent Button Small','mpavc') 	=> 'bg-none-button-small',
										esc_html__('Backgraund Transparent Button Medium','mpavc') 	=> 'bg-none-button-medium',
										esc_html__('Backgraund Transparent Button Large','mpavc') 	=> 'bg-none-button-large',
										esc_html__('3D Button Mini','mpavc') 						=> 'd-button-mini',
										esc_html__('3D Button Small','mpavc')  						=> 'd-button-small',
										esc_html__('3D Button Medium','mpavc')  					=> 'd-button-medium',
										esc_html__('3D Button Large','mpavc')  						=> 'd-button-large',
										esc_html__('Custom','mpavc')  								=> 'button-custom',																	
					   ),			   
					),	
					array(
						'type' => 'textarea',
						'heading' => esc_html__( 'Text', 'mpavc' ),
						'param_name' => 'button_text',
						'admin_label' => true,
					),
					array(
						'type' => 'textfield',
						'heading' => esc_html__( 'Url Button', 'mpavc' ),
						'param_name' => 'button_url',
						'description' => 'ex http://www.google.com',
						'value' => '',										
					),					
					array(
					  "type" => "dropdown",
					  "class" => "",
					  "heading" => esc_html__("Target Button", 'mpavc'),
					  "param_name" => "button_target_url",
					  "value" => array(
										__('Self (Same Window)','mpavc') 		=> '_self',
										__('Blank (New Window)','mpavc')  		=> '_blank',
					   ),				   			   
					),					
					
					
				    /* ICON */
					array(
					  "type" => "dropdown",
					  "class" => "",
					  "heading" => esc_html__("Icon Show", 'mpavc'),
					  "param_name" => "button_icon_show",
					  "value" => array(
							esc_html__('Hidden','mpavc')  	=> 'mpavc-icon-hidden',
							esc_html__('Show','mpavc') 	=> 'mpavc-icon-show'
										
					   ),				   			   
					),						
					array(
						"type" => "iconpicker",
						"heading" => esc_html__( "Icon", "mpavc" ),
						"param_name" => "button_icon",
						"settings" => array(
							"emptyIcon" 	=> false,
							"type" 			=> "fontawesome",
							"iconsPerPage" 	=> 200,
						),
						"dependency" => array(
							'element' => 'button_icon_show',
							'value' => array( 'mpavc-icon-show' )
						),						
						"description" => esc_html__( "Select icon from library.", "mpavc" ),
					),					
					
					
					
					/* STYLE */
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Font Type", 'mpavc'),
						"param_name" => "button_font_type",
						"value" => array(
										__('Default Site','mpavc') 			=> 'mpavc-font-default',
										__('Google Fonts Custom','mpavc')  	=> 'mpavc-google-font'
						),
						"group" => "Style"				   			   
					),
					array(
						'type' => 'google_fonts',
						'param_name' => 'google_fonts',
						'value' => 'font_family:Abril%20Fatface%3Aregular|font_style:400%20regular%3A400%3Anormal',
						'settings' => array(
							'fields' => array(
								'font_family_description' => esc_html__( 'Select font family.', 'js_composer' ),
								'font_style_description' => esc_html__( 'Select font styling.', 'js_composer' ),
							),
						),
						'dependency' => array(
								'element' => 'button_font_type',
								'value' => array( 'mpavc-google-font' )
						),
						"group" => "Style"						
					),					
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Text Size (px)",'mpavc'),
						"param_name" => "button_size",
						"description" => "ex 15px",
						"group" => "Style"				  			  				  
					),
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Text Align", 'mpavc'),
						"param_name" => "button_align",
						"value" => array(
										esc_html__('Center','mpavc') 	=> 'mpavc-align-center',
										esc_html__('Left','mpavc')  	=> 'mpavc-align-left',
										esc_html__('Right','mpavc')  	=> 'mpavc-align-right',
					   ),
					   "group" => "Style"				   			   
					),					
					/* BUTTON CUSTOM */
					array(
					  "type" => "textfield",
					  "class" => "",
					  "heading" => esc_html__("Padding (px)",'mpavc'),
					  "param_name" => "button_custom_padding",
					  "description" => "ex 15px",
					  "dependency" => array(
								'element' => 'button_type',
								'value' => array( 'button-custom' )
					 ),				  
					  "group" => "Style"				  			  				  
					),
					array(
					  "type" => "textfield",
					  "class" => "",
					  "heading" => esc_html__("Margin (px)",'mpavc'),
					  "param_name" => "button_custom_margin",
					  "description" => "ex 15px",
					  "dependency" => array(
								'element' => 'button_type',
								'value' => array( 'button-custom' )
					 ),				  
					  "group" => "Style"				  			  				  
					),
					array(
					  "type" => "textfield",
					  "class" => "",
					  "heading" => esc_html__("Border Radius (ex: 10px)",'mpavc'),
					  "param_name" => "button_custom_border_radius",
					  "description" => "ex 15px",
					  "dependency" => array(
								'element' => 'button_type',
								'value' => array( 'button-custom' )
					 ),				  
					  "group" => "Style"				  			  				  
					),
					/* #BUTTON CUSTOM */					
					array(
					  "type" => "dropdown",
					  "class" => "",
					  "heading" => esc_html__("Button Display", 'mpavc'),
					  "param_name" => "button_display",
					  "value" => array(
										esc_html__('Block','mpavc') 	=> 'block',
										esc_html__('Inline','mpavc')  	=> 'inline-block'
					   ),
					   "group" => "Style"				   			   
					),				
					array(
					  "type" => "dropdown",
					  "class" => "",
					  "heading" => esc_html__("Border Type", 'mpavc'),
					  "param_name" => "button_border_type",
					  "value" => array(
										esc_html__('Square','mpavc')  		=> 'mpavc-border-square',
										esc_html__('Round','mpavc') 		=> 'mpavc-border-round'
										
					   ),
					   "dependency" => array(
								'element' => 'button_type',
								'value' => array(
											'bg-none-button-mini', 
											'bg-none-button-small',
											'bg-none-button-medium',
											'bg-none-button-large',
											'flat-button-mini', 
											'flat-button-small',
											'flat-button-medium',
											'flat-button-large',							
											'd-button-mini', 
											'd-button-small',
											'd-button-medium',
											'd-button-large'																													
										)
					   ),				   
					   "group" => "Style"				   			   
					),
					array(
					  "type" => "dropdown",
					  "class" => "",
					  "heading" => esc_html__("Border Style", 'mpavc'),
					  "param_name" => "button_border_style",
					  "value" => array(
										esc_html__('Solid','mpavc')  		=> 'solid',
										esc_html__('Dotted','mpavc') 		=> 'dotted',
										esc_html__('Dashed','mpavc') 		=> 'dashed',
										esc_html__('Double','mpavc') 		=> 'double',
										esc_html__('Inset','mpavc') 		=> 'inset',
										esc_html__('Outset','mpavc') 		=> 'outset',									
					   ),
					   "dependency" => array(
								'element' => 'button_type',
								'value' => array(
											'bg-none-button-mini', 
											'bg-none-button-small',
											'bg-none-button-medium',
											'bg-none-button-large'																			
										)
					   ),				   
					   "group" => "Style"				   			   
					),																			
					array(
						  "type" => "colorpicker",
						  "class" => "",
						  "heading" => esc_html__("Text Color", 'mpavc'),
						  "param_name" => "button_text_color",
						  "value" => '#FC615D',
						  "group" => "Style"			  
					 ),  
					 array(
						  "type" => "colorpicker",
						  "class" => "",
						  "heading" => esc_html__("Over Color", 'mpavc'),
						  "param_name" => "button_over_color",
						  "value" => '#FC615D',
						  "dependency" => array(
								'element' => 'button_type',
								'value' => array(
											'bg-none-button-mini', 
											'bg-none-button-small',
											'bg-none-button-medium',
											'bg-none-button-large',																		
										)
						  ),					  
						  "group" => "Style"					  					  				  
					  ),
					 array(
						  "type" => "colorpicker",
						  "class" => "",
						  "heading" => esc_html__("Background Color", 'mpavc'),
						  "param_name" => "button_background_color",
						  "value" => '#FC615D',
						  "dependency" => array(
								'element' => 'button_type',
								'value' => array( 
											'flat-button-mini', 
											'flat-button-small',
											'flat-button-medium',
											'flat-button-large',							
											'd-button-mini', 
											'd-button-small',
											'd-button-medium',
											'd-button-large',
											'button-custom',
										)
						  ),					  
						  "group" => "Style"					  					  				  
					  ),				  
					 array(
						  "type" => "colorpicker",
						  "class" => "",
						  "heading" => esc_html__("Border Color", 'mpavc'),
						  "param_name" => "button_border_color",
						  "value" => '#FC615D',
						  "dependency" => array(
								'element' => 'button_type',
								'value' => array( 
											'd-button-mini', 
											'd-button-small',
											'd-button-medium',
											'd-button-large',
										)
						  ),						  
						  "group" => "Style"					  					  				  
					  ),


					 array(
					  "type" => "dropdown",
					  "class" => "",
					  "heading" => esc_html__("Border Show", 'mpavc'),
					  "param_name" => "button_custom_border_active",
					  "value" => array(
										esc_html__('On','mpavc')  		=> 'on',
										esc_html__('Off','mpavc') 		=> 'off'									
								),				 
					  "dependency" => array(
								'element' => 'button_type',
								'value' => array( 'button-custom' )
						  ),
					  "group" => "Style"  	
					 ),	
					array(
					  "type" => "textfield",
					  "class" => "",
					  "heading" => esc_html__("Border Width",'mpavc'),
					  "param_name" => "button_custom_border_width",
					  "description" => "ex 1px",
					  "dependency" => array(
								'element' => 'button_type',
								'value' => array( 'button-custom' )
						  ),			  
					  "group" => "Style"				  			  				  
					),					 		 
					 array(
						  "type" => "colorpicker",
						  "class" => "",
						  "heading" => esc_html__("Border Color", 'mpavc'),
						  "param_name" => "button_custom_border_color",
						  "value" => '#FC615D',
						  "dependency" => array(
								'element' => 'button_type',
								'value' => array( 'button-custom' )
						  ),						  
						  "group" => "Style"					  					  				  
					  ),
					array(
					  "type" => "dropdown",
					  "class" => "",
					  "heading" => esc_html__("Border Style", 'mpavc'),
					  "param_name" => "button_custom_border_style",
					  "value" => array(
										esc_html__('Solid','mpavc')  		=> 'solid',
										esc_html__('Dotted','mpavc') 		=> 'dotted',
										esc_html__('Dashed','mpavc') 		=> 'dashed',
										esc_html__('Double','mpavc') 		=> 'double',
										esc_html__('Inset','mpavc') 		=> 'inset',
										esc_html__('Outset','mpavc') 		=> 'outset',									
					   ),
					  "dependency" => array(
									'element' => 'button_type',
									'value' => array( 'button-custom' )
								),			   
					  "group" => "Style"				   			   
					),	
					 array(
						  "type" => "colorpicker",
						  "class" => "",
						  "heading" => esc_html__("Text Over Color", 'mpavc'),
						  "param_name" => "button_custom_text_over_color",
						  "value" => '#FC615D',
						  "dependency" => array(
								'element' => 'button_type',
								'value' => array( 'button-custom' )
						  ),						  
						  "group" => "Style"					  					  				  
					  ),
					 array(
						  "type" => "colorpicker",
						  "class" => "",
						  "heading" => esc_html__("Background Over Color", 'mpavc'),
						  "param_name" => "button_custom_background_over_color",
						  "value" => '#FC615D',
						  "dependency" => array(
								'element' => 'button_type',
								'value' => array( 'button-custom' )
						  ),						  
						  "group" => "Style"					  					  				  
					  ),					
					

					
					// ANIMATION								  							  		  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate", 'mpavc'),
						"param_name" => "addon_animate",
						"value" => array(
										esc_html__('Off','mpavc') 	=> 'off',
										esc_html__('On','mpavc') 	=> 'on'
										
						),
						"group" => "Animation"
					),			  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate Effects", 'mpavc'),
						"param_name" => "effect",
						"value" => mpavc_animation_effect(),
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"group" => "Animation"				   
					),				  
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Animate Delay (ms)",'mpavc'),
						"param_name" => "delay",
						"description" => "ex 1000",					  
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"value" => "0",
						"group" => "Animation"					  
					),
                ),
            ));


        }
    }

} // End Class

if (class_exists('WPBakeryShortCode')) {
    class WPBakeryShortCode_MPAVC_Button extends WPBakeryShortCode {
    }
}

// Initialize Element Class
if (class_exists('MPAVC_Button')) {
    new MPAVC_Button();
}

