<?php

/*
Addon: Pie_Chart
*/

class MPAVC_Pie_Chart {

	/*
	 * Contruct
	 */
    public function __construct() {

        add_action('wp_enqueue_scripts', array($this, 'load_scripts'));

        add_shortcode('mpavc_pie_chart', array($this, 'shortcode_addon_func'));

        add_action('init', array($this, 'map_vc_addon'));

    }

    function load_scripts() {
		
		wp_enqueue_style( 'bootstrap' );
        wp_enqueue_style( 'mpavc-style' );
		wp_enqueue_style( 'font-awesome' );
		wp_enqueue_style( 'animations' );
		wp_enqueue_script( 'appear' );
		wp_enqueue_script( 'animations' );
		wp_enqueue_script( 'easypiechart' );
		
    }
	
	/*
	 * Addon View
	 */
    public function shortcode_addon_func($atts, $content = null, $tag) {
		static $instance;
		$instance++;
		
        $date = '';

        extract(shortcode_atts(array(

			'bar_color'					=> '#FC615D',
			'track_color'				=> '#FF0000',
			'number_color'				=> '#000000',
			'percent'					=> '1',
			'bar_width'					=> '',
			'addon_animate'				=> 'off',
			'effect'					=> 'fade-in',
			'delay'						=> '0',
			

        ), $atts));
		
		$responsive_on = '';
		if(empty($bar_width) || $bar_width == '') : $bar_width = '300'; endif;
		if($bar_width >= 300) : $responsive_on = 'mpavc_pie_chart_responsive'; endif;
	
		
        $output = '<div class="mpavc mpavc-pie-chart '.mpavc_animate_class($addon_animate,$effect,$delay).'>';
			
			$output .= '<div class="mpavc-chart-item-container hidden '.esc_html($responsive_on).'">
				<div class="mpavc-chart mpavc-rand'.esc_html($instance).' easyPieChart" 
						data-percent="'.esc_html($percent).'" 
						data-color="'.esc_html($bar_color).'" 
						data-colortrack="'.esc_html($track_color).'"
						data-piewidth="'.esc_html($bar_width).'"
						style="width: '.esc_html($bar_width).'px;height: '.esc_html($bar_width).'px;">
						<span class="mpavc-percent" style="color:'.esc_html($number_color).';line-height: '.esc_html($bar_width).'px;color:'.esc_html($bar_color).';">'.esc_html($percent).'</span>
				</div>
			</div>';

		$output .= '</div>';	
		
        return $output;
    }
		
	/*
	 * Addon Backend
	 */	
    function map_vc_addon() {
        if (function_exists("vc_map")) {

            vc_map(array(
                "name" => esc_html__("Pie Chart", "mpavc"),
                "base" => "mpavc_pie_chart",
                "content_element" => true,
                "show_settings_on_create" => true,
                "category" => esc_html__("MP Addons", "mpavc"),
                'description' => esc_html__('Add your Pie Chart', 'mpavc'),
                "icon" => MPAVC_URL . '/assets/img/vc-pie-chart.png',
                "params" => array(
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Bar Color", 'mpavc'),
						"param_name" => "bar_color",
						"value" => '#FC615D'
					),
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Track Color", 'mpavc'),
						"param_name" => "track_color",
						"value" => '#FF0000'
					),
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Number Color", 'mpavc'),
						"param_name" => "number_color",
						"value" => '#000000'
					),						
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Percent", 'mpavc'),
						"param_name" => "percent",
						"value" => array(
										'1',
										'2',
										'3',
										'4',
										'5',
										'6',
										'7',
										'8',
										'9',
										'10',
										'11',
										'12',
										'13',
										'14',
										'15',
										'16',
										'17',
										'18',
										'19',
										'20',
										'21',
										'22',
										'23',
										'24',
										'25',
										'26',
										'27',
										'28',
										'29',
										'30',
										'31',
										'32',
										'33',
										'34',
										'35',
										'36',
										'37',
										'38',
										'39',
										'40',
										'41',
										'42',
										'43',
										'44',
										'45',
										'46',
										'47',
										'48',
										'49',
										'50',
										'51',
										'52',
										'53',
										'54',
										'55',
										'56',
										'57',
										'58',
										'59',
										'60',
										'61',
										'62',
										'63',
										'64',
										'65',
										'66',
										'67',
										'68',
										'69',
										'70',
										'71',
										'72',
										'73',
										'74',
										'75',
										'76',
										'77',
										'78',
										'79',
										'80',
										'81',
										'82',
										'83',
										'84',
										'85',
										'86',
										'87',
										'88',
										'89',
										'90',
										'91',
										'92',
										'93',
										'94',
										'95',
										'96',
										'97',
										'98',
										'99',
										'100'																																																																		
					    )
					),			  										
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Width",'mpavc'),
						"param_name" => "bar_width",
						"description" => esc_html__('example: 400','mpavc'),			  
					),
					
					// ANIMATION								  							  		  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate", 'mpavc'),
						"param_name" => "addon_animate",
						"value" => array(
										esc_html__('Off','mpavc') 	=> 'off',
										esc_html__('On','mpavc') 	=> 'on'
										
						),
						"group" => "Animation"
					),			  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate Effects", 'mpavc'),
						"param_name" => "effect",
						"value" => mpavc_animation_effect(),
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"group" => "Animation"				   
					),				  
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Animate Delay (ms)",'mpavc'),
						"param_name" => "delay",
						"description" => "ex 1000",					  
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"value" => "0",
						"group" => "Animation"					  
					),
                ),
            ));


        }
    }

} // End Class

if (class_exists('WPBakeryShortCode')) {
    class WPBakeryShortCode_MPAVC_Pie_Chart extends WPBakeryShortCode {
    }
}

// Initialize Element Class
if (class_exists('MPAVC_Pie_Chart')) {
    new MPAVC_Pie_Chart();
}

