<?php

/*
Addon: Counter
*/

class MPAVC_Counter {

	/*
	 * Contruct
	 */
    public function __construct() {

        add_action('wp_enqueue_scripts', array($this, 'load_scripts'));

        add_shortcode('mpavc_counter', array($this, 'shortcode_addon_func'));

        add_action('init', array($this, 'map_vc_addon'));

    }

    function load_scripts() {
		
		wp_enqueue_style( 'bootstrap' );
        wp_enqueue_style( 'mpavc-style' );
		wp_enqueue_style( 'font-awesome' );
		wp_enqueue_style( 'animations' );
		wp_enqueue_script( 'appear' );
		wp_enqueue_script( 'animations' );
		wp_enqueue_script( 'countTo' );
		
    }
	
	/*
	 * Addon View
	 */
    public function shortcode_addon_func($atts, $content = null, $tag) {
		static $instance;
		$instance++;
		
        $date = '';

        extract(shortcode_atts(array(

            'number' 					=> '',			
			'custom_style'				=> 'off',
            'color' 					=> '#FFFFFF',
            'size'		 				=> '30px',
            'weight' 					=> 'normal',
			'padding'					=> '10px',
			'background_options'		=> 'off',
			'background_color' 			=> '#000000',
			'border_radius' 			=> '',
			'addon_animate'				=> 'off',
			'effect'					=> 'fade-in',
			'delay'						=> '0',
			

        ), $atts));

		$css_inline = 'style="';
		
			// Custom Style
			if($custom_style == 'on') :
				$css_inline .= 'color:'.esc_html($color).';font-size:'.esc_html($size).';font-weight:'.esc_html($weight).';padding:'.esc_html($padding).';';
				if($background_options == 'on') :
					$css_inline .= 'background:'.esc_html($background_color).';border-radius:'.esc_html($border_radius).';';
				endif;
			endif;
		
		$css_inline .= '"';		
		
        $output = '<div class="mpavc mpavc-counter-container '.mpavc_animate_class($addon_animate,$effect,$delay).'>';
		$output .= '<span class="mpavc-counter timer" '.$css_inline.' data-istance="mpavc-counter-'.esc_html($instance).'" data-to="'.esc_html($number).'" data-speed="10000"></span>';
		$output .= '</div>';

        return $output;
    }
		
	/*
	 * Addon Backend
	 */	
    function map_vc_addon() {
        if (function_exists("vc_map")) {

            vc_map(array(
                "name" => esc_html__("Counter", "mpavc"),
                "base" => "mpavc_counter",
                "content_element" => true,
                "show_settings_on_create" => true,
                "category" => esc_html__("MP Addons", "mpavc"),
                'description' => esc_html__('Add your Counter', 'mpavc'),
                "icon" => MPAVC_URL . '/assets/img/vc-counter.png',
                "params" => array(
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Counter Number",'mpavc'),
						"param_name"  => "number",
						"description" => "ex: 30",
						"admin_label" => true,
						"value" => ""					  
					),										
										
					// STYLE					
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Style", 'mpavc'),
						"param_name" => "custom_style",
						"value" => array(
										esc_html__('Off','mpavc') 	=> 'off',
										esc_html__('On','mpavc') 	=> 'on'
										
						),
						"group" => "Style"
					),					
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Color", 'mpavc'),
						"param_name" => "color",
						"value" => '#FFFFFF',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),			
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Counter size",'mpavc'),
						"param_name" => "size",
						"description" => "ex: 30px",					  
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),
						"value" => "30px",
						"group" => "Style"					  
					),					
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Counter Weight", 'mpavc'),
						"param_name" => "weight",
						"value" => array(
										esc_html__('Normal','mpavc') 	=> 'normal',
										esc_html__('Bold','mpavc') 		=> 'bold',
										esc_html__('100','mpavc') 		=> '100',
										esc_html__('200','mpavc') 		=> '200',
										esc_html__('300','mpavc') 		=> '300',
										esc_html__('400','mpavc') 		=> '400',
										esc_html__('500','mpavc') 		=> '500',
										esc_html__('600','mpavc') 		=> '600',
										esc_html__('700','mpavc') 		=> '700',
										esc_html__('800','mpavc') 		=> '800',
										esc_html__('900','mpavc') 		=> '900'
										
						),
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),						
						"group" => "Style"
					),				
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Padding",'mpavc'),
						"param_name" => "padding",
						"description" => "ex: 10px",					  
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),
						"value" => "10px",
						"group" => "Style"					  
					),					
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Background Options", 'mpavc'),
						"param_name" => "background_options",
						"value" => array(
										esc_html__('Off','mpavc') 	=> 'off',
										esc_html__('On','mpavc') 	=> 'on'
										
						),
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),						
						"group" => "Style"
					),
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Background Color", 'mpavc'),
						"param_name" => "background_color",
						"value" => '#000000',
						'dependency' => array(
								'element' => 'background_options',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Border Radius",'mpavc'),
						"param_name" => "border_radius",
						"description" => "ex: 10px or leave empty to border square",					  
						"dependency" => array(
								"element" => "background_options",
								"value" => array( "on" )
						),
						"value" => "",
						"group" => "Style"					  
					),
					
					// ANIMATION								  							  		  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate", 'mpavc'),
						"param_name" => "addon_animate",
						"value" => array(
										esc_html__('Off','mpavc') 	=> 'off',
										esc_html__('On','mpavc') 	=> 'on'
										
						),
						"group" => "Animation"
					),			  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate Effects", 'mpavc'),
						"param_name" => "effect",
						"value" => mpavc_animation_effect(),
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"group" => "Animation"				   
					),				  
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Animate Delay (ms)",'mpavc'),
						"param_name" => "delay",
						"description" => "ex 1000",					  
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"value" => "0",
						"group" => "Animation"					  
					),
                ),
            ));


        }
    }

} // End Class

if (class_exists('WPBakeryShortCode')) {
    class WPBakeryShortCode_MPAVC_Counter extends WPBakeryShortCode {
    }
}

// Initialize Element Class
if (class_exists('MPAVC_Counter')) {
    new MPAVC_Counter();
}

