<?php

/*
Addon: date
*/

class MPAVC_Date {

	/*
	 * Contruct
	 */
    public function __construct() {

        add_action('wp_enqueue_scripts', array($this, 'load_scripts'));

        add_shortcode('mpavc_date', array($this, 'shortcode_addon_func'));

        add_action('init', array($this, 'map_vc_addon'));

    }

    function load_scripts() {
		
		wp_enqueue_style( 'bootstrap' );
        wp_enqueue_style( 'mpavc-style' );
		wp_enqueue_style( 'font-awesome' );
		wp_enqueue_style( 'animations' );
		wp_enqueue_script( 'appear' );
		wp_enqueue_script( 'animations' );
		
    }
	
	/*
	 * Addon View
	 */
    public function shortcode_addon_func($atts, $content = null, $tag) {
		static $instance;
		$instance++;
		
        $date = '';

        extract(shortcode_atts(array(

            'date_format' 	=> 'F j, Y',
			'icon_show'		=> 'on',
			'date_icon'		=> '',
			'display'		=> 'mpavc-inline-block', 
			'custom_style'	=> 'off',
			'icon_color'	=> '#FFFFFF',
			'text_color'	=> '#333333',
			'font_size'		=> '10px',
			'font_weight'	=> 'normal',
			'addon_animate'	=> 'off',
			'effect'		=> 'fade-in',
			'delay'			=> '0',
			

        ), $atts));

		if($custom_style == 'on') :
			$css_text 		= 'style="color:'.esc_html($text_color).';font-size:'.esc_html($font_size).';font-weight:'.esc_html($font_weight).'"';
			$css_icon_color = 'style="color:'.esc_html($icon_color).'"';
		else :
			$css_text = $css_icon_color = '';
		endif;

		
        $output = '<div class="mpavc mpavc-date '.esc_html($display).' mpavc-date-'.$instance.mpavc_animate_class($addon_animate,$effect,$delay).' '.$css_text.'>';
			if(!is_rtl()) :
				$output .= '<i class="'.esc_html($date_icon).'" '.$css_icon_color.'></i>'.date_i18n($date_format).'';
			else :
				$output .= date_i18n($date_format).'<i class="rtl '.esc_html($date_icon).'" '.$css_icon_color.'></i>';
			endif;
        $output .= '</div>';

        return $output;
    }	

	
	/*
	 * Addon Backend
	 */	
    function map_vc_addon() {
        if (function_exists("vc_map")) {

            vc_map(array(
                "name" => esc_html__("Date", "mpavc"),
                "base" => "mpavc_date",
                "content_element" => true,
                "show_settings_on_create" => true,
                "category" => esc_html__("MP Addons", "mpavc"),
                'description' => esc_html__('Create date addon', 'mpavc'),
                "icon" => MPAVC_URL . '/assets/img/vc-date.png',
                "params" => array(
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Date Format", 'mpavc'),
						"param_name" => "date_format",
						"value" => mpavc_get_format_date()
					),
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Show Icon", 'mpavc'),
						"param_name" => "icon_show",
						"value" => array(
									esc_html__('On','mpavc') 	=> 'on',
									esc_html__('Off','mpavc') 	=> 'off'																				
						)
					),						
					array(
						"type" => "iconpicker",
						"heading" => esc_html__( "Icon", "mpavc" ),
						"param_name" => "date_icon",
						"settings" => array(
							"emptyIcon" 	=> false,
							"type" 			=> "fontawesome",
							"iconsPerPage" 	=> 200,
						),
						"dependency" => array(
							"element" 	=> "icon_show",
							"value" 	=> array( "on" )
						),						
						"description" => esc_html__( "Select icon from library.", "mpavc" ),
					),
					// STYLE
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Display", 'mpavc'),
						"param_name" => "display",
						"value" => array(
										esc_html__('Inline','mpavc') 	=> 'mpavc-inline-block',
										esc_html__('Block','mpavc') 	=> 'mpavc-block'
										
						),
						"group" => "Style"
					),						
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Style", 'mpavc'),
						"param_name" => "custom_style",
						"value" => array(
										esc_html__('Off','mpavc') 	=> 'off',
										esc_html__('On','mpavc') 	=> 'on'
										
						),
						"group" => "Style"
					),					
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Icon Color", 'mpavc'),
						"param_name" => "icon_color",
						"value" => '#FFFFFF',
						"dependency" => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),					
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Text Color", 'mpavc'),
						"param_name" => "text_color",
						"value" => '#333333',
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),
						"group" => "Style"				  
					),					
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Font size",'mpavc'),
						"param_name" => "font_size",
						"description" => "ex: 10px",					  
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),
						"value" => "10px",
						"group" => "Style"					  
					),					
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Display", 'mpavc'),
						"param_name" => "font_weight",
						"value" => array(
										esc_html__('Normal','mpavc') 	=> 'normal',
										esc_html__('Bold','mpavc') 		=> 'bold',
										esc_html__('100','mpavc') 		=> '100',
										esc_html__('200','mpavc') 		=> '200',
										esc_html__('300','mpavc') 		=> '300',
										esc_html__('400','mpavc') 		=> '400',
										esc_html__('500','mpavc') 		=> '500',
										esc_html__('600','mpavc') 		=> '600',
										esc_html__('700','mpavc') 		=> '700',
										esc_html__('800','mpavc') 		=> '800',
										esc_html__('900','mpavc') 		=> '900'
										
						),
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),						
						"group" => "Style"
					),
					
					// ANIMATION								  							  		  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate", 'mpavc'),
						"param_name" => "addon_animate",
						"value" => array(
										esc_html__('Off','mpavc') 	=> 'off',
										esc_html__('On','mpavc') 	=> 'on'
										
						),
						"group" => "Animation"
					),			  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate Effects", 'mpavc'),
						"param_name" => "effect",
						"value" => mpavc_animation_effect(),
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"group" => "Animation"				   
					),				  
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Animate Delay (ms)",'mpavc'),
						"param_name" => "delay",
						"description" => "ex 1000",					  
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"value" => "0",
						"group" => "Animation"					  
					),
                ),
            ));


        }
    }

} // End Class

if (class_exists('WPBakeryShortCode')) {
    class WPBakeryShortCode_MPAVC_Date extends WPBakeryShortCode {
    }
}

// Initialize Element Class
if (class_exists('MPAVC_Date')) {
    new MPAVC_Date();
}

