<?php
/*
Addon: Gallery
*/

class MPAVC_Gallery {

	/*
	 * Contruct
	 */
    public function __construct() {

        add_action('wp_enqueue_scripts', array($this, 'load_scripts'));

        add_shortcode('mpavc_gallery', array($this, 'shortcode_addon_func'));

        add_action('init', array($this, 'map_vc_addon'));

    }

    function load_scripts() {
		
		wp_enqueue_style( 'bootstrap' );
        wp_enqueue_style( 'mpavc-style' );
        wp_enqueue_style( 'mpavc-gallery' );
		wp_enqueue_style( 'font-awesome' );
		wp_enqueue_style( 'animations' );
		wp_enqueue_script( 'appear' );
		wp_enqueue_script( 'animations' );
		
    }

	/*
	 * Addon View
	 */
    public function shortcode_addon_func($atts, $content = null, $tag) {
		static $instance;
		$instance++;

        extract(shortcode_atts(array(

				'gallery_name' => '',
				'gallery_name_show' => 'false',
				'columns' => '1',
				'type' => 'prettyphoto',
				'size' => 'normal',
				'responsive' => 'responsive',
				'style' => 'style1',
				'over_image' => 'over-image-on',
				'thumbs_one' => 'off',
				'social_share_active' => 'on',
				'pagination_active' => 'off',
				'pagination_number' => '10',
				'pagination_style' => 'pagination_style1',
				'icon_border_radius' => 'off',
				'icon_border_radius_value' => '50%',
				'custom_style' => 'off',
				'bg_color' => '#000000',
				'text_icon_color' => '#FFFFFF',
				'icon_bg_color' => '#FFFFFF',
				'icon_h_color' => '#FFFFFF',
				'icon_bg_h_color' => '#009688',
				'spacing_active' => 'off',
				'spacing' => '5px',
				'gallery_name_font_size' => '20',
				'gallery_name_font_color' => '#FC615D',
				'gallery_name_text_align' => 'center',
				'image_lightbox' => 'fa fa-handshake-o',		
				'images' => '',
				'pp_animation_speed' => 'fast',
				'pp_autoplay' => 'true',
				'pp_time' => '2000',
				'pp_title' => 'true',
				'pp_social' => 'true',
				'pb_thumbs' => 'true',
				'pb_time' => '2000',
				'pb_autoplay' => 'true',				
				'pb_counter' => 'true',
				'pb_history' => 'false',
				'pb_loop' => 'true',
				'caption' => 'off',
				'thumbs_grid' => 'mpavc-normal',
				'thumbs_masonry' => 'mpavc-masonry',
				'thumbs_lightbox' => 'large',
				'lg_mode' => 'slide',
				'lg_speed' => '2000',
				'lg_thumbnail' => 'true',
				'lg_controls' => 'true',
				'custom_url_target' => '_blank', 
				'active_custom_responsive' => 'responsive',
				'smartphone_p_columns' => '1',
				'smartphone_l_columns' => '1',
				'tablet_p_columns' => '1',
				'tablet_l_columns' => '1',
				'desktop_medium_columns' => '1',
				'desktop_small_columns' => '1',
			

			// Animations
			'addon_animate'			=> 'off',
			'effect'				=> 'fade-in',
			'delay'					=> '0',
			

        ), $atts));
		
		$return = $caption_check = $masonry_class = $css_custom_space = $data_value = $js_class = '';
		if($size == 'masonry') :
				wp_enqueue_script( 'masonry' ); 
				$thumbs_size_value = $thumbs_masonry;
				$masonry_class = 'mpavc-gallery-masonry';
		else :		
				$thumbs_size_value = $thumbs_grid;
		endif;

		// Get Gallery Images
		$images = explode( ',', $images );
				
		// Pagination
		if($pagination_active == 'on') {		
			$pagination = get_query_var('mg_page');					
			if(!isset($pagination) || empty($pagination)) { $pagination = 1; }		
			$images_array = array_chunk($images,$pagination_number);										
			$pag = $pagination - 1;			
			$images = $images_array[$pag];
			$num_page_for_pagination = count($images_array);
		} // End Pagination

		// CHECK CUSTOM RESPONSIVE
		if($responsive == 'responsive') :
			if($active_custom_responsive == 'responsive') :
				$responsive = 'mpavc_gallery_responsive';
			else :
				$responsive = 'mpavc_smartphone_p_col-'.esc_html($smartphone_p_columns).' mpavc_smartphone_l_col-'.esc_html($smartphone_l_columns).' mpavc_tablet_p_col-'.esc_html($tablet_p_columns).' mpavc_tablet_l_col-'.esc_html($tablet_l_columns).' mpavc_desktop_medium_col-'.esc_html($desktop_medium_columns).' mpavc_desktop_small_col-'.esc_html($desktop_small_columns).'';				
			endif;
		endif;

		if($custom_style == 'on') :
			$css_style_to_append = '<style>.mpavc-gallery-'.esc_html($instance).' .mpavc-gallery-item:hover .mpavc-gallery-item-content {
					background:'.esc_html($bg_color).';
			}
			.mpavc-gallery-'.esc_html($instance).' .mpavc-gallery-social-share a, 
			.mpavc-gallery-'.esc_html($instance).' .mpavc-gallery-lightbox a {
				color:'.esc_html($text_icon_color).';
				background:'.esc_html($icon_bg_color).';
			}
			.mpavc-gallery-'.esc_html($instance).' .mpavc-gallery-caption-container {
				color:'.esc_html($text_icon_color).';
			}				
			.mpavc-gallery-'.esc_html($instance).' .mpavc-gallery-social-share a:hover, 
			.mpavc-gallery-'.esc_html($instance).' .mpavc-gallery-lightbox a:hover {
				color:'.esc_html($icon_h_color).';
				background:'.esc_html($icon_bg_h_color).';
			}
			.mpavc-gallery-social-share-container-content a i,
			.mpavc-gallery-social-share-container .mpavc-gallery-social-share-popup	{
				color:'.esc_html($text_icon_color).';
			}
			.mpavc-gallery-social-share-container-content a:hover i,
			.mpavc-gallery-social-share-container .mpavc-gallery-social-share-popup:hover {
				color:'.esc_html($icon_h_color).';
			}
			.mpavc_gallery_pagination-'.esc_html($instance).'.mpavc_gallery_pagination-pagination_style1 ul.mpavc_gallery_pagination li a {	
				border: 1px solid '.esc_html($text_icon_color).';
				color: '.esc_html($text_icon_color).';
			}			
			.mpavc_gallery_pagination-'.esc_html($instance).'.mpavc_gallery_pagination-pagination_style1 ul.mpavc_gallery_pagination li.mg_current {
				background:'.esc_html($icon_bg_color).';
				border: 1px solid '.esc_html($text_icon_color).';				
			}
			.mpavc_gallery_pagination-'.esc_html($instance).'.mpavc_gallery_pagination-pagination_style1 ul.mpavc_gallery_pagination li a:hover {
				color: '.esc_html($icon_h_color).';
			}
			.mpavc_gallery_pagination-'.esc_html($instance).'.mpavc_gallery_pagination-pagination_style2 ul.mpavc_gallery_pagination li a {
				color: '.esc_html($text_icon_color).';				
			}
			.mpavc_gallery_pagination-'.esc_html($instance).'.mpavc_gallery_pagination-pagination_style2 ul.mpavc_gallery_pagination li.mg_current {
				color: '.esc_html($icon_h_color).';				
			}
			.mpavc_gallery_pagination-'.esc_html($instance).'.mpavc_gallery_pagination-pagination_style2 ul.mpavc_gallery_pagination li a:hover {
				color: '.esc_html($icon_h_color).';
			}
			</style>';
			$data_value = 'data-mpavc-custom-css="'.$css_style_to_append.'"';
			$js_class = 'mpavc-custom-js';
		endif;
		
		
		// Check Custom Space Between Items
		if($spacing_active == 'on') : $css_custom_space = 'style="padding:'.$spacing.'"'; endif;
		
		if($icon_border_radius == 'on') : $border_radius_style = 'style="border-radius:'.esc_html($icon_border_radius_value).'"'; endif;
		
		/**
		 ** PrettyPhoto
		 **/
		 
		if($type == 'prettyphoto') {
				wp_enqueue_style( 'mpavc-gallery' );
				wp_enqueue_style( 'prettyphoto' );
				wp_enqueue_script( 'prettyphoto');

				$return .= '<div 
					data-mpavc-gallery-pp-speed="'.esc_html($pp_animation_speed).'"
					data-mpavc-gallery-pp-slideshow="'.esc_html($pp_time).'"
					data-mpavc-gallery-pp-autoplay="'.esc_html($pp_autoplay).'"
					data-mpavc-gallery-pp-title="'.esc_html($pp_title).'"
					data-mpavc-gallery-pp-social="'.esc_html($pp_social).'"
					class="mpavc-gallery mpavc-gallery-pp mpavc-gallery-'.esc_html($instance).' '.$js_class.' mpavc-gallery-social-share-'.esc_html($social_share_active).' mpavc-gallery-border-radius-'.esc_html($icon_border_radius).' mpavc-gallery-columns-'.esc_html($columns).' '.esc_html($responsive).' mpavc-gallery-'.esc_html($style).' mpavc-gallery-'.esc_html($over_image).' '.esc_html($masonry_class).'" '.$data_value.'>';
					foreach ( $images as $id ) {
						$caption_div = $caption_check = '';
						$image_thumb = wp_get_attachment_image_src( $id, $thumbs_size_value );
						$image_large = wp_get_attachment_image_src( $id, $thumbs_lightbox );
						$image_info = get_post( $id );
						$title = $image_info->post_title;
						$text_caption = $image_info->post_excerpt;
						if($caption == 'off'  || empty($text_caption) || $text_caption == ' ') : 
							$caption_check = 'mpavc-gallery-no-caption'; 
						else :
							$caption_div = '<div class="mpavc-gallery-caption-container"><span class="mpavc-gallery-caption">'.esc_html($text_caption).'</span></div>';
						endif;
						$return .= '<div class="mpavc-gallery-item'.mpavc_animate_class($addon_animate,$effect,$delay).' '.$css_custom_space.'>';
							$return .= '<img src="'.esc_url($image_thumb[0]).'" alt="">';
							$return .=	'<div class="mpavc-gallery-item-content '.esc_html($caption_check).'"><div class="mpavc-gallery-item-content-container">';
								$return .= $caption_div;
								$return .= '<div class="mpavc-gallery-item-conteiner-link"><div class="mpavc-gallery-lightbox"><a href="'.esc_url($image_large[0]).'" title="'.esc_html($title).'" data-mpavc-rel-pp="prettyPhoto[album-'.esc_html($instance).']" class="mpavc-zoom-icon '.esc_html($image_lightbox).'" '.esc_html($border_radius_style).'></a></div>';
								if($social_share_active == 'on') :
									$return .= '<div class="mpavc-gallery-social-share">
										<a data-mpavc-gallery-share-link="'.esc_url($image_large[0]).'"
										data-mpavc-gallery-share-caption="'.esc_html($text_caption).'"
										class="mpavc-gallery-share-image fa fa-share-alt" '.$border_radius_style.'></a></div>';
								endif;		
							$return .= '</div></div></div>';
						$return .= '</div>';
					}
				$return .= '<div class="mpavc-clear"></div></div>';
		}	

		/**
		 ** Magnific PopUp
		 **/
		 
		if($type == 'magnific-popup') {
				wp_enqueue_style( 'mpavc-gallery' );
				wp_enqueue_style( 'magnific-popup' );
				wp_enqueue_script( 'magnific-popup');

				$return .= '<div class="mpavc-gallery mpavc-gallery-mp mpavc-gallery-'.esc_html($instance).' '.$js_class.' mpavc-gallery-social-share-'.esc_html($social_share_active).' mpavc-gallery-border-radius-'.esc_html($icon_border_radius).' mpavc-gallery-columns-'.esc_html($columns).' '.esc_html($responsive).' mpavc-gallery-'.esc_html($style).' mpavc-gallery-'.esc_html($over_image).' '.esc_html($masonry_class).'" '.$data_value.'>';
					foreach ( $images as $id ) {
						$caption_div = $caption_check = '';
						$image_thumb = wp_get_attachment_image_src( $id, $thumbs_size_value );
						$image_large = wp_get_attachment_image_src( $id, $thumbs_lightbox );
						$image_info = get_post( $id );
						$title = $image_info->post_title;
						$text_caption = $image_info->post_excerpt;
						if($caption == 'off'  || empty($text_caption) || $text_caption == ' ') : 
							$caption_check = 'mpavc-gallery-no-caption'; 
						else :
							$caption_div = '<div class="mpavc-gallery-caption-container"><span class="mpavc-gallery-caption">'.esc_html($text_caption).'</span></div>';
						endif;
						$return .= '<div class="mpavc-gallery-item'.mpavc_animate_class($addon_animate,$effect,$delay).' '.$css_custom_space.'>';
							$return .= '<img src="'.esc_url($image_thumb[0]).'" alt="">';
							$return .=	'<div class="mpavc-gallery-item-content '.esc_html($caption_check).'"><div class="mpavc-gallery-item-content-container">';
								$return .= $caption_div;
								$return .= '<div class="mpavc-gallery-item-conteiner-link"><div class="mpavc-gallery-lightbox"><a href="'.esc_url($image_large[0]).'" title="'.esc_html($title).'" class="mpavc-gallery-magnific-popup mpavc-zoom-icon '.esc_html($image_lightbox).'" '.$border_radius_style.'><img src="'.esc_url($image_thumb[0]).'" alt="" style="display:none"></a></div>';
								if($social_share_active == 'on') :
									$return .= '<div class="mpavc-gallery-social-share">
										<a data-mpavc-gallery-share-link="'.esc_url($image_large[0]).'"
										data-mpavc-gallery-share-caption="'.esc_html($text_caption).'"
										class="mpavc-gallery-share-image fa fa-share-alt" '.$border_radius_style.'></a></div>';
								endif;		
							$return .= '</div></div></div>';
						$return .= '</div>';
					}
				$return .= '<div class="mpavc-clear"></div></div>';
		}

		/**
		 ** Light Gallery
		 **/
		 
		if($type == 'lightgallery') {
				wp_enqueue_style( 'mpavc-gallery' );
				wp_enqueue_style( 'lightgallery' );
				wp_enqueue_script( 'lightgallery');

				$return .= '<div 
					data-mpavc-gallery-lg-mode="'.esc_html($lg_mode).'"
					data-mpavc-gallery-lg-speed="'.esc_html($lg_speed).'"
					data-mpavc-gallery-lg-thumbnail="'.esc_html($lg_thumbnail).'"
					data-mpavc-gallery-lg-controls="'.esc_html($lg_controls).'"				
					class="mpavc-gallery mpavc-gallery-lg mpavc-gallery-'.esc_html($instance).' '.$js_class.' mpavc-gallery-social-share-'.esc_html($social_share_active).' mpavc-gallery-border-radius-'.esc_html($icon_border_radius).' mpavc-gallery-columns-'.esc_html($columns).' '.esc_html($responsive).' mpavc-gallery-'.esc_html($style).' mpavc-gallery-'.esc_html($over_image).' '.esc_html($masonry_class).'" '.$data_value.'>';
					foreach ( $images as $id ) {
						$caption_div = $caption_check = '';
						$image_thumb = wp_get_attachment_image_src( $id, $thumbs_size_value );
						$image_large = wp_get_attachment_image_src( $id, $thumbs_lightbox );
						$image_info = get_post( $id );
						$title = $image_info->post_title;
						$text_caption = $image_info->post_excerpt;
						if($caption == 'off'  || empty($text_caption) || $text_caption == ' ') : 
							$caption_check = 'mpavc-gallery-no-caption'; 
						else :
							$caption_div = '<div class="mpavc-gallery-caption-container"><span class="mpavc-gallery-caption">'.esc_html($text_caption).'</span></div>';
						endif;
						$return .= '<div class="mpavc-gallery-item'.mpavc_animate_class($addon_animate,$effect,$delay).' '.$css_custom_space.'>';
							$return .= '<img src="'.esc_url($image_thumb[0]).'" alt="">';
							$return .=	'<div class="mpavc-gallery-item-content '.esc_html($caption_check).'"><div class="mpavc-gallery-item-content-container">';
								$return .= $caption_div;
								$return .= '<div class="mpavc-gallery-item-conteiner-link"><div class="mpavc-gallery-lightbox"><a data-src="'.esc_url($image_large[0]).'" href="'.esc_url($image_large[0]).'" title="'.esc_html($title).'" class="mpavc-zoom-icon '.esc_html($image_lightbox).'" '.$border_radius_style.'><img src="'.esc_url($image_thumb[0]).'" alt="" style="display:none"></a></div>';
								if($social_share_active == 'on') :
									$return .= '<div class="mpavc-gallery-social-share">
										<a data-mpavc-gallery-share-link="'.esc_url($image_large[0]).'"
										data-mpavc-gallery-share-caption="'.esc_html($text_caption).'"
										class="mpavc-gallery-share-image fa fa-share-alt" '.$border_radius_style.'></a></div>';
								endif;		
							$return .= '</div></div></div>';
						$return .= '</div>';
					}
				$return .= '</div>';
		}

		
		/**
		 ** Only Image
		 **/
		 
		if($type == 'only_image') {
				wp_enqueue_style( 'mpavc-gallery' );

				$return .= '<div class="mpavc-gallery mpavc-gallery-oi mpavc-gallery-'.esc_html($instance).' '.$js_class.' mpavc-gallery-social-share-'.esc_html($social_share_active).' mpavc-gallery-border-radius-'.esc_html($icon_border_radius).' mpavc-gallery-columns-'.esc_html($columns).' '.esc_html($responsive).' mpavc-gallery-'.esc_html($style).' mpavc-gallery-'.esc_html($over_image).' '.esc_html($masonry_class).'" '.$data_value.'>';
					foreach ( $images as $id ) {
						$caption_div = $caption_check = '';
						$image_thumb = wp_get_attachment_image_src( $id, $thumbs_size_value );
						$url = get_post_meta( $id, '_mg_custom_url', true );
						$image_info = get_post( $id );
						$title = $image_info->post_title;
						$text_caption = $image_info->post_excerpt;
						if($caption == 'off'  || empty($text_caption) || $text_caption == ' ') : 
							$caption_check = 'mpavc-gallery-no-caption'; 
						else :
							$caption_div = '<div class="mpavc-gallery-caption-container"><span class="mpavc-gallery-caption">'.esc_html($text_caption).'</span></div>';
						endif;
						$return .= '<div class="mpavc-gallery-item'.mpavc_animate_class($addon_animate,$effect,$delay).' '.$css_custom_space.'>';
							$return .= '<img src="'.esc_url($image_thumb[0]).'" alt="">';
							$return .=	'<div class="mpavc-gallery-item-content '.esc_html($caption_check).'"><div class="mpavc-gallery-item-content-container">';
								$return .= $caption_div;
								if($social_share_active == 'on') :
									$return .= '<div class="mpavc-gallery-social-share">
										<a href="#" data-mpavc-gallery-share-link="'.esc_url($image_large[0]).'"
										data-mpavc-gallery-share-caption="'.esc_html($text_caption).'"
										class="mpavc-gallery-share-image fa fa-share-alt" '.$border_radius_style.'></a></div>';
								endif;		
							$return .= '</div></div>';
						$return .= '</div>';
					}
				$return .= '<div class="mpavc-clear"></div></div>';
		}			
		
		/**
		 ** Custom URL
		 **/
		 
		if($type == 'custom_url') {
				wp_enqueue_style( 'mpavc-gallery' );

				$return .= '<div class="mpavc-gallery mpavc-gallery-cu mpavc-gallery-'.esc_html($instance).' '.esc_html($js_class).' mpavc-gallery-columns-'.esc_html($columns).' mpavc-gallery-border-radius-'.esc_html($icon_border_radius).' '.esc_html($responsive).' mpavc-gallery-'.esc_html($style).' mpavc-gallery-'.esc_html($over_image).' '.esc_html($masonry_class).'" '.$data_value.'>';
					foreach ( $images as $id ) {
						$caption_div = $caption_check = '';
						$image_thumb = wp_get_attachment_image_src( $id, $thumbs_size_value );
						$url = get_post_meta( $id, '_mg_custom_url', true );
						$image_info = get_post( $id );
						$title = $image_info->post_title;
						$text_caption = $image_info->post_excerpt;
						if($caption == 'off'  || empty($text_caption) || $text_caption == ' ') : 
							$caption_check = 'mpavc-gallery-no-caption'; 
						else :
							$caption_div = '<div class="mpavc-gallery-caption-container"><span class="mpavc-gallery-caption">'.esc_html($text_caption).'</span></div>';
						endif;
						$return .= '<div class="mpavc-gallery-item'.mpavc_animate_class($addon_animate,$effect,$delay).' '.$css_custom_space.'>';
							$return .= '<img src="'.esc_url($image_thumb[0]).'" alt="">';
							$return .=	'<div class="mpavc-gallery-item-content '.esc_html($caption_check).'"><div class="mpavc-gallery-item-content-container">';
								$return .= $caption_div;
								$return .= '<div class="mpavc-gallery-item-conteiner-link"><div class="mpavc-gallery-lightbox"><a href="'.esc_url($url).'" title="'.esc_html($title).'" target="'.esc_html($custom_url_target).'" class="mpavc-zoom-icon '.esc_html($image_lightbox).'" '.$border_radius_style.'></a></div>';
								if($social_share_active == 'on') :
									$image_large = wp_get_attachment_image_src( $id, $thumbs_lightbox );
									$return .= '<div class="mpavc-gallery-social-share">
										<a href="#" data-mpavc-gallery-share-link="'.esc_url($image_large[0]).'"
										data-mpavc-gallery-share-caption="'.esc_html($text_caption).'"
										class="mpavc-gallery-share-image fa fa-share-alt" '.$border_radius_style.'></a></div>';
								endif;		
							$return .= '</div></div></div>';
						$return .= '</div>';						
					}
				$return .= '<div class="mpavc-clear"></div></div>';
		}		
		
		
		
		/*
		 * Pagination
		 */
		 
		if($pagination_active == 'on') {		
			$return .= '<div class="mpavc-gallery-pagination mpavc_gallery_pagination-'.esc_html($instance).' mpavc_gallery_pagination-'.esc_html($pagination_style).'">'.mpavc_get_gallery_pagination($num_page_for_pagination,$pagination).'</div>';		
		}		
													
		$return .= '<div class="mpavc-clear"></div>';
		return $return;
    }

	/*
	 * Addon Backend
	 */	
    function map_vc_addon() {
        if (function_exists("vc_map")) {

            vc_map(array(
                "name" => esc_html__("Gallery", "mpavc"),
                "base" => "mpavc_gallery",
                "content_element" => true,
                "show_settings_on_create" => true,
                "category" => esc_html__("MP Addons", "mpavc"),
                'description' => esc_html__('add your images gallery', 'mpavc'),
                "icon" => MPAVC_URL . '/assets/img/vc-gallery.png',
                "params" => array(
					array(
							"type" => "textfield",
							"class" => "",
							"heading" => esc_html__("Gallery Display Name",'mpavc'),
							"param_name" => "name",
							"admin_label" => true,				  				  			  				  
					),
					array(
							"type" => "dropdown",
							"class" => "",
							"heading" => esc_html__("Columns", 'mpavc'),
							"param_name" => "columns",
							"value" => array(
											'1' => '1',
											'2' => '2',
											'3' => '3',
											'4' => '4',
											'5' => '5',
											'6' => '6',
											'7' => '7',
											'8' => '8',
											'9' => '9'
							)
					),
				    array(
							"type" => "dropdown",
							"class" => "",
							"heading" => esc_html__("Type Gallery", 'mpavc'),
							"param_name" => "type",
							"value" => array(
										'PrettyPhoto' => 'prettyphoto',
										'Magnific Popup' => 'magnific-popup',
										'Light Gallery' => 'lightgallery',
										'Custom Url' => 'custom_url',
										'Only Image (no Lightbox)' => 'only_image'
							)
				    ),
				    array(
							"type" => "dropdown",
							"class" => "",
							"heading" => esc_html__("Masonry / Grid", 'mpavc'),
							"param_name" => "size",
							"value" => array(
										'Grid' => 'normal',
										'Masonry' => 'masonry'
							)
					),
					array(
							"type" => "dropdown",
							"class" => "",
							"heading" => esc_html__("Over Image", 'mpavc'),
							"param_name" => "over_image",
							"value" => array(
										'On' => 'over-image-on',
										'Off' => 'over-image-off'
							)
					),			  			  
					array(
							"type" => "dropdown",
							"class" => "",
							"heading" => esc_html__("Show Caption Image", 'mpavc'),
							"param_name" => "caption",
							"value" => array(
										'Off' => 'off',
										'On' => 'on'
							)
					),
					array(
						"type" => "attach_images",
						"class" => "",
						"heading" => esc_html__("Upload Your Images", 'mpavc'),
						"param_name" => "images",
						"description" => esc_html__('If you get image from library (not uploaded) we reccomended you to regenerate your thumbs','mpavc'),
					),				
					
					// ADVANCED SETTINGS
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Social Share", 'mpavc'),
						"param_name" => "social_share_active",
						"value" => array(
										'On'  => 'on',
										'Off' => 'off'
										
						),
						"group" => "Advanced",
					),					
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Pagination", 'mpavc'),
						"param_name" => "pagination_active",
						"value" => array(
										'Off' => 'off',
										'On'  => 'on'
						),
						"group" => "Advanced",
					),
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Number of images for each page",'mpavc'),
						"param_name" => "pagination_number",
						"value" => "10",
						"description" => esc_html__("For example: 15 (Default value is 10)",'mpavc'),
						'dependency' => array(
							'element' => 'pagination_active',
							'value' => array( 'on' )
						),
						"group" => "Advanced",
					),
					
			  /* PRETTYPHOTO */
              array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => esc_html__("Animation Speed", 'vcfg'),
                  "param_name" => "pp_animation_speed",
                  "value" => array(
									'Fast' 	 => 'fast',
									'Normal' => 'normal',
									'Slow' 	 => 'slow'																		
				   ),
				  'dependency' => array(
						'element' => 'type',
						'value' => array( 'prettyphoto' )
				  ),
				  "group" => "Prettyphoto Options",				   
              ),
              array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => esc_html__("Autoplay", 'vcfg'),
                  "param_name" => "pp_autoplay",
                  "value" => array(
									'On' => 'true',
									'Off' => 'false'																		
				   ),
				  'dependency' => array(
						'element' => 'type',
						'value' => array( 'prettyphoto' )
				  ),
				  "group" => "Prettyphoto Options",				   
              ),		  
			  array(
				  "type" => "textfield",
				  "class" => "",
				  "heading" => esc_html__("Autoplay Time",'vcfg'),
				  "param_name" => "pp_time",
				  "value" => "2000",
				  "description" => esc_html__("time in ms (1000 = 1sec). Example: 2000",'vcfg'),
				  'dependency' => array(
						'element' => 'type',
						'value' => array( 'prettyphoto' )
				  ),
				  "group" => "Prettyphoto Options",
			  ),
              array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => esc_html__("Show Title", 'vcfg'),
                  "param_name" => "pp_title",
                  "value" => array(
									'On' => 'true',
									'Off' => 'false'																		
				   ),
				  'dependency' => array(
						'element' => 'type',
						'value' => array( 'prettyphoto' )
				  ),
				  "group" => "Prettyphoto Options",				   
              ),
              array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => esc_html__("Show Social", 'vcfg'),
                  "param_name" => "pp_social",
                  "value" => array(
									'On' => 'true',
									'Off' => 'false'																		
				   ),
				  'dependency' => array(
						'element' => 'type',
						'value' => array( 'prettyphoto' )
				  ),
				  "group" => "Prettyphoto Options",				   
              ),
			  			  
			  /* LIGHT GALLERY */
              array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => esc_html__("Mode", 'vcfg'),
                  "param_name" => "lg_mode",
                  "value" => array(
									'Slide' => 'slide',
									'Fade' => 'fade'																		
				   ),
				  'dependency' => array(
						'element' => 'type',
						'value' => array( 'lightgallery' )
				  ),
				  "group" => "Light Gallery",				   
              ),
			  array(
				  "type" => "textfield",
				  "class" => "",
				  "heading" => esc_html__("Speed",'vcfg'),
				  "param_name" => "lg_speed",
				  "value" => "2000",
				  "description" => esc_html__("time in ms (1000 = 1sec). Example: 2000",'vcfg'),
				  'dependency' => array(
						'element' => 'type',
						'value' => array( 'lightgallery' )
				  ),
				  "group" => "Light Gallery",
			  ),			  			  			  
              array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => esc_html__("Thumbnail", 'vcfg'),
                  "param_name" => "lg_thumbnail",
                  "value" => array(
									'On' => 'true',
									'Off' => 'false'																		
				   ),
				  'dependency' => array(
						'element' => 'type',
						'value' => array( 'lightgallery' )
				  ),
				  "group" => "Light Gallery",				   
              ),
              array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => esc_html__("Controls", 'vcfg'),
                  "param_name" => "lg_controls",
                  "value" => array(
									'On' => 'true',
									'Off' => 'false'																		
				   ),
				  'dependency' => array(
						'element' => 'type',
						'value' => array( 'lightgallery' )
				  ),
				  "group" => "Light Gallery",				   
              ),		  

			  /* CUSTOM URL */
              array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => esc_html__("Target", 'vcfg'),
                  "param_name" => "custom_url_target",
                  "value" => array(
									'Blank (New Window)' => '_blank',
									'Self (Same Widow)'	 => '_self'																		
				   ),
				  'dependency' => array(
						'element' => 'type',
						'value' => array( 'custom_url' )
				  ),
				  "group" => "Custom Url",				   
              ),
			  
			  // THUMBNAILS CONTROLS
              array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => esc_html__("Grid Thumbnails Size", 'vcfg'),
                  "param_name" => "thumbs_grid",
                  "value" => array(
									'Default (800px)' => 'mpavc-normal',
									'Thumbnail' => 'thumbnail',
									'Medium' => 'medium',
									'Large' => 'large',
									'Full' => 'full'
				   ),
				  'dependency' => array(
						'element' => 'size',
						'value' => array( 'normal' )
				  ),
				  "group" => "Thumbnails",
              )	,			  
              array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => esc_html__("Masonry Thumbnails Size", 'vcfg'),
                  "param_name" => "thumbs_masonry",
                  "value" => array(
									'Default (500px)' => 'mpavc-masonry',
									'Thumbnail' => 'thumbnail',
									'Medium' => 'medium',
									'Large' => 'large',
									'Full' => 'full'
				   ),
				  'dependency' => array(
						'element' => 'size',
						'value' => array( 'masonry' )
				  ),
				  "group" => "Thumbnails",
              )	,
              array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => esc_html__("Lightbox Thumbs", 'vcfg'),
                  "param_name" => "thumbs_lightbox",
                  "value" => array(	
				  					'Large (Default)'  => 'large',
									'Full' 	 => 'full',									
									'Medium' => 'medium',									
									'Thumbnail'  => 'thumbnail',
				   ),
				  "group" => "Thumbnails",
              )	,
			  
			  /* MOBILE COLUMNS */
              array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => esc_html__("Active Custom Responsive", 'vcfg'),
                  "param_name" => "active_custom_responsive",
                  "value" => array(
									'Defatul Value' => 'responsive',
									'Active Custom Responsive' => 'active_custom_responsive',
				  ),
				  'dependency' => array(
						'element' => 'responsive',
						'value' => array( 'responsive' )
				  ),				   
				  "group" => "Responsive",
              ),			  
              array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => esc_html__("Smartphone Portrait", 'vcfg'),
                  "param_name" => "smartphone_p_columns",
                  "value" => array(
									'1' => '1',
									'2' => '2',
									'3' => '3',
									'4' => '4',
									'5' => '5',
									'6' => '6',
									'7' => '7',
									'8' => '8',
									'9' => '9'
				  ),
				  'dependency' => array(
						'element' => 'responsive',
						'value' => array( 'responsive' )
				  ),				   
				  "group" => "Responsive",
              ),
              array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => esc_html__("Smartphone Landscape", 'vcfg'),
                  "param_name" => "smartphone_l_columns",
                  "value" => array(
									'1' => '1',
									'2' => '2',
									'3' => '3',
									'4' => '4',
									'5' => '5',
									'6' => '6',
									'7' => '7',
									'8' => '8',
									'9' => '9'
				  ),
				  'dependency' => array(
						'element' => 'responsive',
						'value' => array( 'responsive' )
				  ),				   
				  "group" => "Responsive",
              ),
              array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => esc_html__("Tablet Portrait", 'vcfg'),
                  "param_name" => "tablet_p_columns",
                  "value" => array(
									'1' => '1',
									'2' => '2',
									'3' => '3',
									'4' => '4',
									'5' => '5',
									'6' => '6',
									'7' => '7',
									'8' => '8',
									'9' => '9'
				  ),
				  'dependency' => array(
						'element' => 'responsive',
						'value' => array( 'responsive' )
				  ),				   
				  "group" => "Responsive",
              ),			  	
              array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => esc_html__("Tablet Landscape", 'vcfg'),
                  "param_name" => "tablet_l_columns",
                  "value" => array(
									'1' => '1',
									'2' => '2',
									'3' => '3',
									'4' => '4',
									'5' => '5',
									'6' => '6',
									'7' => '7',
									'8' => '8',
									'9' => '9'
				  ),
				  'dependency' => array(
						'element' => 'responsive',
						'value' => array( 'responsive' )
				  ),				   
				  "group" => "Responsive",
              ),
              array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => esc_html__("Desktop (min value 640px - max value 1024px)", 'vcfg'),
                  "param_name" => "desktop_medium_columns",
                  "value" => array(
									'1' => '1',
									'2' => '2',
									'3' => '3',
									'4' => '4',
									'5' => '5',
									'6' => '6',
									'7' => '7',
									'8' => '8',
									'9' => '9'
				  ),
				  'dependency' => array(
						'element' => 'responsive',
						'value' => array( 'responsive' )
				  ),				   
				  "group" => "Responsive",
              ),
              array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => esc_html__("Desktop (max 639px)", 'vcfg'),
                  "param_name" => "desktop_small_columns",
                  "value" => array(
									'1' => '1',
									'2' => '2',
									'3' => '3',
									'4' => '4',
									'5' => '5',
									'6' => '6',
									'7' => '7',
									'8' => '8',
									'9' => '9'
				  ),
				  'dependency' => array(
						'element' => 'responsive',
						'value' => array( 'responsive' )
				  ),				   
				  "group" => "Responsive",
              ),		  
					// STYLE 
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Style", 'mpavc'),
						"param_name" => "style",
						"value" => array(
										'Style 1' => 'style1',
										'Style 2' => 'style2',
										'Style 3' => 'style3',
										'Style 4' => 'style4',
										'No Style' => 'no_style',																		
						),
						"group" => "Style",
					),
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Icon Border Radius", 'mpavc'),
						"param_name" => "icon_border_radius",
						"value" => array(
										'Off (Icon Square)' => 'off',
										'On' => 'on',																		
						),
						"group" => "Style",
					),
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Border Radius",'mpavc'),
						"param_name" => "icon_border_radius_value",
						"description" => "ex 50% or 50px",					  
						"dependency" => array(
							"element" => "icon_border_radius",
							"value" => array( "on" )
						),
						"value" => "50%",
						"group" => "Style"					  
					),					
					array(
						"type" => "iconpicker",
						"heading" => esc_html__( "Image Lightbox", "mpavc" ),
						"param_name" => "image_lightbox",
						"settings" => array(
							"emptyIcon" 	=> false,
							"type" 			=> "fontawesome",
							"iconsPerPage" 	=> 200,
						),						
						"description" => esc_html__( "Select lightbox icon from library.", "mpavc" ),
						"group" => "Style",
					),
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Custom Style", 'mpavc'),
						"param_name" => "custom_style",
						"value" => array(
										'Off' => 'off',
										'On' => 'on'																	
					   ),
					   "group" => "Style",			   				   
					),					
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Background Color", 'mpavc'),
						"param_name" => "bg_color",
						"value" => '#000000',
						"group" => "Style",
						'dependency' => array(
							'element' => 'custom_style',
							'value' => array( 'on' )
						),							
					),	  
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Text/Icon Color", 'mpavc'),
						"param_name" => "text_icon_color",
						"value" => '#FFFFFF',
						"group" => "Style",
						'dependency' => array(
							'element' => 'custom_style',
							'value' => array( 'on' )
						),							
					),
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Background Icon", 'mpavc'),
						"param_name" => "icon_bg_color",
						"value" => '#FFFFFF',
						"group" => "Style",
						'dependency' => array(
							'element' => 'custom_style',
							'value' => array( 'on' )
						),							
					),
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Over Icon", 'mpavc'),
						"param_name" => "icon_h_color",
						"value" => '#FFFFFF',
						"group" => "Style",
						'dependency' => array(
							'element' => 'custom_style',
							'value' => array( 'on' )
						),							
					),	
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Background Over Icon", 'mpavc'),
						"param_name" => "icon_bg_h_color",
						"value" => '#009688',
						"group" => "Style",
						'dependency' => array(
							'element' => 'custom_style',
							'value' => array( 'on' )
						),							
					),						
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Custom spacing between the photos", 'mpavc'),
						"param_name" => "spacing_active",
						"value" => array(
										'Off' => 'off',
										'On' => 'on'																	
					   ),
					   "group" => "Style",					   
					),
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("spacing between the photos",'mpavc'),
						"param_name" => "spacing",
						"value" => "5px",
						"description" => esc_html__("Enter pixel value (examples: 20px)",'mpavc'),
						'dependency' => array(
							'element' => 'spacing_active',
							'value' => array( 'on' )
						),
						"group" => "Style",
					),				
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Pagination Style", 'mpavc'),
						"param_name" => "pagination_style",
						"value" => array(
										'Style 1'  => 'pagination_style1',
										'Style 2'  => 'pagination_style2'
						),
						'dependency' => array(
							'element' => 'pagination_active',
							'value' => array( 'on' )
						),	
						"group" => "Style",			   
					),				  			  						
					// ANIMATION								  							  		  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate", 'mpavc'),
						"param_name" => "addon_animate",
						"value" => array(
										esc_html__('Off','mpavc') 	=> 'off',
										esc_html__('On','mpavc') 	=> 'on'
										
						),
						"dependency" => array(
							"element" => "pagination",
							"value" => array( "no", "yes" )
						),						
						"group" => "Animation"
					),			  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate Effects", 'mpavc'),
						"param_name" => "effect",
						"value" => mpavc_animation_effect(),
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"group" => "Animation"				   
					),				  
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Animate Delay (ms)",'mpavc'),
						"param_name" => "delay",
						"description" => "ex 1000",					  
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"value" => "0",
						"group" => "Animation"					  
					),
                ),
            ));


        }
    }


} // End Class

if (class_exists('WPBakeryShortCode')) {
    class WPBakeryShortCode_MPAVC_Gallery extends WPBakeryShortCode {
    }
}

// Initialize Element Class
if (class_exists('MPAVC_Gallery')) {
    new MPAVC_Gallery();
}



/*
 * Gallery Media Fields
 */
 
$attchments_mpavc_gallery_vc_options = array(    
    'mg_custom_url' => array(
        'label'       => esc_html__('Image Url', 'mpavc'),
        'input'       => 'text',
        'application' => 'image',
        'exclusions'  => array('audio', 'video'),
        'required'    => false
    ),
    'hidden_thumb' => array(
        'label'       => esc_html__('Show Thumb', 'mpavc'),
        'input'       => 'select',
        'application' => 'image',
        'exclusions'  => array('audio', 'video'),
        'required'    => false,
		'options' 	  => array(
			'mpavc_gallery_thumb_visible' => esc_html__( 'Visible', 'mpavc' ),
			'mpavc_gallery_thumb_hidden' => esc_html__( 'Hidden', 'mpavc' )
		),
	)
);

 
class MPAVC_Gallery_VC_Custom_Medias_Fields {
 
    private $media_fields = array();
 
    function __construct($fields)
    {
        $this->media_fields = $fields;
     
        add_filter( 'attachment_fields_to_edit', array( $this, 'applyFilter' ), 11, 2 );
        add_filter( 'attachment_fields_to_save', array( $this, 'saveFields' ), 11, 2 );
    }
 
    public function applyFilter($form_fields, $post = null)
    {
        // If our fields array is not empty
        if(!empty($this->media_fields))
        {
            // We browse our set of options
            foreach ($this->media_fields as $field => $values)
            {
                // If the field matches the current attachment mime type
                // and is not one of the exclusions
                if(preg_match("/".$values['application']."/", $post->post_mime_type)  && !in_array($post->post_mime_type, $values['exclusions']))
                {
                    // We get the already saved field meta value
                    $meta = get_post_meta( $post->ID, "_" . $field, true );
     
                    // Define the input type to "text" by default
                    switch ($values['input'])
                    {
                        default:
                        case 'text':
                            $values['input'] = "text";
                            break;
                     
                        case 'textarea':
                            $values['input'] = "textarea";
                            break;
                     
                        case 'select':
                     
                            // Select type doesn't exist, so we will create the html manually
                            // For this, we have to set the input type to "html"
                            $values['input'] = "html";
                     
                            // Create the select element with the right name (matches the one that wordpress creates for custom fields)
                            $html = "<select name='attachments[".$post->ID."][".$field."]'>";
                     
                            // If options array is passed
                            if(isset($values['options']))
                            {
                                // Browse and add the options
                                foreach ($values['options'] as $k => $v)
                                {
                                    // Set the option selected or not
                                    if($meta == $k)
                                        $selected = " selected='selected'";
                                    else
                                        $selected = "";
                     
                                    $html .= "<option$selected value='".$k."'>".$v."</option>";
                                }
                            }
                     
                            $html .= "</select>";
                     
                            // Set the html content
                            $values['html'] = $html;
                     
                            break;
                     
                        case 'checkbox':
                     
                            // Checkbox type doesn't exist either
                            $values['input'] = "html";
                     
                            // Set the checkbox checked or not
                            if($meta == "on")
                                $checked = " checked='checked'";
                            else
                                $checked = "";
                     
                            $html = "<input$checked type='checkbox' name='attachments[".$post->ID."][".$field."]' id='attachments-".$post->ID."-".$field."' />";
                     
                            $values['html'] = $html;
                     
                            break;
                     
                        case 'radio':
                     
                            // radio type doesn't exist either
                            $values['input'] = "html";
                     
                            $html = "";
                     
                            if(!empty($values['options']))
                            {
                                $i = 0;
                     
                                foreach ($values['options'] as $k => $v)
                                {
                                    if($meta == $k)
                                        $checked = " checked='checked'";
                                    else
                                        $checked = "";
                     
                                    $html .= "<input$checked value='" . $k . "' type='radio' name='attachments[".$post->ID."][".$field."]' id='".sanitize_key( $field . "_" . $post->ID . "_" . $i )."' /> <label for='".sanitize_key( $field . "_" . $post->ID . "_" . $i )."'>" . $v . "</label><br />";
                                    $i++;
                                }
                            }
                     
                            $values['html'] = $html;
                     
                            break;
                    }
     
                    // And set it to the field before building it
                    $values['value'] = $meta;
     
                    // We add our field into the $form_fields array
                    $form_fields[$field] = $values;
                }
            }
        }
     
        // We return the completed $form_fields array
        return $form_fields;
    }  
 
    function saveFields( $post, $attachment )
    {
        // If our fields array is not empty
        if(!empty($this->media_fields))
        {
            // Browser those fields
            foreach ($this->media_fields as $field => $values)
            {
                // If this field has been submitted (is present in the $attachment variable)
                if(isset($attachment[$field]))
                {
                    // If submitted field is empty
                    // We add errors to the post object with the "error_text" parameter we set in the options
                    if(strlen(trim($attachment[$field])) == 0)
                        $post['errors'][$field]['errors'][] = '';
                    // Otherwise we update the custom field
                    else
                        update_post_meta( $post['ID'], "_" . $field, $attachment[$field] );
                }
                // Otherwise, we delete it if it already existed
                else
                {
                    delete_post_meta( $post['ID'], $field );
                }
            }
        }
     
        return $post;
    }
 
}
 
$mpavc_gallery_cmf = new MPAVC_Gallery_VC_Custom_Medias_Fields($attchments_mpavc_gallery_vc_options);