<?php

/*
Addon: Heading
*/

class MPAVC_Heading {

	/*
	 * Contruct
	 */
    public function __construct() {

        add_action('wp_enqueue_scripts', array($this, 'load_scripts'));

        add_shortcode('mpavc_heading', array($this, 'shortcode_addon_func'));

        add_action('init', array($this, 'map_vc_addon'));

    }

    function load_scripts() {
		
		wp_enqueue_style( 'bootstrap' );
        wp_enqueue_style( 'mpavc-style' );
		wp_enqueue_style( 'font-awesome' );
		wp_enqueue_style( 'animations' );
		wp_enqueue_script( 'appear' );
		wp_enqueue_script( 'animations' );
		
    }
	
	/*
	 * Addon View
	 */
    public function shortcode_addon_func($atts, $content = null, $tag) {
		static $instance;
		$instance++;
		
        $date = '';

        extract(shortcode_atts(array(

            'text' 						=> '',
			'display'					=> 'mpavc-inline-block',
			'custom_style'				=> 'off',
            'color' 					=> '#FFFFFF',
            'font_size' 				=> '30px',
            'font_weight' 				=> 'normal',
			'padding'					=> '10px',
			'margin'					=> '10px',
			'letter_spacing'			=> '1px',
			'background_color'			=> 'off',
			'select_background_color' 	=> '#000000',			
			'google_font_family'		=> 'off',
			'google_fonts'				=> '',
			'addon_animate'				=> 'off',
			'effect'					=> 'fade-in',
			'delay'						=> '0',
			

        ), $atts));

		$css_inline = 'style="';
		
			// Google Fonts
			if($google_font_family == 'on') :
			 
				// Build the data array
				$text_font_data = $this->mpavc_getFontsData( $google_fonts );
			 
				// Build the inline style
				$css_inline .= $this->mpavc_googleFontsStyles( $text_font_data );   
					 
				// Enqueue the right font   
				$this->mpavc_enqueueGoogleFonts( $text_font_data );
				$font_weight = '';
				
			endif;
		
			// Custom Style
			if($custom_style == 'on') :
				$css_inline .= 'color:'.esc_html($color).';font-size:'.esc_html($font_size).';font-weight:'.esc_html($font_weight).';padding:'.esc_html($padding).';margin:'.esc_html($margin).';letter-spacing:'.esc_html($letter_spacing).';';
				if($background_color == 'on') :
					$css_inline .= 'background:'.esc_html($select_background_color).';';
				endif;
			endif;
		
		$css_inline .= '"';
		
		
        $output = '<span class="mpavc mpavc-heading '.esc_html($display).' mpavc-heading-'.esc_html($instance).mpavc_animate_class($addon_animate,$effect,$delay).' '.$css_inline.'>'.esc_html($text).'</span>';

        return $output;
    }	

	/*
	 * Google Fonts Help
	 */	
     
    // Build the string of values in an Array
    protected function mpavc_getFontsData( $fontsString ) {   
     
        // Font data Extraction
        $googleFontsParam = new Vc_Google_Fonts();      
        $fieldSettings = array();
        $fontsData = strlen( $fontsString ) > 0 ? $googleFontsParam->_vc_google_fonts_parse_attributes( $fieldSettings, $fontsString ) : '';
        return $fontsData;
         
    }
     
    // Build the inline style starting from the data
    protected function mpavc_googleFontsStyles( $fontsData ) {
         
        // Inline styles
        $fontFamily = explode( ':', $fontsData['values']['font_family'] );
        $styles[] = 'font-family:' . $fontFamily[0];
        $fontStyles = explode( ':', $fontsData['values']['font_style'] );
        $styles[] = 'font-weight:' . $fontStyles[1];
        $styles[] = 'font-style:' . $fontStyles[2];
         
        $inline_style = '';     
        foreach( $styles as $attribute ){           
            $inline_style .= $attribute.'; ';       
        }   
         
        return $inline_style;
         
    }
     
    // Enqueue right google font from Googleapis
    protected function mpavc_enqueueGoogleFonts( $fontsData ) {
         
        // Get extra subsets for settings (latin/cyrillic/etc)
        $settings = get_option( 'wpb_js_google_fonts_subsets' );
        if ( is_array( $settings ) && ! empty( $settings ) ) {
            $subsets = '&subset=' . implode( ',', $settings );
        } else {
            $subsets = '';
        }
         
        // We also need to enqueue font from googleapis
        if ( isset( $fontsData['values']['font_family'] ) ) {
            wp_enqueue_style( 
                'vc_google_fonts_' . vc_build_safe_css_class( $fontsData['values']['font_family'] ), 
                '//fonts.googleapis.com/css?family=' . $fontsData['values']['font_family'] . $subsets
            );
        }
         
    }	
		
	/*
	 * Addon Backend
	 */	
    function map_vc_addon() {
        if (function_exists("vc_map")) {

            vc_map(array(
                "name" => esc_html__("Heading", "mpavc"),
                "base" => "mpavc_heading",
                "content_element" => true,
                "show_settings_on_create" => true,
                "category" => esc_html__("MP Addons", "mpavc"),
                'description' => esc_html__('Add your Heading', 'mpavc'),
                "icon" => MPAVC_URL . '/assets/img/vc-heading.png',
                "params" => array(
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Text Heading",'mpavc'),
						"param_name" => "text",	
					),
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Display", 'mpavc'),
						"param_name" => "display",
						"value" => array(
										esc_html__('Inline','mpavc') 	=> 'mpavc-inline-block',
										esc_html__('Block','mpavc') 	=> 'mpavc-block'
										
						),
					),						
										
					// STYLE					
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Style", 'mpavc'),
						"param_name" => "custom_style",
						"value" => array(
										esc_html__('Off','mpavc') 	=> 'off',
										esc_html__('On','mpavc') 	=> 'on'
										
						),
						"group" => "Style"
					),					
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Color", 'mpavc'),
						"param_name" => "color",
						"value" => '#FFFFFF',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),			
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Font size",'mpavc'),
						"param_name" => "font_size",
						"description" => "ex: 30px",					  
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),
						"value" => "30px",
						"group" => "Style"					  
					),					
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Font Weight", 'mpavc'),
						"param_name" => "font_weight",
						"value" => array(
										esc_html__('Normal','mpavc') 	=> 'normal',
										esc_html__('Bold','mpavc') 		=> 'bold',
										esc_html__('100','mpavc') 		=> '100',
										esc_html__('200','mpavc') 		=> '200',
										esc_html__('300','mpavc') 		=> '300',
										esc_html__('400','mpavc') 		=> '400',
										esc_html__('500','mpavc') 		=> '500',
										esc_html__('600','mpavc') 		=> '600',
										esc_html__('700','mpavc') 		=> '700',
										esc_html__('800','mpavc') 		=> '800',
										esc_html__('900','mpavc') 		=> '900'
										
						),
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),						
						"group" => "Style"
					),
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Letter Spacing",'mpavc'),
						"param_name" => "letter_spacing",
						"description" => "ex: 1px",					  
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),
						"value" => "1px",
						"group" => "Style"					  
					),					
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Padding",'mpavc'),
						"param_name" => "padding",
						"description" => "ex: 10px",					  
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),
						"value" => "10px",
						"group" => "Style"					  
					),
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Margin",'mpavc'),
						"param_name" => "margin",
						"description" => "ex: 10px",					  
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),
						"value" => "10px",
						"group" => "Style"					  
					),					
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Background Color", 'mpavc'),
						"param_name" => "background_color",
						"value" => array(
										esc_html__('Off','mpavc') 	=> 'off',
										esc_html__('On','mpavc') 	=> 'on'
										
						),
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),						
						"group" => "Style"
					),
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Select Background Color", 'mpavc'),
						"param_name" => "select_background_color",
						"value" => '#000000',
						'dependency' => array(
								'element' => 'background_color',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),
					
					// Font Family
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Use Google Font?", 'mpavc'),
						"param_name" => "google_font_family",
						"value" => array(
										esc_html__('No','mpavc') 	=> 'off',
										esc_html__('Yes','mpavc') 	=> 'on'
										
						),						
						"group" => "Font Family"
					),					
					array(
						'type' => 'google_fonts',
						'param_name' => 'google_fonts',
						'value' => 'font_family:Abril%20Fatface%3Aregular|font_style:400%20regular%3A400%3Anormal',
						'settings' => array(
							'fields' => array(
								'font_family_description' => esc_html__( 'Select font family.', 'js_composer' ),
								'font_style_description' => esc_html__( 'Select font styling.', 'js_composer' ),
							),
						),
						'dependency' => array(
								'element' => 'google_font_family',
								'value' => array( 'on' )
						),
						"group" => "Font Family"						
					),
					
					// ANIMATION								  							  		  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate", 'mpavc'),
						"param_name" => "addon_animate",
						"value" => array(
										esc_html__('Off','mpavc') 	=> 'off',
										esc_html__('On','mpavc') 	=> 'on'
										
						),
						"group" => "Animation"
					),			  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate Effects", 'mpavc'),
						"param_name" => "effect",
						"value" => mpavc_animation_effect(),
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"group" => "Animation"				   
					),				  
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Animate Delay (ms)",'mpavc'),
						"param_name" => "delay",
						"description" => "ex 1000",					  
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"value" => "0",
						"group" => "Animation"					  
					),
                ),
            ));


        }
    }

} // End Class

if (class_exists('WPBakeryShortCode')) {
    class WPBakeryShortCode_MPAVC_Heading extends WPBakeryShortCode {
    }
}

// Initialize Element Class
if (class_exists('MPAVC_Heading')) {
    new MPAVC_Heading();
}

