<?php

/*
Addon: Icon
*/

class MPAVC_Icon {

	/*
	 * Contruct
	 */
    public function __construct() {

        add_action('wp_enqueue_scripts', array($this, 'load_scripts'));

        add_shortcode('mpavc_icon', array($this, 'shortcode_addon_func'));

        add_action('init', array($this, 'map_vc_addon'));

    }

    function load_scripts() {
		
		wp_enqueue_style( 'bootstrap' );
        wp_enqueue_style( 'mpavc-style' );
		wp_enqueue_style( 'font-awesome' );
		wp_enqueue_style( 'animations' );
		wp_enqueue_script( 'appear' );
		wp_enqueue_script( 'animations' );
		
    }
	
	/*
	 * Addon View
	 */
    public function shortcode_addon_func($atts, $content = null, $tag) {
		static $instance;
		$instance++;
		
        $date = '';

        extract(shortcode_atts(array(

            'icon' 						=> 'fa fa-instagram',
			'line'						=> 'off',
			'display'					=> 'mpavc-inline-block',			
			'custom_style'				=> 'off',
            'color' 					=> '#FFFFFF',
            'font_size' 				=> '30px',
            'icon_line_height' 			=> '16px',
			'padding'					=> '10px',
			'margin'					=> '10px',
			'background_options'		=> 'off',
			'select_background_color' 	=> '#000000',
			'border_radius' 			=> '',
			'line_type'					=> 'solid',
			'line_color'				=> '#000000',
			'line_height'				=> '2px',
			'line_width'				=> '10px',
			'addon_animate'				=> 'off',
			'effect'					=> 'fade-in',
			'delay'						=> '0',
			

        ), $atts));

		$css_inline = 'style="';
		
		// Custom Style
		if($custom_style == 'on') :
			$css_inline .= 'color:'.esc_html($color).';font-size:'.esc_html($font_size).';line-height:'.esc_html($icon_line_height).';padding:'.esc_html($padding).';margin:'.esc_html($margin).';';
			if($background_options == 'on') :
				$css_inline .= 'background:'.esc_html($select_background_color).';border-radius:'.esc_html($border_radius).';';
			endif;
		endif;
		
		$css_inline .= '"';
		
		if($line == 'on') :
		
			$line_class = 'mpavc-icon-line';
			$line_code = '<span class="mpavc-icon-line" style="
				border-top-color:'.esc_html($line_color).';
				border-top-width:'.esc_html($line_height).';
				border-top-style:'.esc_html($line_type).';
				width:'.esc_html($line_width).';
			"></span>';
		
		else :
			
			$line_code = $line_class = '';
		
		endif;
		
		
		
        $output = '<div class="mpavc mpavc-icon '.esc_html($display).' '.$line_class.' mpavc-icon-'.$instance.mpavc_animate_class($addon_animate,$effect,$delay).'>';
			$output .= $line_code;
			$output .= '<i class="'.esc_html($icon).'" '.$css_inline.'></i>';
			$output .= $line_code;
		$output .= '</div>';

        return $output;
    }
		
	/*
	 * Addon Backend
	 */	
    function map_vc_addon() {
        if (function_exists("vc_map")) {

            vc_map(array(
                "name" => esc_html__("Icon", "mpavc"),
                "base" => "mpavc_icon",
                "content_element" => true,
                "show_settings_on_create" => true,
                "category" => esc_html__("MP Addons", "mpavc"),
                'description' => esc_html__('Add your Heading', 'mpavc'),
                "icon" => MPAVC_URL . '/assets/img/vc-icon.png',
                "params" => array(
					array(
						"type" => "iconpicker",
						"heading" => esc_html__( "Icon", "mpavc" ),
						"param_name" => "icon",
						"settings" => array(
							"emptyIcon" 	=> false,
							"type" 			=> "fontawesome",
							"iconsPerPage" 	=> 200,
						),						
						"description" => esc_html__( "Select icon from library.", "mpavc" ),
					),
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Line", 'mpavc'),
						"param_name" => "line",
						"value" => array(
										esc_html__('Off','mpavc') 	=> 'off',
										esc_html__('On','mpavc') 	=> 'on'
										
						),
					),					
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Display", 'mpavc'),
						"param_name" => "display",
						"value" => array(
										esc_html__('Inline','mpavc') 	=> 'mpavc-inline-block',
										esc_html__('Block','mpavc') 	=> 'mpavc-block'
										
						),
					),						
										
					// STYLE					
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Style", 'mpavc'),
						"param_name" => "custom_style",
						"value" => array(
										esc_html__('Off','mpavc') 	=> 'off',
										esc_html__('On','mpavc') 	=> 'on'
										
						),
						"group" => "Style"
					),					
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Color", 'mpavc'),
						"param_name" => "color",
						"value" => '#FFFFFF',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),			
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Size",'mpavc'),
						"param_name" => "font_size",
						"description" => "ex: 30px",					  
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),
						"value" => "30px",
						"group" => "Style"					  
					),					
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Line Height",'mpavc'),
						"param_name" => "icon_line_height",
						"description" => "ex: 16px",					  
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),
						"value" => "16px",
						"group" => "Style"					  
					),				
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Padding",'mpavc'),
						"param_name" => "padding",
						"description" => "ex: 10px",					  
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),
						"value" => "10px",
						"group" => "Style"					  
					),
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Margin",'mpavc'),
						"param_name" => "margin",
						"description" => "ex: 10px",					  
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),
						"value" => "10px",
						"group" => "Style"					  
					),					
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Background Color", 'mpavc'),
						"param_name" => "background_options",
						"value" => array(
										esc_html__('Off','mpavc') 	=> 'off',
										esc_html__('On','mpavc') 	=> 'on'
										
						),
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),						
						"group" => "Style"
					),
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Select Background Color", 'mpavc'),
						"param_name" => "select_background_color",
						"value" => '#000000',
						'dependency' => array(
								'element' => 'background_options',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Border Radius",'mpavc'),
						"param_name" => "border_radius",
						"description" => "ex: 10px or leave empty to border square",					  
						"dependency" => array(
								"element" => "background_options",
								"value" => array( "on" )
						),
						"value" => "",
						"group" => "Style"					  
					),
					
					// LINE
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Type", 'mpavc'),
						"param_name" => "line_type",
						"value" => array(
										esc_html__('Line','mpavc') 				=> 'solid',
										esc_html__('Duble Line','mpavc') 		=> 'double',
										esc_html__('Dotted','mpavc') 			=> 'dotted',
										esc_html__('Ddashed','mpavc') 			=> 'dashed',										
										esc_html__('Groove','mpavc') 			=> 'groove',
										esc_html__('Ridge','mpavc') 			=> 'ridge',
										esc_html__('Inset','mpavc') 			=> 'inset',
										esc_html__('Outset','mpavc') 			=> 'outset',
										esc_html__('Initial','mpavc') 			=> 'initial',
						),
						"dependency" => array(
								"element" => "line",
								"value" => array( "on" )
						),						
						"group" => "Line"
					),				
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Color", 'mpavc'),
						"param_name" => "line_color",
						"value" => '#000000',
						'dependency' => array(
								'element' => 'line',
								'value' => array( 'on' )
						),
						"group" => "Line"				  
					),						
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Line Height",'mpavc'),
						"param_name" => "line_height",
						"description" => "ex: 2px",					  
						"dependency" => array(
								"element" => "line",
								"value" => array( "on" )
						),
						"value" => "2px",
						"group" => "Line"					  
					),					
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Width",'mpavc'),
						"param_name" => "line_width",
						"description" => "ex: 10px",					  
						"dependency" => array(
								"element" => "line",
								"value" => array( "on" )
						),
						"value" => "10px",
						"group" => "Line"					  
					),
					
					// ANIMATION								  							  		  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate", 'mpavc'),
						"param_name" => "addon_animate",
						"value" => array(
										esc_html__('Off','mpavc') 	=> 'off',
										esc_html__('On','mpavc') 	=> 'on'
										
						),
						"group" => "Animation"
					),			  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate Effects", 'mpavc'),
						"param_name" => "effect",
						"value" => mpavc_animation_effect(),
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"group" => "Animation"				   
					),				  
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Animate Delay (ms)",'mpavc'),
						"param_name" => "delay",
						"description" => "ex 1000",					  
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"value" => "0",
						"group" => "Animation"					  
					),
                ),
            ));


        }
    }

} // End Class

if (class_exists('WPBakeryShortCode')) {
    class WPBakeryShortCode_MPAVC_Icon extends WPBakeryShortCode {
    }
}

// Initialize Element Class
if (class_exists('MPAVC_Icon')) {
    new MPAVC_Icon();
}

