<?php

/*
Addon: Interactive Box Style1
*/

class MPAVC_Interactive_Box_Style1 {

	/*
	 * Contruct
	 */
    public function __construct() {

        add_action('wp_enqueue_scripts', array($this, 'load_scripts'));

        add_shortcode('mpavc_interactive_box_style1', array($this, 'shortcode_addon_func'));

        add_action('init', array($this, 'map_vc_addon'));

    }

    function load_scripts() {
		
		wp_enqueue_style( 'bootstrap' );
        wp_enqueue_style( 'mpavc-style' );
		wp_enqueue_style( 'font-awesome' );
		wp_enqueue_style( 'animations' );
		wp_enqueue_script( 'appear' );
		wp_enqueue_script( 'animations' );
		
    }
	
	/*
	 * Addon View
	 */
    public function shortcode_addon_func($atts, $content = null, $tag) {
		static $instance;
		$instance++;

        extract(shortcode_atts(array(

            'title' 				=> '',
            'icon_show' 			=> 'on',
            'icon' 					=> 'fa fa-instagram',
            'text_link' 			=> '',
            'url_link' 				=> '',
            'target_link' 			=> '_blank',
            'custom_style' 			=> 'off',
			'width'					=> '300px',
			'height'				=> '300px',
            'title_color' 			=> '#FFFFFF',
			'icon_color' 			=> '#000000',
            'background_color' 		=> '#00FFFF',
            'background_h_color' 	=> '#FFFF00',
            'title_font_size' 		=> '30px',
            'title_font_weight' 	=> 'normal',
            'icon_size' 			=> '30px',
            'link_font_size' 		=> '14px',		
            'link_font_weight' 		=> 'normal',			
			'addon_animate'			=> 'off',
			'effect'				=> 'fade-in',
			'delay'					=> '0',
			

        ), $atts));

		if($custom_style == 'on') :
			$css_container		= 'style="background:'.esc_html($background_color).';width:'.esc_html($width).';height:'.esc_html($height).';"';
			$css_h_container	= 'style="background:'.esc_html($background_h_color).'"';
			$css_title 			= 'style="color:'.esc_html($title_color).';font-size:'.esc_html($title_font_size).';font-weight:'.esc_html($title_font_weight).'"';
			$css_icon 			= 'style="color:'.esc_html($icon_color).';font-size:'.esc_html($icon_size).'"';
			$css_link 			= 'style="font-size:'.esc_html($link_font_size).';font-weight:'.esc_html($link_font_weight).'"';
			$css_style_to_append = '<style>.mpavc-interactive-box-style1-'.esc_html($instance).':hover .mpavc-interactive-box-icon i,
			.mpavc-interactive-box-style1-'.esc_html($instance).':hover .mpavc-interactive-box-title {
					color:'.esc_html($background_color).';
			}
			.mpavc-interactive-box-style1-'.esc_html($instance).':hover .mpavc-interactive-box-link a {
				border: 1px solid '.esc_html($title_color).';
				color: '.esc_html($title_color).';
			}
			</style>';
			$data_value = 'data-mpavc-custom-css="'.$css_style_to_append.'"';
			$js_class = 'mpavc-custom-js';			
		else :
			$css_container = $css_title = $css_icon = $js_class = $data_value = $css_h_container = $css_link = '';
		endif;

        $output = '<div class="mpavc mpavc-interactive-box '.esc_html($js_class).' mpavc-interactive-box-style1 mpavc-interactive-box-style1-'.esc_html($instance).mpavc_animate_class($addon_animate,$effect,$delay).' '.$data_value.' '.$css_container.'>';
						
			$output .= '<div class="mpavc-interactive-box-container">
							<span class="mpavc-interactive-box-icon"><i class="'.esc_html($icon).'" '.$css_icon.'></i></span>
							<span class="mpavc-interactive-box-title" '.$css_title.'>'.esc_html($title).'</span>					
						</div>
						<div class="mpavc-interactive-box-container-link" '.$css_h_container.'>
							<a href="'.esc_url($url_link).'" class="mpavc-interactive-box-link" target="'.esc_html($target_link).'" '.$css_link.'>'.esc_html($text_link).'</a>
						</div>';			
        $output .= '<div class="mpavc-clear"></div></div>';

        return $output;
    }	

	
	/*
	 * Addon Backend
	 */	
    function map_vc_addon() {
        if (function_exists("vc_map")) {

            vc_map(array(
                "name" => esc_html__("Interactive Box Style 1", "mpavc"),
                "base" => "mpavc_interactive_box_style1",
                "content_element" => true,
                "show_settings_on_create" => true,
                "category" => esc_html__("MP Addons", "mpavc"),
                'description' => esc_html__('interactive box', 'mpavc'),
                "icon" => MPAVC_URL . '/assets/img/vc-interactive-box-style.png',
                "params" => array(
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Title",'mpavc'),
						"param_name" => "title",	
					),
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Show Icon", 'mpavc'),
						"param_name" => "icon_show",
						"value" => array(
									esc_html__('On','mpavc') 	=> 'on',
									esc_html__('Off','mpavc') 	=> 'off'																				
						)
					),						
					array(
						"type" => "iconpicker",
						"heading" => esc_html__( "Icon", "mpavc" ),
						"param_name" => "icon",
						"settings" => array(
							"emptyIcon" 	=> false,
							"type" 			=> "fontawesome",
							"iconsPerPage" 	=> 200,
						),
						"dependency" => array(
							"element" 	=> "icon_show",
							"value" 	=> array( "on" )
						),						
						"description" => esc_html__( "Select icon from library.", "mpavc" ),
					),					
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Text Link",'mpavc'),
						"param_name" => "text_link",	
					),					
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("URL Link",'mpavc'),
						"param_name" => "url_link",	
					),
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Target", 'mpavc'),
						"param_name" => "target_link",
						"value" => array(
									esc_html__('Blank (new window)','mpavc') 	=> '_blank',
									esc_html__('Self','mpavc') 					=> '_self'
										
						)
					),
					
					// STYLE					
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Style", 'mpavc'),
						"param_name" => "custom_style",
						"value" => array(
										esc_html__('Off','mpavc') 	=> 'off',
										esc_html__('On','mpavc') 	=> 'on'
										
						),
						"group" => "Style"
					),
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Width",'mpavc'),
						"param_name" => "width",
						"description" => "ex: 300px",					  
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),
						"value" => "300px",
						"group" => "Style"					  
					),
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Height",'mpavc'),
						"param_name" => "height",
						"description" => "ex: 300px",					  
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),
						"value" => "300px",
						"group" => "Style"					  
					),					
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Title Color", 'mpavc'),
						"param_name" => "title_color",
						"value" => '#FFFFFF',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Icon Color", 'mpavc'),
						"param_name" => "icon_color",
						"value" => '#000000',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),					
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Background Color", 'mpavc'),
						"param_name" => "background_color",
						"value" => '#00FFFF',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),					
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Hover Color", 'mpavc'),
						"param_name" => "background_h_color",
						"value" => '#FFFF00',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),				
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Title Font size",'mpavc'),
						"param_name" => "title_font_size",
						"description" => "ex: 30px",					  
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),
						"value" => "30px",
						"group" => "Style"					  
					),					
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Title Font Weight", 'mpavc'),
						"param_name" => "title_font_weight",
						"value" => array(
										esc_html__('Normal','mpavc') 	=> 'normal',
										esc_html__('Bold','mpavc') 		=> 'bold',
										esc_html__('100','mpavc') 		=> '100',
										esc_html__('200','mpavc') 		=> '200',
										esc_html__('300','mpavc') 		=> '300',
										esc_html__('400','mpavc') 		=> '400',
										esc_html__('500','mpavc') 		=> '500',
										esc_html__('600','mpavc') 		=> '600',
										esc_html__('700','mpavc') 		=> '700',
										esc_html__('800','mpavc') 		=> '800',
										esc_html__('900','mpavc') 		=> '900'
										
						),
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),						
						"group" => "Style"
					),					
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Icon size",'mpavc'),
						"param_name" => "icon_size",
						"description" => "ex: 30px",					  
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),
						"value" => "30px",
						"group" => "Style"					  
					),					
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Link text size",'mpavc'),
						"param_name" => "link_font_size",
						"description" => "ex: 14px",					  
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),
						"value" => "14px",
						"group" => "Style"					  
					),					
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Text Font Weight", 'mpavc'),
						"param_name" => "link_font_weight",
						"value" => array(
										esc_html__('Normal','mpavc') 	=> 'normal',
										esc_html__('Bold','mpavc') 		=> 'bold',
										esc_html__('100','mpavc') 		=> '100',
										esc_html__('200','mpavc') 		=> '200',
										esc_html__('300','mpavc') 		=> '300',
										esc_html__('400','mpavc') 		=> '400',
										esc_html__('500','mpavc') 		=> '500',
										esc_html__('600','mpavc') 		=> '600',
										esc_html__('700','mpavc') 		=> '700',
										esc_html__('800','mpavc') 		=> '800',
										esc_html__('900','mpavc') 		=> '900'
										
						),
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),						
						"group" => "Style"
					),										
					// ANIMATION								  							  		  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate", 'mpavc'),
						"param_name" => "addon_animate",
						"value" => array(
										esc_html__('Off','mpavc') 	=> 'off',
										esc_html__('On','mpavc') 	=> 'on'
										
						),
						"group" => "Animation"
					),			  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate Effects", 'mpavc'),
						"param_name" => "effect",
						"value" => mpavc_animation_effect(),
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"group" => "Animation"				   
					),				  
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Animate Delay (ms)",'mpavc'),
						"param_name" => "delay",
						"description" => "ex 1000",					  
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"value" => "0",
						"group" => "Animation"					  
					),
                ),
            ));


        }
    }

} // End Class

if (class_exists('WPBakeryShortCode')) {
    class WPBakeryShortCode_MPAVC_Interactive_Box_Style1 extends WPBakeryShortCode {
    }
}

// Initialize Element Class
if (class_exists('MPAVC_Interactive_Box_Style1')) {
    new MPAVC_Interactive_Box_Style1();
}

