<?php

/*
Addon: Logo
*/

class MPAVC_Logo {

	/*
	 * Contruct
	 */
    public function __construct() {

        add_action('wp_enqueue_scripts', array($this, 'load_scripts'));

        add_shortcode('mpavc_logo', array($this, 'shortcode_addon_func'));

        add_action('init', array($this, 'map_vc_addon'));

    }

    function load_scripts() {

		wp_enqueue_style( 'bootstrap' );
        wp_enqueue_style( 'mpavc-style' );
		wp_enqueue_style( 'font-awesome' );
		wp_enqueue_style( 'animations' );
		wp_enqueue_script( 'appear' );
		wp_enqueue_script( 'animations' );
		
    }
	
	/*
	 * Addon View
	 */
    public function shortcode_addon_func($atts, $content = null, $tag) {
		static $instance;
		$instance++;
		
        $date = '';

        extract(shortcode_atts(array(

            'logo_image' 	=> '',
			'logo_size'		=> 'full',
			'logo_align'	=> 'center',
			'logo_link'		=> 'on',
			'logo_url'		=> home_url( '/' ),
			'logo_target'	=> '_self',
			'addon_animate'	=> 'off',
			'effect'		=> 'fade-in',
			'delay'			=> '0',
			

        ), $atts));
		
		$logo_url_array = wp_get_attachment_image_src( $logo_image, $logo_size );
        
		$output = '<div class="mpavc mpavc-logo mpavc-align-'.esc_html($logo_align).' mpavc-logo-'.esc_html($instance).mpavc_animate_class($addon_animate,$effect,$delay).'>';
			
			if($logo_link == 'on') : $output .= '<a href="'.esc_url($logo_url).'" target="'.esc_html($logo_target).'">'; endif;
				$output .= '<img src="'.esc_url($logo_url_array[0]).'" alt="'.esc_html__('Logo','mpavc').'">';
			if($logo_link == 'on') : $output .= '</a>'; endif;
			
			
        $output .= '</div>';

        return $output;
    }	

	
	/*
	 * Addon Backend
	 */	
    function map_vc_addon() {
        if (function_exists("vc_map")) {

            vc_map(array(
                "name" => esc_html__("Logo", "mpavc"),
                "base" => "mpavc_logo",
                "content_element" => true,
                "show_settings_on_create" => true,
                "category" => esc_html__("MP Addons", "mpavc"),
                'description' => esc_html__('Add your Logo addon', 'mpavc'),
                "icon" => MPAVC_URL . '/assets/img/vc-logo.png',
                "params" => array(
					array(
						"type" => "attach_image",
						"class" => "",
						"heading" => esc_html__("Upload your Logo", 'mpavc'),
						"param_name" => "logo_image",
					),
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Size", 'mpavc'),
						"param_name" => "logo_size",
						"value" => array(
									esc_html__('Original Size','mpavc') => 'full',
									esc_html__('Thumbnail','mpavc') 	=> 'thumbnail',
									esc_html__('Medium','mpavc') 		=> 'large',
									esc_html__('Large','mpavc')  		=> 'large'																		
						),
					),					
					
					// TARGET
					array(
					    "type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Align", 'mpavc'),
						"param_name" => "logo_align",
						"value" => array(
									esc_html__('Center','mpavc')  => 'center',
									esc_html__('Left','mpavc') 	  => 'left',
									esc_html__('Right','mpavc')   => 'right',									
						),
					),			  
									
					array(
					    "type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Link", 'mpavc'),
						"param_name" => "logo_link",
						"value" => array(
									esc_html__('On','mpavc') 	=> 'on',
									esc_html__('Off','mpavc') 	=> 'off'
						),
						"group" => "Target"
					),
									
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Url",'mpavc'),
						"param_name" => "logo_url",
						"description" => esc_html__('Leave empty for homelink','mpavc'),					  
						'dependency' => array(
								'element' => 'logo_link',
								'value' => array( 'on' )
						),
						"group" => "Target"
					),
									
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Target", 'mpavc'),
						"param_name" => "logo_target",
						"value" => array(
									esc_html__('Self (Same Window)','mpavc') => '_self',
									esc_html__('Blank (New Window)','mpavc') => '_blank'
									
						),
						'dependency' => array(
								'element' => 'logo_link',
								'value' => array( 'on' )
						),
						"group" => "Target"
					),
					
					// ANIMATION								  							  		  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate", 'mpavc'),
						"param_name" => "addon_animate",
						"value" => array(
										esc_html__('Off','mpavc') 	=> 'off',
										esc_html__('On','mpavc') 	=> 'on'
										
						),
						"group" => "Animation"
					),			  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate Effects", 'mpavc'),
						"param_name" => "effect",
						"value" => mpavc_animation_effect(),
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"group" => "Animation"				   
					),				  
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Animate Delay (ms)",'mpavc'),
						"param_name" => "delay",
						"description" => "ex 1000",					  
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"value" => "0",
						"group" => "Animation"					  
					),
                ),
            ));


        }
    }

} // End Class

if (class_exists('WPBakeryShortCode')) {
    class WPBakeryShortCode_MPAVC_Logo extends WPBakeryShortCode {
    }
}

// Initialize Element Class
if (class_exists('MPAVC_Logo')) {
    new MPAVC_Logo();
}

