<?php

/*
Addon: map
*/

class MPAVC_Map {

	/*
	 * Contruct
	 */
    public function __construct() {

        add_action('wp_enqueue_scripts', array($this, 'load_scripts'));

        add_shortcode('mpavc_map', array($this, 'shortcode_addon_func'));

        add_action('init', array($this, 'map_vc_addon'));

    }

    function load_scripts() {
		
		wp_enqueue_style( 'bootstrap' );
        wp_enqueue_style( 'mpavc-style' );
		wp_enqueue_style( 'font-awesome' );
		wp_enqueue_style( 'animations' );
		wp_enqueue_script( 'appear' );
		wp_enqueue_script( 'animations' );
		
    }
	
	/*
	 * Addon View
	 */
    public function shortcode_addon_func($atts, $content = null, $tag) {
		static $instance;
		$instance++;
		
        $map = '';

        extract(shortcode_atts(array(

				"type" => 'satellite', 
				"latidude" => '', 
				"longitude" => '', 
				"zoom" => '2', 
				"messagge" => '',
				"key"	=> '', 
				"width" => '', 
				"height" => '',
				"marker" => 'on',
				"marker_image" => '',
				"zoomcontrol" => 'false',
				"scalecontrol" => 'false',
				"streetviewcontrol" => 'false',
				"rotatecontrol" => 'false',
				"maptypecontrol" => 'false',
				"pancontrol" => 'false', 
				"overviewmapcontrol" => 'false',
				"addon_animate"	=> "off",
				"effect"		=> "fade-in",
				"delay"			=> "0",
			

        ), $atts));

	$id = 'mpavc-map-'.$instance;
	if($key == '') :
	wp_enqueue_script( 'mpavc-map-js',  'http://maps.google.com/maps/api/js'); 
	else:
	wp_enqueue_script( 'mpavc-map-js',  'http://maps.google.com/maps/api/js?key='.$key.''); 	
	endif;
    $mapType = '';
    if($type == "satellite") {
        $mapType = "SATELLITE";
	} elseif($type == "terrain") {
        $mapType = "TERRAIN"; 
	} elseif($type == "hybrid") {
        $mapType = "HYBRID";
	} elseif($type == "roadmap") {
        $mapType = "ROADMAP"; 
	}
	
	$return = '';  
	 
        $return .= '<div 
					data-mpavc-map-id="'.esc_html($id).'"
					data-mpavc-map-type="'.esc_html($mapType).'"
					data-mpavc-map-latidude="'.esc_html($latidude).'"
					data-mpavc-map-longitude="'.esc_html($longitude).'"
					data-mpavc-map-zoom="'.esc_html($zoom).'"
					data-mpavc-map-messagge="'.esc_html($messagge).'"
					data-mpavc-map-marker="'.esc_html($marker).'"
					data-mpavc-map-marker-image="'.esc_url($image_attributes[0]).'"
					data-mpavc-map-zoomcontrol="'.esc_html($zoomcontrol).'"
					data-mpavc-map-scalecontrol="'.esc_html($scalecontrol).'"
					data-mpavc-map-streetviewcontrol="'.esc_html($streetviewcontrol).'"
					data-mpavc-map-rotatecontrol="'.esc_html($rotatecontrol).'"
					data-mpavc-map-maptypecontrol="'.esc_html($maptypecontrol).'"
					data-mpavc-map-pancontrol="'.esc_html($pancontrol).'"
					data-mpavc-map-overviewmapcontrol="'.esc_html($overviewmapcontrol).'"
		
		style="height:'.esc_html($height).';" class="mpavc-gmaps mpavc-map-container'.mpavc_animate_class($addon_animate,$effect,$delay).'>
						<div id="'.esc_html($id).'" style="width:'.esc_html($width).'; height:'.esc_html($height).';" class="mpavc-googleMap"></div>
					</div>';					
		return $return;
	} 

	
	/*
	 * Addon Backend
	 */	
    function map_vc_addon() {
        if (function_exists("vc_map")) {

            vc_map(array(
                "name" => esc_html__("Map", "mpavc"),
                "base" => "mpavc_map",
                "content_element" => true,
                "show_settings_on_create" => true,
                "category" => esc_html__("MP Addons", "mpavc"),
                'description' => esc_html__('Create map addon', 'mpavc'),
                "icon" => MPAVC_URL . '/assets/img/vc-map.png',
                "params" => array(
                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => esc_html__("Type", 'mpavc'),
                  "param_name" => "type",
                  "value" => array(
									'Satellite' => 'satellite',
									'Terrain' => 'terrain',
									'Hybrid' => 'hybrid',
									'Roadmap' => 'roadmap'
				   ),
				   'admin_label' => true
				),
				array(
				  "type" => "textfield",
				  "class" => "",
				  "heading" => esc_html__("Latitude",'mpavc'),
				  "param_name" => "latidude",
				  'admin_label' => true
			  ),
			  array(
				  "type" => "textfield",
				  "class" => "",
				  "heading" => esc_html__("Longitude",'mpavc'),
				  "param_name" => "longitude",
			  ),			  
              array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => esc_html__("Zoom", 'mpavc'),
                  "param_name" => "zoom",
				  "admin_label" => true,
                  "value" => array(
									'2',
									'3',
									'4',
									'5',
									'6',
									'7',
									'8',
									'9',
									'10',
									'11',
									'12',
									'13',
									'14',
									'15',
									'16',
									'17',
									'18',
									'19',
									'20',
									'21'																														
				   )
               ),
                array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => esc_html__("Custom Marker", 'mpavc'),
                  "param_name" => "marker",
                  "value" => array(
									__('On','mpavc') => 'on',
									__('Off','mpavc') 	  => 'off'
				   )
				),
			  array(
				  "type" => "attach_image",
				  "class" => "",
				  "heading" => esc_html__("Image Custom Marker",'mpavc'),
				  "param_name" => "marker_image",
				  'dependency' => array(
						'element' => 'marker',
						'value' => array( 'on' )
				  ),				  
			  ),				
								   			  
			  array(
				  "type" => "textfield",
				  "class" => "",
				  "heading" => esc_html__("Width (example: 300px or 100%)",'mpavc'),
				  "param_name" => "width",
			  ),
			  array(
				  "type" => "textfield",
				  "class" => "",
				  "heading" => esc_html__("Height (example: 300px)",'mpavc'),
				  "param_name" => "height",
			  ),
			  array(
				  "type" => "textfield",
				  "class" => "",
				  "heading" => esc_html__("Message",'mpavc'),
				  "param_name" => "messagge",
			  ),
			  array(
				  "type" => "textfield",
				  "class" => "",
				  "heading" => esc_html__("API Key",'mpavc'),
				  "param_name" => "key",
			  ),			  
               array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => esc_html__("Show Zoom Control", 'mpavc'),
                  "param_name" => "zoomcontrol",
                  "value" => array(
									__('Off','mpavc') => 'false',
									__('On','mpavc')  => 'true'
				   ),
				   "group" => "Advanced Options"
				),
               array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => esc_html__("Show Scale Control", 'mpavc'),
                  "param_name" => "scalecontrol",
                  "value" => array(
									__('Off','mpavc') => 'false',
									__('On','mpavc')  => 'true'
				   ),
				   "group" => "Advanced Options"
				),
               array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => esc_html__("Show Street View Control", 'mpavc'),
                  "param_name" => "streetviewcontrol",
                  "value" => array(
									__('Off','mpavc') => 'false',
									__('On','mpavc')  => 'true'
				   ),
				   "group" => "Advanced Options"
				),
               array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => esc_html__("Show Rotate Control", 'mpavc'),
                  "param_name" => "rotatecontrol",
                  "value" => array(
									__('Off','mpavc') => 'false',
									__('On','mpavc')  => 'true'
				   ),
				   "group" => "Advanced Options"
				),
               array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => esc_html__("Show Map Type Control", 'mpavc'),
                  "param_name" => "maptypecontrol",
                  "value" => array(
									__('Off','mpavc') => 'false',
									__('On','mpavc')  => 'true'
				   ),
				   "group" => "Advanced Options"
				),
               array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => esc_html__("Show Pan Control", 'mpavc'),
                  "param_name" => "pancontrol",
                  "value" => array(
									__('Off','mpavc') => 'false',
									__('On','mpavc')  => 'true'
				   ),
				   "group" => "Advanced Options"
				),
               array(
                  "type" => "dropdown",
                  "class" => "",
                  "heading" => esc_html__("Show Overview Map Control", 'mpavc'),
                  "param_name" => "overviewmapcontrol",
                  "value" => array(
									__('Off','mpavc') => 'false',
									__('On','mpavc')  => 'true'
				   ),
				   "group" => "Advanced Options"
				),						
					
					// ANIMATION								  							  		  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate", 'mpavc'),
						"param_name" => "addon_animate",
						"value" => array(
										esc_html__('Off','mpavc') 	=> 'off',
										esc_html__('On','mpavc') 	=> 'on'
										
						),
						"group" => "Animation"
					),			  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate Effects", 'mpavc'),
						"param_name" => "effect",
						"value" => mpavc_animation_effect(),
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"group" => "Animation"				   
					),				  
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Animate Delay (ms)",'mpavc'),
						"param_name" => "delay",
						"description" => "ex 1000",					  
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"value" => "0",
						"group" => "Animation"					  
					),
                ),
            ));


        }
    }

} // End Class

if (class_exists('WPBakeryShortCode')) {
    class WPBakeryShortCode_MPAVC_Map extends WPBakeryShortCode {
    }
}

// Initialize Element Class
if (class_exists('MPAVC_Map')) {
    new MPAVC_Map();
}

