<?php

/*
Addon: News Posts Style6
*/

class MPAVC_News_Posts_Style6 {

	/*
	 * Contruct
	 */
    public function __construct() {

        add_action('wp_enqueue_scripts', array($this, 'load_scripts'));

        add_shortcode('mpavc_news_posts_style6', array($this, 'shortcode_addon_func'));

        add_action('init', array($this, 'map_vc_addon'));

    }

    function load_scripts() {
		
		wp_enqueue_style( 'bootstrap' );
        wp_enqueue_style( 'mpavc-style' );
        wp_enqueue_style( 'mpavc-style-news' );
		wp_enqueue_style( 'font-awesome' );
		wp_enqueue_style( 'animations' );
		wp_enqueue_script( 'appear' );
		wp_enqueue_script( 'animations' );
		
    }
	
	/*
	 * Addon View
	 */
    public function shortcode_addon_func($atts, $content = null, $tag) {
		static $instance;
		$instance++;

        extract(shortcode_atts(array(

            'name' 					=> '',
			'columns'				=> '1',
			
			// Query
			'source' 				=> 'post',
			'posts_source' 			=> 'all_posts',
			'posts_type' 			=> '',
			'categories' 			=> '',									
			'categories_post_type' 	=> '',
			'pagination' 			=> 'off',
			'pagination_type' 		=> 'numeric',
			'num_posts_page' 		=> '',
			'num_posts' 			=> '', 	
			'orderby' 				=> 'date',
			'order' 				=> 'DESC',
						
			// Style
            'custom_style' 			=> 'off',
            'title_color' 			=> '#333333',
            'text_color' 			=> '#747474',
            'date_color' 			=> '#AAAAAA',
            'comment_color' 		=> '#FFFFFF',
			'category_color' 		=> '#FFFFFF',
			'category_h_color' 		=> '#e7685d',
            'bg_category_color' 	=> '#000000',
            'link_color' 			=> '#c9564c',
            'link_h_color' 			=> '#e7685d',
			

			// Animations
			'addon_animate'			=> 'off',
			'effect'				=> 'fade-in',
			'delay'					=> '0',
			

        ), $atts));
		
		$container_class = $class_load_more = $class_item_load_more = $css_title = $css_text = $css_link = $css_date = $css_bg_comment = $css_comment = $css_comment_link = $js_class = $data_value = $css_current_pag_num = '';

		if($columns == '1') : $columns_class = 'col-xs-12'; $container_class = 'mpavc-np-vc-news-1-col'; endif;
		if($columns == '2') : $columns_class = 'col-xs-6'; $container_class = 'mpavc-np-vc-news-2-col'; endif;
		if($columns == '3') : $columns_class = 'col-xs-4'; $container_class = 'mpavc-np-vc-news-3-col'; endif;		
		if(empty($num_posts)) : $num_posts = 6; endif;		
		
		$post_id = get_the_id(); 
		// PAGINATION		
		if($pagination == 'yes') {
			if ( get_query_var('paged') ) {
				$paged = get_query_var('paged');				
			} elseif ( get_query_var('page') ) {			
				$paged = get_query_var('page');			
			} else {			
				$paged = 1;			
			}
		}
		// #PAGINATION		
		
		// Load More
		if($pagination == 'load-more') : 
			$class_load_more = 'mpavc-np-load-more-news-style6'; 
			$class_item_load_more = 'mpavc-np-item-load-more-style6';
		endif;
		// #Load More
		
		// LOOP QUERY
		$query = mpavc_query( $source,
							$posts_source, 
							$posts_type, 
							$categories,
							$categories_post_type, 
							$order, 
							$orderby, 
							$pagination, 
							$pagination_type,
							$num_posts, 
							$num_posts_page );	
		
		if($custom_style == 'on') :
			$css_title = 'style="color:'.esc_html($title_color).'" onMouseOver="this.style.color = \''.esc_html($link_h_color).'\';" onMouseLeave="this.style.color = \''.esc_html($title_color).'\';"';
			$css_text = 'style="color:'.esc_html($text_color).'"';
			$css_date = 'style="color:'.esc_html($date_color).'"';		
			$css_comment_link = 'style="color:'.esc_html($comment_color).'" onMouseOver="this.style.color = \''.esc_html($link_h_color).'\';" onMouseLeave="this.style.color = \''.esc_html($comment_color).'\';"';			
			$css_link = 'style="color:'.esc_html($link_color).'" onMouseOver="this.style.color = \''.esc_html($link_h_color).'\';" onMouseLeave="this.style.color = \''.esc_html($link_color).'\';"';
			$css_category = 'style="color:'.esc_html($category_color).';background-color:'.esc_html($bg_category_color).';" onMouseOver="this.style.color = \''.esc_html($category_h_color).'\';" onMouseLeave="this.style.color = \''.esc_html($category_color).'\';"';
			$css_current_pag_num = 'style="color:'.esc_html($link_h_color).'"';
		endif;

		$return .= '<div class="mpavc-clear"></div>';
		
		$count = 0;
		
		$return .= '<div class="mpavc mpavc-np-vc-element-news '.esc_html($class_load_more).' mpavc-np-news-style6 '.esc_html($container_class).' element-no-padding mpavc-np-vc-element-news-'.esc_html($instance).mpavc_animate_class($addon_animate,$effect,$delay).'>';
		
		if($style == ''): $style = ''; endif;
		
		$return .= '<div class="mpavc-np-vc-element-news-article-container">';
		
		// Start Query Loop
		$loop = new WP_Query($query);		

		// Load More
		if($pagination == 'load-more') : 
		
			$readtext 		= esc_html__('Read More','mpavc');
			$loading 		= esc_html__('Loading posts...','mpavc');
			$nomoreposts 	= esc_html__('No more posts to load.','mpavc');		
		
			wp_enqueue_script(
				'mpavc-np-load-news-style6',
				MPAVC_URL . 'assets/js/mpavc-np-load-more-news-style6.js',
				array('jquery'),
				'1.0',
				true
			);		
					
			$max = $loop->max_num_pages;
			$paged = ( get_query_var('paged') > 1 ) ? get_query_var('paged') : 1;
			
			// Add some parameters for the JS.
			wp_localize_script(
				'mpavc-np-load-news-style6',
				'fnwp_',
				array(
					'startPage' 	=> $paged,
					'maxPages' 		=> $max,
					'nextLink' 		=> next_posts($max, false),
					'readtext'		=> $readtext,
					'loading'		=> $loading,
					'nomoreposts'	=> $nomoreposts,
					'cssLink'		=> $css_link
				)
			);
		endif;
		// #Load More


		
		if($loop) :
			while ( $loop->have_posts() ) : $loop->the_post();
		
				$id_post = get_the_id();
				$link = get_permalink(); 
				if($count & 1) : $class_odd = "vc-element-post-even"; else : $class_odd = "vc-element-post-odd"; endif;		
				
					if($count < $columns) :
				
						$return .= '<article class="item-news first-element-news '.esc_html($columns_class).' '.esc_html($class_item_load_more).' '.esc_html($class_odd).'">';
							$return .= '<div class="article-image">';
								if($columns != 3) :
									$return .= mpavc_get_thumb('mpavc-vc-posts-medium-large');
								else :
									$return .= mpavc_get_thumb('mpavc-vc-header-medium');							
								endif;
								$return .= mpavc_check_post_format();						
								$return .= '<div class="article-category">'.mpavc_get_category($source,$post_type,$css_category).'
																			<a href="'.esc_url($link).'" '.$css_category.'><i class="fa fa-mail-forward"></i></a>
											</div>';
							$return .= '</div>';
							$return .= '<div class="article-info">';
								$return .= '<div class="article-info-top">';
										$return .= '<div class="article-data" '.$css_date.'><i class="fa fa-calendar-o"></i>'.get_the_date().'</div>';
										$return .= '<div class="article-separator">|</div>';
										$return .= '<div class="article-comments"><i class="fa fa-comment-o"></i>'.mpavc_get_num_comments($css_comment,$css_comment_link).'</div>';
								$return .= '<div class="mpavc-clear"></div></div>';
								$return .= '<div class="article-info-bottom">';		
										$return .= '<h3 class="article-title"><a href="'.esc_url($link).'" '.$css_title.'>'.get_the_title().'</a></h3>';
										if($columns != 1) :
											$return .= '<p class="article-excerpt" '.$css_text.'>' . mpavc_get_news_excerpt(150,'on',$css_link) . '</p>';
										else :
											$return .= '<p class="article-excerpt" '.$css_text.'>' . mpavc_get_news_excerpt(350,'on',$css_link) . '</p>';						
										endif;
										$return .= '<div class="mpavc-clear"></div>';	
								$return .= '</div>';
							$return .= '</div>';
						$return .= '</article>';
			
					else :
					
						$return .= '<article class="item-news first-element-news others-post '.esc_html($columns_class).' '.esc_html($class_item_load_more).' '.esc_html($class_odd).'">';
							$return .= '<div class="article-image col-xs-5">';
								if($columns != 1) :
									$return .= mpavc_get_thumb('mpavc-vc-header-small');
								else :
									$return .= mpavc_get_thumb('mpavc-vc-header-medium');							
								endif;
								$return .= mpavc_check_post_format();
							$return .= '</div>';
							$return .= '<div class="article-info col-xs-7">';
								$return .= '<div class="article-info-top">';
										$return .= '<h3 class="article-title"><a href="'.esc_url($link).'" '.$css_title.'>'.get_the_title().'</a></h3>';
										$return .= '<div class="article-data" '.$css_date.'><i class="fa fa-calendar-o"></i>'.get_the_date().'</div>';
										if($columns == 1) :
											$return .= '<div class="mpavc-clear"></div><p class="article-excerpt" '.$css_text.'>' . mpavc_get_news_excerpt(150,'on',$css_link) . '</p>';
										endif;								
								$return .= '<div class="mpavc-clear"></div></div>';
								$return .= '<div class="article-info-bottom">';		
											$return .= '<div class="article-category">'.mpavc_get_category($source,$post_type,$css_category).'
																			<a href="'.esc_url($link).'" '.$css_category.'><i class="fa fa-mail-forward"></i></a>
														</div>';						
											$return .= '<div class="mpavc-clear"></div>';	
								$return .= '</div>';
							$return .= '</div>';
						$return .= '</article>';					
										
					endif;				
					
				$count_clear = $count + 1;
				if(($count_clear % $columns) == 0) : $return .= '<div class="mpavc-clear"></div>'; endif;		
				
			$count++;
			endwhile;
		endif;	
		
		$return .= '</div><div class="mpavc-clear"></div>';
		
		/**********************************************************************/
		/****************************** PAGINATION ****************************/
		/**********************************************************************/ 
		if($pagination == 'yes') {
				$return .= '<div class="mpavc-clear"></div><div class="mpavc-np-news-display-'.esc_html($instance).' mpavc-np-vc-pagination">';
				if($pagination_type == 'numeric') {
					$return .= mpavc_posts_numeric_pagination($pages = '', $range = 2,$loop,$paged,$css_current_pag_num,$css_link);
				} else {
					$return .= '<div class="mpavc-np-pagination-normal">';
						$return .= get_next_posts_link( '<span '.$css_link.'>Older News</span>', $loop->max_num_pages );
						$return .= get_previous_posts_link( '<span '.$css_link.'>Newer News</span>' );
					$return .= '</div>';
				}
				$return .= '<div class="mpavc-clear"></div></div>';
		}
		/**********************************************************************/
		/***************************** #PAGINATION ****************************/
		/**********************************************************************/ 
		
		$return .= '</div>';
		wp_reset_query();
		return $return;
    }	

	
	/*
	 * Addon Backend
	 */	
    function map_vc_addon() {
        if (function_exists("vc_map")) {

            vc_map(array(
                "name" => esc_html__("News Posts Style 6", "mpavc"),
                "base" => "mpavc_news_posts_style6",
                "content_element" => true,
                "show_settings_on_create" => true,
                "category" => esc_html__("MP Addons", "mpavc"),
                'description' => esc_html__('add your posts', 'mpavc'),
                "icon" => MPAVC_URL . '/assets/img/vc-news-post-style.png',
                "params" => array(
					array(
							"type" => "textfield",
							"class" => "",
							"heading" => esc_html__("Newss Display Name",'mpavc'),
							"param_name" => "name",
							"admin_label" => true,				  				  			  				  
					),
					array(		
						  "type" => "dropdown",
						  "class" => "",
						  "heading" => esc_html__("Columns", 'mpavc'),
						  "param_name" => "columns",
						  "value" => array(
											'1' => '1',
											'2' => '2',
											'3' => '3',										
						   ),					   
					),					
					
					// QUERY
					array(
					  "type" => "dropdown",
					  "class" => "",
					  "heading" => esc_html__("Source", 'mpavc'),
					  "param_name" => "source",
					  "value" => array(
										esc_html__('Wordpress Posts','mpavc') 		=> 'post',
										esc_html__('Custom Posts Type','mpavc')  	=> 'post_type',
					   ),
					   "group" => "Query"				   			   
					),

					array(
					  "type" => "dropdown",
					  "class" => "",
					  "heading" => esc_html__("All Posts/Sticky Posts", 'mpavc'),
					  "param_name" => "news_source",
					  "value" => array(
										esc_html__('All Posts','mpavc') 		 		=> 'all_posts',
										esc_html__('Only Sticky Posts','mpavc')  	=> 'sticky_posts',
					   ),
					   "group" => "Query",
					  "dependency" => array(
								'element' => 'source',
								'value' => array( 'post' )
					  ),					   				   			   
					),

					array(
					  "type" => "posttypes", 
					  "class" => "",
					  "heading" => esc_html__("Select Post Type Source",'mpavc'),
					  "param_name" => "posts_type",
					  "group" => "Query",
					  "dependency" => array(
								'element' => 'source',
								'value' => array( 'post_type' )
					  ),					  				  					  				  			  				  
					),
					array(
					  "type" => "checkbox", 
					  "class" => "",
					  "heading" => esc_html__("Categories",'mpavc'),
					  "param_name" => "categories",
					  "group" => "Query", 
					  "value" => mpavc_get_category_array(),	  
					  "dependency" => array(
								'element' => 'source',
								'value' => array( 'post' )
					  ),				  					  				  					  				  			  				  
					),				
					
					
					array(
					  "type" => "textfield", 
					  "class" => "",
					  "heading" => esc_html__("Categories Post Type",'mpavc'),
					  "param_name" => "categories_post_type",
					  "description" => esc_html__("Write Categories slug separate by comma(,) for example: cat-slug1, cat-slug2, cat-slug3 (Leave empty for all categories)","mpavc"),
					  "group" => "Query",
					  "dependency" => array(
								'element' => 'source',
								'value' => array( 'post_type' )
					  ),				  					  				  					  				  			  				  
					),

					array(
					  "type" => "dropdown",
					  "class" => "",
					  "heading" => esc_html__("Order", 'mpavc'),
					  "param_name" => "order",
					  "value" => array(
										esc_html__('DESC','mpavc')  	=> 'DESC',
										esc_html__('ASC','mpavc') 	=> 'ASC'
										
					   ),
					   "group" => "Query"				   			   
					),

					array(
					  "type" => "dropdown",
					  "class" => "",
					  "heading" => esc_html__("Order By", 'mpavc'),
					  "param_name" => "orderby",
					  "value" => array(
										esc_html__('Date','mpavc') 				=> 'date',
										esc_html__('ID','mpavc')  				=> 'ID',
										esc_html__('Author','mpavc') 			=> 'author',
										esc_html__('Title','mpavc')  			=> 'title',
										esc_html__('Name','mpavc') 				=> 'name',
										esc_html__('Modified','mpavc')  			=> 'modified',
										esc_html__('Parent','mpavc') 			=> 'parent',
										esc_html__('Rand','mpavc')  				=> 'rand',
										esc_html__('Comments Count','mpavc')  	=> 'comment_count',
										esc_html__('Views','mpavc')				=> 'views',
										esc_html__('None','mpavc')  				=> 'none',																																													
					   ),
					   "group" => "Query"				   			   
					),												

					array(
					  "type" => "dropdown",
					  "class" => "",
					  "heading" => esc_html__("Pagination", 'mpavc'),
					  "param_name" => "pagination",
					  "value" => array(
										esc_html__('No','mpavc')  						=> 'no',
										esc_html__('Yes','mpavc') 						=> 'yes',
										esc_html__('Yes with load more','mpavc') 		=> 'load-more'
										
					   ),				   
					  "group" => "Query"				   			   
					),

					array(
					  "type" => "textfield", 
					  "class" => "",
					  "heading" => esc_html__("Number Posts",'mpavc'),
					  "param_name" => "num_posts",
					  "description" => "ex 10",
					  "group" => "Query",
					  "dependency" => array(
								'element' => 'pagination',
								'value' => array( 'no' )
					  ),					  				  					  				  			  				  
					),

					array(
					  "type" => "dropdown",
					  "class" => "",
					  "heading" => esc_html__("Pagination Type", 'mpavc'),
					  "param_name" => "pagination_type",
					  "value" => array(
										esc_html__('Numeric','mpavc') 		=> 'numeric',
										esc_html__('Normal','mpavc')  		=> 'normal',
					  ),
					  "group" => "Query",
					  "dependency" => array(
								'element' => 'pagination',
								'value' => array( 'yes' )
					  ),				   				   			   
					),

					array(
					  "type" => "textfield", 
					  "class" => "",
					  "heading" => esc_html__("Number Posts For Page",'mpavc'),
					  "param_name" => "num_posts_page",
					  "description" => "ex 10",
					  "group" => "Query",
					  "dependency" => array(
								'element' => 'pagination',
								'value' => array( 'yes','load-more' )
					  ),					  				  					  				  			  				  
					),				
					
					// STYLE					
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Style", 'mpavc'),
						"param_name" => "custom_style",
						"value" => array(
										esc_html__('Off','mpavc') 	=> 'off',
										esc_html__('On','mpavc') 	=> 'on'
										
						),
						"group" => "Style"
					),				
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Title Color", 'mpavc'),
						"param_name" => "title_color",
						"value" => '#333333',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Text Color", 'mpavc'),
						"param_name" => "text_color",
						"value" => '#747474',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Date Color", 'mpavc'),
						"param_name" => "date_color",
						"value" => '#AAAAAA',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Comment Color", 'mpavc'),
						"param_name" => "comment_color",
						"value" => '#FFFFFF',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Category Color", 'mpavc'),
						"param_name" => "category_color",
						"value" => '#FFFFFF',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Category Hover Color", 'mpavc'),
						"param_name" => "category_h_color",
						"value" => '#e7685d',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),						
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Category Background Color", 'mpavc'),
						"param_name" => "bg_category_color",
						"value" => '#000000',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),					
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Link Color", 'mpavc'),
						"param_name" => "link_color",
						"value" => '#c9564c',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Link Hover Color", 'mpavc'),
						"param_name" => "link_h_color",
						"value" => '#e7685d',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),														
					// ANIMATION								  							  		  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate", 'mpavc'),
						"param_name" => "addon_animate",
						"value" => array(
										esc_html__('Off','mpavc') 	=> 'off',
										esc_html__('On','mpavc') 	=> 'on'
										
						),
						"dependency" => array(
							"element" => "pagination",
							"value" => array( "no", "yes" )
						),						
						"group" => "Animation"
					),			  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate Effects", 'mpavc'),
						"param_name" => "effect",
						"value" => mpavc_animation_effect(),
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"group" => "Animation"				   
					),				  
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Animate Delay (ms)",'mpavc'),
						"param_name" => "delay",
						"description" => "ex 1000",					  
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"value" => "0",
						"group" => "Animation"					  
					),
                ),
            ));


        }
    }

} // End Class

if (class_exists('WPBakeryShortCode')) {
    class WPBakeryShortCode_MPAVC_News_Posts_Style6 extends WPBakeryShortCode {
    }
}

// Initialize Element Class
if (class_exists('MPAVC_News_Posts_Style6')) {
    new MPAVC_News_Posts_Style6();
}

