<?php

/*
Addon: News Carousel Posts Style3
*/

class MPAVC_News_Carousel_Posts_Style3 {

	/*
	 * Contruct
	 */
    public function __construct() {

        add_action('wp_enqueue_scripts', array($this, 'load_scripts'));

        add_shortcode('mpavc_news_carousel_posts_style3', array($this, 'shortcode_addon_func'));

        add_action('init', array($this, 'map_vc_addon'));

    }

    function load_scripts() {
		
		wp_enqueue_style( 'bootstrap' );
        wp_enqueue_style( 'mpavc-style' );
        wp_enqueue_style( 'mpavc-style-news-v2' );
		wp_enqueue_style( 'font-awesome' );
		wp_enqueue_style( 'animations' );
		wp_enqueue_style( 'owlcarousel' );
		wp_enqueue_script( 'appear' );
		wp_enqueue_script( 'animations' );
		wp_enqueue_script( 'owlcarousel' );
		
    }
	
	/*
	 * Addon View
	 */
    public function shortcode_addon_func($atts, $content = null, $tag) {
		static $instance;
		$instance++;

        extract(shortcode_atts(array(

            'name' 					=> '',
            'columns' 				=> '1',
			
			// Query
			'source' 				=> 'post',
			'posts_source' 			=> 'all_posts',
			'posts_type' 			=> '',
			'categories' 			=> '',									
			'categories_post_type' 	=> '',
			'pagination' 			=> 'off',
			'pagination_type' 		=> 'numeric',
			'num_posts_page' 		=> '',
			'num_posts' 			=> '', 	
			'orderby' 				=> 'date',
			'order' 				=> 'DESC',

			// Carousel
			'item_show'				=> '1',
			'item_show_900'			=> '1',
			'item_show_600'			=> '1',
			'loop'					=> 'false',
			'autoplay'				=> '',
			'smart_speed'			=> '2000',
			'navigation'			=> 'true',
			'pagination'			=> 'true',
			'margin'				=> '0',
			'rtl'					=> 'false',
			'custom_style' 			=> 'off',
	
			// Style
            'custom_style' 			=> 'off',
            'title_color' 			=> '#333333',
            'text_color' 			=> '#747474',
            'date_color' 			=> '#AAAAAA',
            'comment_color' 		=> '#FFFFFF',
            'bg_category_color' 	=> '#000000',
            'link_color' 			=> '#c9564c',
            'link_h_color' 			=> '#e7685d',
			'nav_color'				=> '#333333',
			'nav_h_color'			=> '#333333',
			'nav_bg_color'			=> '#FFFFFF',
			'nav_bg_h_color'		=> '#FFFFFF',			

			// Animations
			'addon_animate'			=> 'off',
			'effect'				=> 'fade-in',
			'delay'					=> '0',
			

        ), $atts));

		if($custom_style == 'on') :
		
			$css_style_to_append = "<style>
			.mpavc-np-v2-vc-element-news-".esc_html($instance)." .mpavc-np-v2-vc-element-carousel-news.owl-theme .owl-controls .owl-nav [class*=owl-]:hover { color:".esc_html($nav_h_color)."; background:".esc_html($nav_bg_h_color).";}
			.mpavc-np-v2-vc-element-news-".esc_html($instance)." .mpavc-np-v2-vc-element-carousel-news.owl-theme .owl-controls .owl-nav [class*=owl-] { color:".esc_html($nav_color)."; background:".esc_html($nav_bg_color).";}
			.mpavc-np-v2-vc-element-news-".esc_html($instance)." .mpavc-np-v2-vc-element-carousel-news.owl-theme .owl-dots .owl-dot span { background:".esc_html($nav_bg_color).";}
			</style>";
			$data_value = 'data-mpavc-custom-css="'.$css_style_to_append.'"';
			$js_class = 'mpavc-custom-js';

		else :

			$js_class = $data_value = '';

		endif;
		
		$container_class = $class_load_more = $class_item_load_more = $css_title = $css_text = $css_link = $css_date = $css_bg_comment = $css_comment = $css_comment_link = $css_current_pag_num = '';
		if(empty($num_posts)) : $num_posts = 6; endif;		
		
		$post_id = get_the_id(); 	
		
		// LOOP QUERY
		$query = mpavc_query( $source,
							$posts_source, 
							$posts_type, 
							$categories,
							$categories_post_type, 
							$order, 
							$orderby, 
							$pagination, 
							$pagination_type,
							$num_posts, 
							$num_posts_page );	
		
		if($custom_style == 'on') :
			$css_title = 'style="color:'.esc_html($title_color).'" onMouseOver="this.style.color = \''.esc_html($link_h_color).'\';" onMouseLeave="this.style.color = \''.esc_html($title_color).'\';"';
			$css_text = 'style="color:'.esc_html($text_color).'"';
			$css_date = 'style="color:'.esc_html($date_color).'"';		
			$css_comment_link = 'style="color:'.esc_html($comment_color).'" onMouseOver="this.style.color = \''.esc_html($link_h_color).'\';" onMouseLeave="this.style.color = \''.esc_html($comment_color).'\';"';			
			$css_link = 'style="color:'.esc_html($link_color).'" onMouseOver="this.style.color = \''.esc_html($link_h_color).'\';" onMouseLeave="this.style.color = \''.esc_html($link_color).'\';"';
			$css_category = 'style="color:'.esc_html($link_color).';background-color:'.esc_html($bg_category_color).';" onMouseOver="this.style.color = \''.esc_html($link_h_color).'\';" onMouseLeave="this.style.color = \''.esc_html($link_color).'\';"';
			$css_current_pag_num = 'style="color:'.esc_html($link_h_color).'"';
		endif;

		$return .= '<div class="mpavc-clear"></div>';
		
		$count = 0;
		
		$return .= '<div class="mpavc mpavc-np-v2-vc-element-news '.esc_html($class_load_more).' mpavc-np-v2-news-style2 mpavc-np-v2-vc-news-1-col mpavc-np-v2-vc-news-carousel-item-show-'.esc_html($item_show).' mpavc-np-v2-vc-news-carousel-item-show-900-'.esc_html($item_show_900).' mpavc-np-v2-vc-news-carousel-item-show-600-'.esc_html($item_show_600).' mpavc-np-v2-vc-element-news-'.esc_html($instance).' element-no-padding">';
		
		if($style == ''): $style = ''; endif;
		
		$return .= '<div 	'.$data_value.'
							data-mpavc-news-carousel-owl-items="'.esc_html($item_show).'" 
							data-mpavc-news-carousel-owl-items-900="'.esc_html($item_show_900).'" 
							data-mpavc-news-carousel-owl-items-600="'.esc_html($item_show_600).'" 
							data-mpavc-news-carousel-owl-loop="'.esc_html($loop).'" 
							data-mpavc-news-carousel-owl-autoplay="'.esc_html($autoplay).'" 
							data-mpavc-news-carousel-owl-smart-speed="'.esc_html($smart_speed).'" 
							data-mpavc-news-carousel-owl-navigation="'.esc_html($navigation).'" 
							data-mpavc-news-carousel-owl-pagination="'.esc_html($pagination).'" 
							data-mpavc-news-carousel-owl-margin="'.esc_html($margin).'" 
							data-mpavc-news-carousel-owl-rtl="'.esc_html($rtl).'"			
							class="mpavc-np-v2-vc-element-news-article-container mpavc-np-vc-element-carousel-news mpavc-np-v2-vc-element-carousel-news-pagination-'.esc_html($pagination).' '.esc_html($js_class).'">';
		
		// Start Query Loop
		$loop = new WP_Query($query);		
		
		if($loop) :
			while ( $loop->have_posts() ) : $loop->the_post();
		
				$id_post = get_the_id();
				$link = get_permalink();	

				$return .= '<article class="item-news first-element-news col-xs-12 '.mpavc_animate_class($addon_animate,$effect,$delay).'>';
						
							$return .= '<div class="article-image">';
								if($item_show != 1) :
									$return .= mpavc_get_thumb('mpavc-vc-header-medium');
								else :
									$return .= mpavc_get_thumb('mpavc-blog-medium');							
								endif;
								$return .= mpavc_check_post_format();
								$return .= '<div class="article-category">'.mpavc_get_category($source,$post_type,$css_category).'</div>';
								$return .= '<div class="article-info-top">';
										$return .= '<div class="article-data"  '.$css_date.'><i class="fa fa-calendar-o"></i>'.get_the_date().'</div>';
										$return .= '<div class="article-separator">|</div>';
										$return .= '<div class="article-comments"><i class="fa fa-comment-o"></i>'.mpavc_get_num_comments($css_comment,$css_comment_link).'</div>';
								$return .= '<div class="mpavc-clear"></div></div>';											
							$return .= '</div>';
							$return .= '<div class="article-info">';
								$return .= '<div class="article-info-bottom">';		
										$return .= '<h3 class="article-title"><a href="'.esc_url($link).'" '.$css_title.'>'.get_the_title().'</a></h3>';
										$return .= '<div class="mpavc-clear"></div>';	
								$return .= '</div>';
							$return .= '</div>';
						
				$return .= '</article>';
			
			$count++;
			endwhile;
		endif;	
		
		$return .= '</div>';
		
		$return .= '</div>';
		wp_reset_query();
		return $return;
    }	

	
	/*
	 * Addon Backend
	 */	
    function map_vc_addon() {
        if (function_exists("vc_map")) {

            vc_map(array(
                "name" => esc_html__("News Carousel Posts Style 3", "mpavc"),
                "base" => "mpavc_news_carousel_posts_style3",
                "content_element" => true,
                "show_settings_on_create" => true,
                "category" => esc_html__("MP Addons", "mpavc"),
                'description' => esc_html__('add your posts', 'mpavc'),
                "icon" => MPAVC_URL . '/assets/img/vc-news-carousel-posts-style.png',
                "params" => array(
					array(
							"type" => "textfield",
							"class" => "",
							"heading" => esc_html__("News Display Name",'mpavc'),
							"param_name" => "name",
							"admin_label" => true,				  				  			  				  
					),
					
					// QUERY
					array(
					  "type" => "dropdown",
					  "class" => "",
					  "heading" => esc_html__("Source", 'mpavc'),
					  "param_name" => "source",
					  "value" => array(
										esc_html__('Wordpress Posts','mpavc') 		=> 'post',
										esc_html__('Custom Posts Type','mpavc')  	=> 'post_type',
					   ),
					   "group" => "Query"				   			   
					),

					array(
					  "type" => "dropdown",
					  "class" => "",
					  "heading" => esc_html__("All Posts/Sticky Posts", 'mpavc'),
					  "param_name" => "news_source",
					  "value" => array(
										esc_html__('All Posts','mpavc') 		 		=> 'all_posts',
										esc_html__('Only Sticky Posts','mpavc')  	=> 'sticky_posts',
					   ),
					   "group" => "Query",
					  "dependency" => array(
								'element' => 'source',
								'value' => array( 'post' )
					  ),					   				   			   
					),

					array(
					  "type" => "posttypes", 
					  "class" => "",
					  "heading" => esc_html__("Select Post Type Source",'mpavc'),
					  "param_name" => "posts_type",
					  "group" => "Query",
					  "dependency" => array(
								'element' => 'source',
								'value' => array( 'post_type' )
					  ),					  				  					  				  			  				  
					),
					array(
					  "type" => "checkbox", 
					  "class" => "",
					  "heading" => esc_html__("Categories",'mpavc'),
					  "param_name" => "categories",
					  "group" => "Query", 
					  "value" => mpavc_get_category_array(),	  
					  "dependency" => array(
								'element' => 'source',
								'value' => array( 'post' )
					  ),				  					  				  					  				  			  				  
					),				
					
					
					array(
					  "type" => "textfield", 
					  "class" => "",
					  "heading" => esc_html__("Categories Post Type",'mpavc'),
					  "param_name" => "categories_post_type",
					  "description" => esc_html__("Write Categories slug separate by comma(,) for example: cat-slug1, cat-slug2, cat-slug3 (Leave empty for all categories)","mpavc"),
					  "group" => "Query",
					  "dependency" => array(
								'element' => 'source',
								'value' => array( 'post_type' )
					  ),				  					  				  					  				  			  				  
					),

					array(
					  "type" => "dropdown",
					  "class" => "",
					  "heading" => esc_html__("Order", 'mpavc'),
					  "param_name" => "order",
					  "value" => array(
										esc_html__('DESC','mpavc')  	=> 'DESC',
										esc_html__('ASC','mpavc') 	=> 'ASC'
										
					   ),
					   "group" => "Query"				   			   
					),

					array(
					  "type" => "dropdown",
					  "class" => "",
					  "heading" => esc_html__("Order By", 'mpavc'),
					  "param_name" => "orderby",
					  "value" => array(
										esc_html__('Date','mpavc') 				=> 'date',
										esc_html__('ID','mpavc')  				=> 'ID',
										esc_html__('Author','mpavc') 			=> 'author',
										esc_html__('Title','mpavc')  			=> 'title',
										esc_html__('Name','mpavc') 				=> 'name',
										esc_html__('Modified','mpavc')  		=> 'modified',
										esc_html__('Parent','mpavc') 			=> 'parent',
										esc_html__('Rand','mpavc')  			=> 'rand',
										esc_html__('Comments Count','mpavc')  	=> 'comment_count',
										esc_html__('Views','mpavc')				=> 'views',
										esc_html__('None','mpavc')  			=> 'none',																																													
					   ),
					   "group" => "Query"				   			   
					),												

					array(
					  "type" => "textfield", 
					  "class" => "",
					  "heading" => esc_html__("Number Posts",'mpavc'),
					  "param_name" => "num_posts",
					  "description" => "ex 10",
					  "group" => "Query",					  				  					  				  			  				  
					),
			
					// Carousel
						array(
						  "type" => "dropdown",
						  "class" => "",
						  "heading" => esc_html__("Number Item Show", 'mpavc'),
						  "param_name" => "item_show",
						  "value" => array(
											esc_html__('1','mpavc') 	=> '1',
											esc_html__('2','mpavc')  	=> '2',
											esc_html__('3','mpavc') 	=> '3',
											esc_html__('4','mpavc')  	=> '4',																										
											esc_html__('5','mpavc')  	=> '5'																										
						   ),
						   "group" => "Carousel"						   
						),				
						array(
						  "type" => "dropdown",
						  "class" => "",
						  "heading" => esc_html__("Item Show for content between 600px to 900px ", 'mpavc'),
						  "param_name" => "item_show_900",
						  "value" => array(
											esc_html__('1','mpavc') 	=> '1',
											esc_html__('2','mpavc')  	=> '2',
											esc_html__('3','mpavc') 	=> '3',
											esc_html__('4','mpavc')  	=> '4',
											esc_html__('5','mpavc')  	=> '5'										
						   ),
						   "group" => "Carousel"						   
						),					
						array(
						  "type" => "dropdown",
						  "class" => "",
						  "heading" => esc_html__("Item Show for content between 0px to 599px ", 'mpavc'),
						  "param_name" => "item_show_600",
						  "value" => array(
											esc_html__('1','mpavc') 	=> '1',
											esc_html__('2','mpavc')  	=> '2'											
						   ),
						   "group" => "Carousel"						   
						),
						array(
						  "type" => "dropdown",
						  "class" => "",
						  "heading" => esc_html__("Loop", 'mpavc'),
						  "param_name" => "loop",
						  "value" => array(
											esc_html__('Off','mpavc')  	=> 'false',
											esc_html__('On','mpavc') 	=> 'true' 
																																					
						   ),
						   "group" => "Carousel"						   
						),						
						array(
							  "type" => "textfield",
							  "class" => "",
							  "heading" => esc_html__("Autoplay",'mpavc'),
							  "param_name" => "autoplay",
							  "description" => "ex 2000 or Leave empty for default",
							  "group" => "Carousel"							  
						),
						array(
							  "type" => "textfield",
							  "class" => "",
							  "heading" => esc_html__("Speed",'mpavc'),
							  "param_name" => "smart_speed",
							  "description" => "ex 2000 or Leave empty for default",
							  "group" => "Carousel"							  
						),						
						array(
							  "type" => "textfield",
							  "class" => "",
							  "heading" => esc_html__("Margin between Items",'mpavc'),
							  "param_name" => "margin",
							  "description" => "empty to disable. Or for example: 10",				  					  
							  "value" => '0',
							  "group" => "Carousel"							  
						),						
						 array(
						  "type" => "dropdown",
						  "class" => "",
						  "heading" => esc_html__("Navigation", 'mpavc'),
						  "param_name" => "navigation",
						  "value" => array(
											esc_html__('Show','mpavc') 		=> 'true', 
											esc_html__('Hidden','mpavc')  	=> 'false'																										
						   ),
						  "group" => "Carousel"						   
						),						
						 array(
						  "type" => "dropdown",
						  "class" => "",
						  "heading" => esc_html__("Pagination", 'mpavc'),
						  "param_name" => "pagination",
						  "value" => array(
											esc_html__('Show','mpavc') 		=> 'true', 
											esc_html__('Hidden','mpavc')  	=> 'false'																										
						   ),
						   "group" => "Carousel"						   
						),													
					
					// STYLE					
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Style", 'mpavc'),
						"param_name" => "custom_style",
						"value" => array(
										esc_html__('Off','mpavc') 	=> 'off',
										esc_html__('On','mpavc') 	=> 'on'
										
						),
						"group" => "Style"
					),				
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Title Color", 'mpavc'),
						"param_name" => "title_color",
						"value" => '#333333',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Text Color", 'mpavc'),
						"param_name" => "text_color",
						"value" => '#747474',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Date Color", 'mpavc'),
						"param_name" => "date_color",
						"value" => '#AAAAAA',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Comment Color", 'mpavc'),
						"param_name" => "comment_color",
						"value" => '#FFFFFF',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Background Category Color", 'mpavc'),
						"param_name" => "bg_category_color",
						"value" => '#000000',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),					
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Link Color", 'mpavc'),
						"param_name" => "link_color",
						"value" => '#c9564c',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Link Hover Color", 'mpavc'),
						"param_name" => "link_h_color",
						"value" => '#e7685d',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),									
						array(
							"type" => "colorpicker",
							"class" => "",
							"heading" => esc_html__("Navigation/Pagination Carousel Color", 'mpavc'),
							"param_name" => "nav_color",
							"value" => '#333333',
							"dependency" => array(
									"element" => "custom_style",
									"value" => array( "on" )
							),
							"group" => "Style"				  
						),
						array(
							"type" => "colorpicker",
							"class" => "",
							"heading" => esc_html__("Navigation/Pagination Carousel Hover Color", 'mpavc'),
							"param_name" => "nav_h_color",
							"value" => '#333333',
							"dependency" => array(
									"element" => "custom_style",
									"value" => array( "on" )
							),
							"group" => "Style"				  
						),						
						array(
							"type" => "colorpicker",
							"class" => "",
							"heading" => esc_html__("Navigation Carousel Background Color", 'mpavc'),
							"param_name" => "nav_bg_color",
							"value" => '#FFFFFF',
							"dependency" => array(
									"element" => "custom_style",
									"value" => array( "on" )
							),
							"group" => "Style"				  
						),
						array(
							"type" => "colorpicker",
							"class" => "",
							"heading" => esc_html__("Navigation Carousel Background Hover Color", 'mpavc'),
							"param_name" => "nav_bg_h_color",
							"value" => '#FFFFFF',
							"dependency" => array(
									"element" => "custom_style",
									"value" => array( "on" )
							),
							"group" => "Style"				  
						),									
					// ANIMATION								  							  		  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate", 'mpavc'),
						"param_name" => "addon_animate",
						"value" => array(
										esc_html__('Off','mpavc') 	=> 'off',
										esc_html__('On','mpavc') 	=> 'on'
										
						),					
						"group" => "Animation"
					),			  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate Effects", 'mpavc'),
						"param_name" => "effect",
						"value" => mpavc_animation_effect(),
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"group" => "Animation"				   
					),				  
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Animate Delay (ms)",'mpavc'),
						"param_name" => "delay",
						"description" => "ex 1000",					  
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"value" => "0",
						"group" => "Animation"					  
					),
                ),
            ));


        }
    }

} // End Class

if (class_exists('WPBakeryShortCode')) {
    class WPBakeryShortCode_MPAVC_News_Carousel_Posts_Style3 extends WPBakeryShortCode {
    }
}

// Initialize Element Class
if (class_exists('MPAVC_News_Carousel_Posts_Style3')) {
    new MPAVC_News_Carousel_Posts_Style3();
}

