<?php

/*
Addon: Separator
*/

class MPAVC_Separator {

	/*
	 * Contruct
	 */
    public function __construct() {

        add_action('wp_enqueue_scripts', array($this, 'load_scripts'));

        add_shortcode('mpavc_separator', array($this, 'shortcode_addon_func'));

        add_action('init', array($this, 'map_vc_addon'));

    }

    function load_scripts() {
		
		wp_enqueue_style( 'bootstrap' );
        wp_enqueue_style( 'mpavc-style' );
		wp_enqueue_style( 'font-awesome' );
		wp_enqueue_style( 'animations' );
		wp_enqueue_script( 'appear' );
		wp_enqueue_script( 'animations' );
		
    }
	
	/*
	 * Addon View
	 */
    public function shortcode_addon_func($atts, $content = null, $tag) {
		static $instance;
		$instance++;
		
        $separator = '';

        extract(shortcode_atts(array(

            'separator_type' 	=> 'mpavc-separator-hline',
			'display'			=> 'mpavc-inline-block',
			'height'			=> '14px',
			'custom_style'		=> 'off',
			'separator_color'	=> '#FFFFFF',
			'separator_padding'	=> '',
			'addon_animate'		=> 'off',
			'effect'			=> 'fade-in',
			'delay'				=> '0',
			

        ), $atts));

            $separator_type		= esc_html($separator_type);
			$display			= esc_html($display);
			$height				= esc_html($height);
			$custom_style		= esc_html($custom_style);
			$separator_color	= esc_html($separator_color);
			$separator_padding	= esc_html($separator_padding);
			$addon_animate		= esc_html($addon_animate);
			$effect				= esc_html($effect);
			$delay				= esc_html($delay);



		if($custom_style == 'on') :
			$css_separator = 'style="font-size:'.esc_html($height).';color:'.esc_html($separator_color).';padding:'.esc_html($separator_padding).'"';
		else :
			$css_separator = 'style="font-size:'.esc_html($height).'"';
		endif;

		
        $output = '<span class="mpavc mpavc-separator '.esc_html($display).' '.esc_html($separator_type).' mpavc-separator-'.esc_html($instance).mpavc_animate_class($addon_animate,$effect,$delay).' '.$css_separator.'>';
        $output .= '</span>';

        return $output;
    }	

	
	/*
	 * Addon Backend
	 */	
    function map_vc_addon() {
        if (function_exists("vc_map")) {

            vc_map(array(
                "name" => esc_html__("Text Separator", "mpavc"),
                "base" => "mpavc_separator",
                "content_element" => true,
                "show_settings_on_create" => true,
                "category" => esc_html__("MP Addons", "mpavc"),
                'description' => esc_html__('Add separator from addons', 'mpavc'),
                "icon" => MPAVC_URL . '/assets/img/vc-separator.png',
                "params" => array(
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Separator Format", 'mpavc'),
						"param_name" => "separator_type",
						"value" => array(
									esc_html__('Line','mpavc') 			=> 'mpavc-separator-hline',
									esc_html__('Vertical Line','mpavc') => 'mpavc-separator-vline',
									esc_html__('Point','mpavc') 		=> 'mpavc-separator-point',										
						)
					),
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Size",'mpavc'),
						"param_name" => "height",
						"description" => "14px",
						"default"	=> "14px",				  
					),						
					// STYLE
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Display", 'mpavc'),
						"param_name" => "display",
						"value" => array(
										esc_html__('Inline','mpavc') 	=> 'mpavc-inline-block',
										esc_html__('Block','mpavc') 	=> 'mpavc-block'
										
						),
						"group" => "Style"
					),						
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Style", 'mpavc'),
						"param_name" => "custom_style",
						"value" => array(
										esc_html__('Off','mpavc') 	=> 'off',
										esc_html__('On','mpavc') 	=> 'on'
										
						),
						"group" => "Style"
					),					
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Separator Color", 'mpavc'),
						"param_name" => "separator_color",
						"value" => '#FFFFFF',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),					
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Padding",'mpavc'),
						"param_name" => "separator_padding",
						"description" => "ex: 0 5px",					  
						"dependency" => array(
							"element" => "custom_style",
							"value" => array( "on" )
						),
						"group" => "Style"					  
					),					
					
					
					// ANIMATION								  							  		  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate", 'mpavc'),
						"param_name" => "addon_animate",
						"value" => array(
										esc_html__('Off','mpavc') 	=> 'off',
										esc_html__('On','mpavc') 	=> 'on'
										
						),
						"group" => "Animation"
					),			  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate Effects", 'mpavc'),
						"param_name" => "effect",
						"value" => mpavc_animation_effect(),
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"group" => "Animation"				   
					),				  
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Animate Delay (ms)",'mpavc'),
						"param_name" => "delay",
						"description" => "ex 1000",					  
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"value" => "0",
						"group" => "Animation"					  
					),
                ),
            ));


        }
    }

} // End Class

if (class_exists('WPBakeryShortCode')) {
    class WPBakeryShortCode_MPAVC_Separator extends WPBakeryShortCode {
    }
}

// Initialize Element Class
if (class_exists('MPAVC_Separator')) {
    new MPAVC_Separator();
}

