<?php

/*
Addon: Social
*/

class MPAVC_Social {

	/*
	 * Contruct
	 */
    public function __construct() {

        add_action('wp_enqueue_scripts', array($this, 'load_scripts'));
        add_shortcode('mpavc_social', array($this, 'shortcode_addon_func'));
        add_shortcode('mpavc_social_item', array($this, 'child_shortcode_addon_func'));
        add_action('init', array($this, 'map_vc_addon'));
        add_action('init', array($this, 'map_child_vc_addon'));

    }

    function load_scripts() {
		
		wp_enqueue_style( 'bootstrap' );
        wp_enqueue_style( 'mpavc-style' );
		wp_enqueue_style( 'font-awesome' );
		wp_enqueue_style( 'animations' );
		wp_enqueue_script( 'appear' );
		wp_enqueue_script( 'animations' );
		
    }

	/*
	 * Addon View
	 */
    public function shortcode_addon_func($atts, $content = null, $tag) {
		static $instance;
		$instance++;
		
        extract(shortcode_atts(array(
            //'social_style' 	=> 'style1',
			'display'	   	=> 'mpavc-inline-block',
			'custom_style' 	=> 'off',
			'icon_color'	=> '#FFFFFF',
			'icon_h_color'	=> '#333333',
			'font_size'		=> '10px',
			'padding'		=> '5px'

        ), $atts));

		if($custom_style == 'on') :
		
			$css_style_to_append = "<style>
			.mpavc-social-".esc_html($instance)." span a { color:".esc_html($icon_color)."; font-size:".esc_html($font_size)."; margin-right:".esc_html($padding).";}
			.mpavc-social-".esc_html($instance)." span a:hover { color:".esc_html($icon_h_color)."; }
			</style>";
			$data_value = 'data-mpavc-custom-css="'.$css_style_to_append.'"';
			$js_class = 'mpavc-custom-js';
		
		else :

			$js_class = $data_value = '';

		endif;
	
			$output = '<div '.$data_value.' class="mpavc mpavc-social mpavc-social-'.esc_html($instance).' '.esc_html($js_class).' '.esc_html($social_style).' '.esc_html($display).'">'.do_shortcode($content).'</div>';

        return $output;
    }
	
	/*
	 * Addon Child View
	 */
    public function child_shortcode_addon_func($atts, $content = null, $tag) {
		static $instance;
		$instance++;
		
        $date = '';

        extract(shortcode_atts(array(

            'social_icon' 	=> '',
			'social_url'	=> '',
			'social_target'	=> '_self',
			'addon_animate'	=> 'off',
			'effect'		=> 'fade-in',
			'delay'			=> '0',
			
        ), $atts));
		
        $output = '<span class="mpavc-social-item mpavc-social-item-'.$instance.mpavc_animate_class($addon_animate,$effect,$delay).'>';
			$output .= '<a href="'.esc_url($social_url).'" target="'.esc_html($social_target).'"><i class="'.esc_html($social_icon).'"></i></a>';
        $output .= '</span>';

        return $output;
    }	

		/*
	 * Addon Child Backend
	 */	
    function map_vc_addon() {
        if (function_exists("vc_map")) {
            vc_map(array(
                "name" => esc_html__("Add your Social", "mpavc"),
                "base" => "mpavc_social",
                "content_element" => true,
                "as_parent" => array('only' => 'mpavc_social_item'),
				"show_settings_on_create" => true,
				"is_container" => true,
				"js_view" => 'VcColumnView',
                "category" => esc_html__("MP Addons", "mpavc"),
                "icon" => MPAVC_URL . '/assets/img/vc-add-your-social.png',
                "params" => array(
						array(
							"type" => "dropdown",
							"class" => "",
							"heading" => esc_html__("Display", 'mpavc'),
							"param_name" => "display",
							"value" => array(
											esc_html__('Inline','mpavc') 	=> 'mpavc-inline-block',
											esc_html__('Block','mpavc') 	=> 'mpavc-block'
											
							),
						),
						// STYLE					
						array(
							"type" => "dropdown",
							"class" => "",
							"heading" => esc_html__("Style", 'mpavc'),
							"param_name" => "custom_style",
							"value" => array(
											esc_html__('Off','mpavc') 	=> 'off',
											esc_html__('On','mpavc') 	=> 'on'
											
							),
							"group" => "Style"
						),					
						array(
							"type" => "colorpicker",
							"class" => "",
							"heading" => esc_html__("Icon Color", 'mpavc'),
							"param_name" => "icon_color",
							"value" => '#FFFFFF',
							"dependency" => array(
									'element' => 'custom_style',
									'value' => array( 'on' )
							),
							"group" => "Style"				  
						),					
						array(
							"type" => "colorpicker",
							"class" => "",
							"heading" => esc_html__("Icon Hover Color", 'mpavc'),
							"param_name" => "icon_h_color",
							"value" => '#333333',
							"dependency" => array(
									"element" => "custom_style",
									"value" => array( "on" )
							),
							"group" => "Style"				  
						),					
						array(
							"type" => "textfield",
							"class" => "",
							"heading" => esc_html__("Font size",'mpavc'),
							"param_name" => "font_size",
							"description" => "ex: 10px",					  
							"dependency" => array(
									"element" => "custom_style",
									"value" => array( "on" )
							),
							"value" => "10px",
							"group" => "Style"					  
						),
						array(
							"type" => "textfield",
							"class" => "",
							"heading" => esc_html__("Padding From Social",'mpavc'),
							"param_name" => "padding",
							"description" => "ex: 5px",					  
							"dependency" => array(
									"element" => "custom_style",
									"value" => array( "on" )
							),
							"value" => "5px",
							"group" => "Style"					  
						),							
				),
            ));			
		}
	}
	
	/*
	 * Addon Child Backend
	 */	
    function map_child_vc_addon() {
        if (function_exists("vc_map")) {

            vc_map(array(
                "name" => esc_html__("Add your Social", "mpavc"),
                "base" => "mpavc_social_item",
                "content_element" => true,
                "as_child" => array('only' => 'mpavc_social'),
                "category" => esc_html__("MP Addons", "mpavc"),
                "icon" => 'addon',
                "params" => array(					
					array(
						"type" => "iconpicker",
						"heading" => esc_html__( "Add Social Icon", "mpavc" ),
						"param_name" => "social_icon",
						"admin_label" => true,
						"settings" => array(
							"emptyIcon" 	=> false,
							"type" 			=> "fontawesome",
							"iconsPerPage" 	=> 200,
						),						
						"description" => esc_html__( "Select icon from library.", "mpavc" ),
					),
					// LINK				
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Url",'mpavc'),
						"param_name" => "social_url",
						"description" => esc_html__('Social Link','mpavc'),
						"group" => "Link"
					),
									
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Target", 'mpavc'),
						"param_name" => "social_target",
						"value" => array(
									esc_html__('Self (Same Window)','mpavc') => '_self',
									esc_html__('Blank (New Window)','mpavc') => '_blank'
									
						),
						"group" => "Link"
					),					
					// ANIMATION								  							  		  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate", 'mpavc'),
						"param_name" => "addon_animate",
						"value" => array(
										esc_html__('Off','mpavc') 	=> 'off',
										esc_html__('On','mpavc') 	=> 'on'
										
						),
						"group" => "Animation"
					),			  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate Effects", 'mpavc'),
						"param_name" => "effect",
						"value" => mpavc_animation_effect(),
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"group" => "Animation"				   
					),				  
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Animate Delay (ms)",'mpavc'),
						"param_name" => "delay",
						"description" => "ex 1000",					  
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"value" => "0",
						"group" => "Animation"					  
					),
                ),
            ));


        }
    }

} // End Class


if (class_exists('WPBakeryShortCodesContainer')) {
    class WPBakeryShortCode_mpavc_social extends WPBakeryShortCodesContainer {
    }
}

if (class_exists('WPBakeryShortCode')) {
    class WPBakeryShortCode_mpavc_social_item extends WPBakeryShortCode {
    }
}

// Initialize Element Class
if (class_exists('MPAVC_Social')) {
    new MPAVC_Social();
}