<?php

/*
Addon: Team_Style2
*/

class MPAVC_Team_Style2 {

	/*
	 * Contruct
	 */
    public function __construct() {

        add_action('wp_enqueue_scripts', array($this, 'load_scripts'));
        add_shortcode('mpavc_team_style2', array($this, 'shortcode_addon_func'));
        add_shortcode('mpavc_team_style2_item', array($this, 'child_shortcode_addon_func'));
        add_action('init', array($this, 'map_vc_addon'));
        add_action('init', array($this, 'map_child_vc_addon'));

    }

    function load_scripts() {
		
		wp_enqueue_style( 'bootstrap' );
        wp_enqueue_style( 'mpavc-style' );
		wp_enqueue_style( 'font-awesome' );
		wp_enqueue_style( 'animations' );
		wp_enqueue_script( 'appear' );
		wp_enqueue_script( 'animations' );
		
    }

	/*
	 * Addon View
	 */
    public function shortcode_addon_func($atts, $content = null, $tag) {
		static $instance;
		$instance++;
		
        extract(shortcode_atts(array(
			'columns'	=> '1',
			'custom_style' 			=> 'off',
			'title_color'			=> '#FFFFFF',
			'role_color'			=> '#000000',
			'social_color'			=> '#FFFFFF',
			'h_color'				=> '#333333',

        ), $atts));

		if($custom_style == 'on') :
		
			$css_style_to_append = "<style>
			.mpavc-team-style2-".esc_html($instance)." .mpavc-team-name, 
			.mpavc-team-style2-".esc_html($instance)." .mpavc-team-container-wrap span.mpavc-team-name { color:".esc_html($title_color).";}
			.mpavc-team-style2-".esc_html($instance)." .mpavc-team-container-wrap span.mpavc-team-role { color:".esc_html($role_color).";}
			.mpavc-team-style2-".esc_html($instance)." .mpavc-team-social-container a { color:".esc_html($social_color).";}
			.mpavc-team-style2-".esc_html($instance)." a:hover { color:".esc_html($h_color)."; }
			</style>";
			$data_value = 'data-mpavc-custom-css="'.$css_style_to_append.'"';
			$js_class = 'mpavc-custom-js';
		
		else :

			$js_class = $data_value = '';

		endif;
	
			$output = '<div '.$data_value.' class="mpavc mpavc-team-style2 mpavc-team-col-'.esc_html($columns).' mpavc-team-style2-'.esc_html($instance).' '.esc_html($js_class).' '.esc_html($team_style2_style).' '.esc_html($display).'">'.do_shortcode($content).'<div class="mpavc-clear"></div></div>';

        return $output;
    }
	
	/*
	 * Addon Child View
	 */
    public function child_shortcode_addon_func($atts, $content = null, $tag) {
		static $instance;
		$instance++;

        extract(shortcode_atts(array(

            'image_user' 	=> '',
			'name'			=> '',
			'role'			=> '',
			'social'		=> 'on',
			'social_target'	=> '_blank',
			'social_list'	=> '',
			'addon_animate'	=> 'off',
			'effect'		=> 'fade-in',
			'delay'			=> '0',			
			
        ), $atts));
		
		$elements = json_decode(urldecode($social_list));
		
		$team_image_array = wp_get_attachment_image_src( $image_user, 'large');

        $output = '<div class="mpavc-team mpavc-item-'.esc_html($instance).mpavc_animate_class($addon_animate,$effect,$delay).'>';
			$output .= '<div class="mpavc-team-container" style="background-image:url('.esc_url($team_image_array[0]).');">
							<div class="mpavc-team-container-wrap">
								<span class="mpavc-team-name">'.esc_html($name).'</span>
								<span class="mpavc-team-role">'.esc_html($role).'</span>';
			if($elements) :					
				$output .= '<div class="mpavc-team-social-container">';
						foreach ( $elements as $element ) {					
							$output .= '<a href="'.esc_url($element->social_url).'" class="'.esc_html($element->social_icon).'" target="'.esc_html($target).'"></a>';			
						}        
				$output .= '</div>';
			endif;
			$output .= '</div><div class="mpavc-team-pattern"></div></div></div>';

        return $output;
    }	

		/*
	 * Addon Child Backend
	 */	
    function map_vc_addon() {
        if (function_exists("vc_map")) {
            vc_map(array(
                "name" => esc_html__("Team Style 2", "mpavc"),
                "base" => "mpavc_team_style2",
                "content_element" => true,
                "as_parent" => array('only' => 'mpavc_team_style2_item'),
				"show_settings_on_create" => true,
				"is_container" => true,
				"js_view" => 'VcColumnView',
                "category" => esc_html__("MP Addons", "mpavc"),
                "icon" => MPAVC_URL . '/assets/img/vc-team-style.png',
                "params" => array(	
						array(
							"type" => "dropdown",
							"class" => "",
							"heading" => esc_html__("Columns", 'mpavc'),
							"param_name" => "columns",
							"value" => array(
											esc_html__('1','mpavc') 	=> '1',
											esc_html__('2','mpavc') 	=> '2',
											esc_html__('3','mpavc') 	=> '3',
											esc_html__('4','mpavc') 	=> '4',				
							),
						),					
						// STYLE					
						array(
							"type" => "dropdown",
							"class" => "",
							"heading" => esc_html__("Style", 'mpavc'),
							"param_name" => "custom_style",
							"value" => array(
											esc_html__('Off','mpavc') 	=> 'off',
											esc_html__('On','mpavc') 	=> 'on'
											
							),
							"group" => "Style"
						),
						array(
							"type" => "colorpicker",
							"class" => "",
							"heading" => esc_html__("Title Color", 'mpavc'),
							"param_name" => "title_color",
							"value" => '#FFFFFF',
							"dependency" => array(
									'element' => 'custom_style',
									'value' => array( 'on' )
							),
							"group" => "Style"				  
						),
						array(
							"type" => "colorpicker",
							"class" => "",
							"heading" => esc_html__("Role Color", 'mpavc'),
							"param_name" => "role_color",
							"value" => '#000000',
							"dependency" => array(
									'element' => 'custom_style',
									'value' => array( 'on' )
							),
							"group" => "Style"				  
						),
						array(
							"type" => "colorpicker",
							"class" => "",
							"heading" => esc_html__("Social Color", 'mpavc'),
							"param_name" => "social_color",
							"value" => '#FFFFFF',
							"dependency" => array(
									'element' => 'custom_style',
									'value' => array( 'on' )
							),
							"group" => "Style"				  
						),					
						array(
							"type" => "colorpicker",
							"class" => "",
							"heading" => esc_html__("Social Hover Color", 'mpavc'),
							"param_name" => "h_color",
							"value" => '#333333',
							"dependency" => array(
									"element" => "custom_style",
									"value" => array( "on" )
							),
							"group" => "Style"				  
						)		
				),
            ));			
		}
	}
	
	/*
	 * Addon Child Backend
	 */	
    function map_child_vc_addon() {
        if (function_exists("vc_map")) {

            vc_map(array(
                "name" => esc_html__("Member Team", "mpavc"),
                "base" => "mpavc_team_style2_item",
                "content_element" => true,
                "as_child" => array('only' => 'mpavc_team_style2'),
                "category" => esc_html__("MP Addons", "mpavc"),
                "icon" => 'addon',
                "params" => array(					
					array(
						"type" => "attach_image",
						"class" => "",
						"heading" => esc_html__("Image User Team", 'mpavc'),
						"param_name" => "image_user",
					),
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Name",'mpavc'),
						"param_name" => "name",
					),					
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Role",'mpavc'),
						"param_name" => "role",
					),					
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Social", 'mpavc'),
						"param_name" => "social",
						"value" => array(
									esc_html__('On') => 'on',
									esc_html__('Off','mpavc') => 'off'
									
						),
					),					
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Social Target", 'mpavc'),
						"param_name" => "social_target",
						"value" => array(
									esc_html__('Self (Same Window)','mpavc') => '_self',
									esc_html__('Blank (New Window)','mpavc') => '_blank'
									
						),
						"dependency" => array(
							"element" => "social",
							"value" => array( "on" )
						),
					),
					
					// SOCIAL
					array(
						'type' => 'param_group',
						'value' => '',
						'param_name' => 'social_list',
						'params' => array(
							array(
								"type" => "iconpicker",
								"heading" => esc_html__( "Icon", "mpavc" ),
								"param_name" => "social_icon",
								"settings" => array(
									"emptyIcon" 	=> false,
									"type" 			=> "fontawesome",
									"iconsPerPage" 	=> 200,
								),						
								"description" => esc_html__( "Select icon from library.", "mpavc" ),
							),						
							array(
								'type' => 'textfield',
								'value' => '',
								'heading' => esc_html__("Url Link", 'mpavc'),
								'param_name' => 'social_url',
							)
						),
						"dependency" => array(
							"element" => "social",
							"value" => array( "on" )
						),
						"group" => "Social"
					),
					
					// ANIMATION								  							  		  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate", 'mpavc'),
						"param_name" => "addon_animate",
						"value" => array(
										esc_html__('Off','mpavc') 	=> 'off',
										esc_html__('On','mpavc') 	=> 'on'
										
						),
						"group" => "Animation"
					),			  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate Effects", 'mpavc'),
						"param_name" => "effect",
						"value" => mpavc_animation_effect(),
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"group" => "Animation"				   
					),				  
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Animate Delay (ms)",'mpavc'),
						"param_name" => "delay",
						"description" => "ex 1000",					  
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"value" => "0",
						"group" => "Animation"					  
					),
                ),
            ));


        }
    }

} // End Class


if (class_exists('WPBakeryShortCodesContainer')) {
    class WPBakeryShortCode_mpavc_team_style2 extends WPBakeryShortCodesContainer {
    }
}

if (class_exists('WPBakeryShortCode')) {
    class WPBakeryShortCode_mpavc_team_style2_item extends WPBakeryShortCode {
    }
}

// Initialize Element Class
if (class_exists('MPAVC_Team_Style2')) {
    new MPAVC_Team_Style2();
}