<?php

/*
Addon: Team_Carousel_Style2
*/

class MPAVC_Team_Carousel_Style2 {

	/*
	 * Contruct
	 */
    public function __construct() {

        add_action('wp_enqueue_scripts', array($this, 'load_scripts'));
        add_shortcode('mpavc_team_carousel_style2', array($this, 'shortcode_addon_func'));
        add_shortcode('mpavc_team_carousel_style2_item', array($this, 'child_shortcode_addon_func'));
        add_action('init', array($this, 'map_vc_addon'));
        add_action('init', array($this, 'map_child_vc_addon'));

    }

    function load_scripts() {
		
		wp_enqueue_style( 'bootstrap' );
        wp_enqueue_style( 'mpavc-style' );
		wp_enqueue_style( 'font-awesome' );
		wp_enqueue_style( 'animations' );
		wp_enqueue_style( 'owlcarousel' );
		wp_enqueue_script( 'appear' );
		wp_enqueue_script( 'animations' );
		wp_enqueue_script( 'owlcarousel' );
		
    }

	/*
	 * Addon View
	 */
    public function shortcode_addon_func($atts, $content = null, $tag) {
		static $instance;
		$instance++;
		
        extract(shortcode_atts(array(
			'item_show'				=> '1',
			'item_show_900'			=> '1',
			'item_show_600'			=> '1',
			'loop'					=> 'false',
			'autoplay'				=> '',
			'smart_speed'			=> '2000',
			'navigation'			=> 'true',
			'pagination'			=> 'true',
			'margin'				=> '0',
			'rtl'					=> 'false',
			'custom_style' 			=> 'off',
			'title_color'			=> '#FFFFFF',
			'role_color'			=> '#000000',
			'social_color'			=> '#FFFFFF',
			'h_color'				=> '#333333',
			'nav_color'				=> '#333333',
			'nav_h_color'			=> '#333333',
			'nav_bg_color'			=> '#FFFFFF',
			'nav_bg_h_color'		=> '#FFFFFF',

        ), $atts));

		if($custom_style == 'on') :
		
			$css_style_to_append = "<style>
			.mpavc-team-carousel-style2-".esc_html($instance)." .mpavc-team-name, 
			.mpavc-team-carousel-style2-".esc_html($instance)." .mpavc-team-container-wrap span.mpavc-team-name { color:".esc_html($title_color).";}
			.mpavc-team-carousel-style2-".esc_html($instance)." .mpavc-team-container-wrap span.mpavc-team-role { color:".esc_html($role_color).";}
			.mpavc-team-carousel-style2-".esc_html($instance)." .mpavc-team-social-container a { color:".esc_html($social_color).";}
			.mpavc-team-carousel-style2-".esc_html($instance)." a:hover { color:".esc_html($h_color)."; }
			.mpavc-team-owl-carousel.mpavc-team-carousel-style2-".esc_html($instance).".owl-theme .owl-controls .owl-nav [class*=owl-]:hover { color:".esc_html($nav_h_color)."; background:".esc_html($nav_bg_h_color).";}
			.mpavc-team-owl-carousel.mpavc-team-carousel-style2-".esc_html($instance).".owl-theme .owl-controls .owl-nav [class*=owl-] { color:".esc_html($nav_color)."; background:".esc_html($nav_bg_color).";}
			.mpavc-team-owl-carousel.mpavc-team-carousel-style2-".esc_html($instance).".owl-theme .owl-dots .owl-dot span { background:".esc_html($nav_bg_color).";}
			</style>";
			$data_value = 'data-mpavc-custom-css="'.$css_style_to_append.'"';
			$js_class = 'mpavc-custom-js';
		
		else :

			$js_class = $data_value = '';

		endif;
		
			$output = '<div '.$data_value.'
							data-mpavc-carousel-owl-items="'.esc_html($item_show).'" 
							data-mpavc-carousel-owl-items-900="'.esc_html($item_show_900).'" 
							data-mpavc-carousel-owl-items-600="'.esc_html($item_show_600).'" 
							data-mpavc-carousel-owl-loop="'.esc_html($loop).'" 
							data-mpavc-carousel-owl-autoplay="'.esc_html($autoplay).'" 
							data-mpavc-carousel-owl-smart-speed="'.esc_html($smart_speed).'" 
							data-mpavc-carousel-owl-navigation="'.esc_html($navigation).'" 
							data-mpavc-carousel-owl-pagination="'.esc_html($pagination).'" 
							data-mpavc-carousel-owl-margin="'.esc_html($margin).'" 
							data-mpavc-carousel-owl-rtl="'.esc_html($rtl).'"
							class="mpavc mpavc-team-owl-carousel mpavc-team-carousel-style2 mpavc-team-carousel-col-'.esc_html($item_show).' mpavc-team-carousel-style2-'.esc_html($instance).' '.esc_html($js_class).' '.esc_html($team_carousel_style2_style).' '.esc_html($display).'">'.do_shortcode($content).'</div>';

        return $output;
    }
	
	/*
	 * Addon Child View
	 */
    public function child_shortcode_addon_func($atts, $content = null, $tag) {
		static $instance;
		$instance++;

        extract(shortcode_atts(array(

            'image_user' 	=> '',
			'name'			=> '',
			'role'			=> '',
			'social'		=> 'on',
			'social_target'	=> '_blank',
			'social_list'	=> '',
			'addon_animate'	=> 'off',
			'effect'		=> 'fade-in',
			'delay'			=> '0',			
			
        ), $atts));

		$elements = json_decode(urldecode($social_list));
		
		$team_image_array = wp_get_attachment_image_src( $image_user, 'mpavc-normal');

        $output = '<div class="mpavc-team-carousel mpavc-item-'.esc_html($instance).mpavc_animate_class($addon_animate,$effect,$delay).'>';
			$output .= '<div class="mpavc-team-carousel-container">';
			$output .= '<img src="'.esc_url($team_image_array[0]).'">';
						$output .= '<div class="mpavc-team-carousel-container-wrap">
										<span class="mpavc-team-name">'.esc_html($name).'</span>
										<span class="mpavc-team-role">'.esc_html($role).'</span>';
			if($elements) :					
				$output .= '<div class="mpavc-team-social-container">';
						foreach ( $elements as $element ) {					
							$output .= '<a href="'.esc_url($element->social_url).'" class="'.esc_html($element->social_icon).'" target="'.esc_html($target).'"></a>';			
						}        
				$output .= '</div>';
			endif;
			$output .= '</div><div class="mpavc-team-carousel-pattern"></div></div></div>';

        return $output;
    }	

	/*
	 * Addon Child Backend
	 */	
    function map_vc_addon() {
        if (function_exists("vc_map")) {
            vc_map(array(
                "name" => esc_html__("Team Carousel Style 2", "mpavc"),
                "base" => "mpavc_team_carousel_style2",
                "content_element" => true,
                "as_parent" => array('only' => 'mpavc_team_carousel_style2_item'),
				"show_settings_on_create" => true,
				"is_container" => true,
				"js_view" => 'VcColumnView',
                "category" => esc_html__("MP Addons", "mpavc"),
                "icon" => MPAVC_URL . '/assets/img/vc-team-carousel-style.png',
                "params" => array(	
						array(
						  "type" => "dropdown",
						  "class" => "",
						  "heading" => esc_html__("Number Item Show", 'mpavc'),
						  "param_name" => "item_show",
						  "value" => array(
											esc_html__('1','mpavc') 	=> '1',
											esc_html__('2','mpavc')  	=> '2',
											esc_html__('3','mpavc') 	=> '3',
											esc_html__('4','mpavc')  	=> '4',																										
						   ),					  				   				   			   
						),				
						array(
						  "type" => "dropdown",
						  "class" => "",
						  "heading" => esc_html__("Item Show for content between 600px to 900px ", 'mpavc'),
						  "param_name" => "item_show_900",
						  "value" => array(
											esc_html__('1','mpavc') 	=> '1',
											esc_html__('2','mpavc')  	=> '2',
											esc_html__('3','mpavc') 	=> '3',
											esc_html__('4','mpavc')  	=> '4',																										
						   ),			  				   				   			   
						),					
						array(
						  "type" => "dropdown",
						  "class" => "",
						  "heading" => esc_html__("Item Show for content between 0px to 599px ", 'mpavc'),
						  "param_name" => "item_show_600",
						  "value" => array(
											esc_html__('1','mpavc') 	=> '1',
											esc_html__('2','mpavc')  	=> '2',
											esc_html__('3','mpavc') 	=> '3',
											esc_html__('4','mpavc')  	=> '4',																										
						   ),				  				   				   			   
						),
						array(
						  "type" => "dropdown",
						  "class" => "",
						  "heading" => esc_html__("Loop", 'mpavc'),
						  "param_name" => "loop",
						  "value" => array(
											esc_html__('Off','mpavc')  	=> 'false',
											esc_html__('On','mpavc') 	=> 'true' 
																																					
						   ),					  				   				   			   
						),						
						array(
							  "type" => "textfield",
							  "class" => "",
							  "heading" => esc_html__("Autoplay",'mpavc'),
							  "param_name" => "autoplay",
							  "description" => "ex 2000 or Leave empty for default",				  					  
						),
						array(
							  "type" => "textfield",
							  "class" => "",
							  "heading" => esc_html__("Speed",'mpavc'),
							  "param_name" => "smart_speed",
							  "description" => "ex 2000 or Leave empty for default",				  					  
						),						
						array(
							  "type" => "textfield",
							  "class" => "",
							  "heading" => esc_html__("Margin between Items",'mpavc'),
							  "param_name" => "margin",
							  "description" => "empty to disable. Or for example: 10",				  					  
							  "value" => '0',
						),						
						 array(
						  "type" => "dropdown",
						  "class" => "",
						  "heading" => esc_html__("Navigation", 'mpavc'),
						  "param_name" => "navigation",
						  "value" => array(
											esc_html__('Show','mpavc') 		=> 'true', 
											esc_html__('Hidden','mpavc')  	=> 'false'																										
						   ),				  				   				   			   
						),						
						 array(
						  "type" => "dropdown",
						  "class" => "",
						  "heading" => esc_html__("Pagination", 'mpavc'),
						  "param_name" => "pagination",
						  "value" => array(
											esc_html__('Show','mpavc') 		=> 'true', 
											esc_html__('Hidden','mpavc')  	=> 'false'																										
						   ),				  				   				   			   
						),														
						// STYLE					
						array(
							"type" => "dropdown",
							"class" => "",
							"heading" => esc_html__("Style", 'mpavc'),
							"param_name" => "custom_style",
							"value" => array(
											esc_html__('Off','mpavc') 	=> 'off',
											esc_html__('On','mpavc') 	=> 'on'
											
							),
							"group" => "Style"
						),
						array(
							"type" => "colorpicker",
							"class" => "",
							"heading" => esc_html__("Title Color", 'mpavc'),
							"param_name" => "title_color",
							"value" => '#FFFFFF',
							"dependency" => array(
									'element' => 'custom_style',
									'value' => array( 'on' )
							),
							"group" => "Style"				  
						),
						array(
							"type" => "colorpicker",
							"class" => "",
							"heading" => esc_html__("Role Color", 'mpavc'),
							"param_name" => "role_color",
							"value" => '#000000',
							"dependency" => array(
									'element' => 'custom_style',
									'value' => array( 'on' )
							),
							"group" => "Style"				  
						),
						array(
							"type" => "colorpicker",
							"class" => "",
							"heading" => esc_html__("Social Color", 'mpavc'),
							"param_name" => "social_color",
							"value" => '#FFFFFF',
							"dependency" => array(
									'element' => 'custom_style',
									'value' => array( 'on' )
							),
							"group" => "Style"				  
						),					
						array(
							"type" => "colorpicker",
							"class" => "",
							"heading" => esc_html__("Hover Color", 'mpavc'),
							"param_name" => "h_color",
							"value" => '#333333',
							"dependency" => array(
									"element" => "custom_style",
									"value" => array( "on" )
							),
							"group" => "Style"				  
						),
						array(
							"type" => "colorpicker",
							"class" => "",
							"heading" => esc_html__("Navigation/Pagination Carousel Color", 'mpavc'),
							"param_name" => "nav_color",
							"value" => '#333333',
							"dependency" => array(
									"element" => "custom_style",
									"value" => array( "on" )
							),
							"group" => "Style"				  
						),
						array(
							"type" => "colorpicker",
							"class" => "",
							"heading" => esc_html__("Navigation/Pagination Carousel Hover Color", 'mpavc'),
							"param_name" => "nav_h_color",
							"value" => '#333333',
							"dependency" => array(
									"element" => "custom_style",
									"value" => array( "on" )
							),
							"group" => "Style"				  
						),						
						array(
							"type" => "colorpicker",
							"class" => "",
							"heading" => esc_html__("Navigation Carousel Background Color", 'mpavc'),
							"param_name" => "nav_bg_color",
							"value" => '#FFFFFF',
							"dependency" => array(
									"element" => "custom_style",
									"value" => array( "on" )
							),
							"group" => "Style"				  
						),
						array(
							"type" => "colorpicker",
							"class" => "",
							"heading" => esc_html__("Navigation Carousel Background Hover Color", 'mpavc'),
							"param_name" => "nav_bg_h_color",
							"value" => '#FFFFFF',
							"dependency" => array(
									"element" => "custom_style",
									"value" => array( "on" )
							),
							"group" => "Style"				  
						),							
				),
            ));			
		}
	}
	
	/*
	 * Addon Child Backend
	 */	
    function map_child_vc_addon() {
        if (function_exists("vc_map")) {

            vc_map(array(
                "name" => esc_html__("Member Team", "mpavc"),
                "base" => "mpavc_team_carousel_style2_item",
                "content_element" => true,
                "as_child" => array('only' => 'mpavc_team_carousel_style2'),
                "category" => esc_html__("MP Addons", "mpavc"),
                "icon" => 'addon',
                "params" => array(					
					array(
						"type" => "attach_image",
						"class" => "",
						"heading" => esc_html__("Image User Team", 'mpavc'),
						"param_name" => "image_user",
					),
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Name",'mpavc'),
						"param_name" => "name",
					),					
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Role",'mpavc'),
						"param_name" => "role",
					),					
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Social", 'mpavc'),
						"param_name" => "social",
						"value" => array(
									esc_html__('On') => 'on',
									esc_html__('Off','mpavc') => 'off'
									
						),
					),					
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Social Target", 'mpavc'),
						"param_name" => "social_target",
						"value" => array(
									esc_html__('Self (Same Window)','mpavc') => '_self',
									esc_html__('Blank (New Window)','mpavc') => '_blank'
									
						),
						"dependency" => array(
							"element" => "social",
							"value" => array( "on" )
						),
					),
					
					// SOCIAL
					array(
						'type' => 'param_group',
						'value' => '',
						'param_name' => 'social_list',
						'params' => array(
							array(
								"type" => "iconpicker",
								"heading" => esc_html__( "Icon", "mpavc" ),
								"param_name" => "social_icon",
								"settings" => array(
									"emptyIcon" 	=> false,
									"type" 			=> "fontawesome",
									"iconsPerPage" 	=> 200,
								),						
								"description" => esc_html__( "Select icon from library.", "mpavc" ),
							),						
							array(
								'type' => 'textfield',
								'value' => '',
								'heading' => esc_html__("Url Link", 'mpavc'),
								'param_name' => 'social_url',
							)
						),
						"dependency" => array(
							"element" => "social",
							"value" => array( "on" )
						),
						"group" => "Social"
					),
					
					// ANIMATION								  							  		  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate", 'mpavc'),
						"param_name" => "addon_animate",
						"value" => array(
										esc_html__('Off','mpavc') 	=> 'off',
										esc_html__('On','mpavc') 	=> 'on'
										
						),
						"group" => "Animation"
					),			  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate Effects", 'mpavc'),
						"param_name" => "effect",
						"value" => mpavc_animation_effect(),
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"group" => "Animation"				   
					),				  
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Animate Delay (ms)",'mpavc'),
						"param_name" => "delay",
						"description" => "ex 1000",					  
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"value" => "0",
						"group" => "Animation"					  
					),
                ),
            ));


        }
    }

} // End Class


if (class_exists('WPBakeryShortCodesContainer')) {
    class WPBakeryShortCode_mpavc_team_carousel_style2 extends WPBakeryShortCodesContainer {
    }
}

if (class_exists('WPBakeryShortCode')) {
    class WPBakeryShortCode_mpavc_team_carousel_style2_item extends WPBakeryShortCode {
    }
}

// Initialize Element Class
if (class_exists('MPAVC_Team_Carousel_Style2')) {
    new MPAVC_Team_Carousel_Style2();
}