<?php

/*
Addon: News Posts Style1
*/

class MPAVC_Timeline_Style1 {

	/*
	 * Contruct
	 */
    public function __construct() {

        add_action('wp_enqueue_scripts', array($this, 'load_scripts'));

        add_shortcode('mpavc_timeline_style1', array($this, 'shortcode_addon_func'));

        add_action('init', array($this, 'map_vc_addon'));

    }

    function load_scripts() {
		
		wp_enqueue_style( 'bootstrap' );
        wp_enqueue_style( 'mpavc-style' );
		wp_enqueue_style( 'font-awesome' );
		wp_enqueue_style( 'animations' );
		wp_enqueue_script( 'appear' );
		wp_enqueue_script( 'animations' );
		
    }
	
	/*
	 * Addon View
	 */
    public function shortcode_addon_func($atts, $content = null, $tag) {
		static $instance;
		$instance++;

        extract(shortcode_atts(array(

            'name' 					=> '',
			
			// Query
			'source' 				=> 'post',
			'posts_source' 			=> 'all_posts',
			'posts_type' 			=> '',
			'categories' 			=> '',									
			'categories_post_type' 	=> '',
			'pagination' 			=> 'off',
			'pagination_type' 		=> 'numeric',
			'num_posts_page' 		=> '',
			'num_posts' 			=> '', 	
			'orderby' 				=> 'date',
			'order' 				=> 'DESC',
						
			// Style
            'custom_style' 			=> 'off',
            'title_color' 			=> '#333333',
            'date_color' 			=> '#AAAAAA',
            'h_color' 				=> '#e7685d',
			'line_color'			=> '#000000',
			

			// Animations
			'addon_animate'			=> 'off',
			'effect'				=> 'fade-in',
			'delay'					=> '0',
			

        ), $atts));

		$css_bg_line = 'style="--bg-timeline-color-var:rgba(0,0,0,0.3);"';
		$js_class = $data_value = $css_title = $css_date = '';
		if($custom_style == 'on') :

			$css_bg_line = 'style="--bg-timeline-color-var:'.esc_html($line_color).';"';
			$css_title = 'style="color:'.esc_html($title_color).'" onMouseOver="this.style.color = \''.esc_html($h_color).'\';" onMouseLeave="this.style.color = \''.esc_html($title_color).'\';"';
			$css_date = 'style="color:'.esc_html($date_color).'"';

		endif;

		
		$return = '<div class="mpavc-timeline mpavc-timeline-'.esc_html($instance).' '.esc_html($js_class).'" '.$css_bg_line.' '.$data_value.'>';
		
			$return .= '<section class="mpavc-container">';
		
					// LOOP QUERY
					$query = mpavc_query( $source,
										$posts_source, 
										$posts_type, 
										$categories,
										$categories_post_type, 
										$order, 
										$orderby, 
										'no', 
										$pagination_type,
										$num_posts, 
										$num_posts_page );	
			
					
					// Start Query Loop
					$loop = new WP_Query($query);	
			
					if($loop) :
						while ( $loop->have_posts() ) : $loop->the_post();
					
							$id_post = get_the_id();
							$link = get_permalink(); 
							
							$return .= '<div class="mpavc-timeline-block">';
							
								$return .= '<div class="mpavc-timeline-img">';
									$return .= '<div class="mpavc-timeline-img">';
										$return .= '<div class="mpavc_format_icon mpavc mpavc-icon">';
											$return .= '<span class="fa fa-image">';
											$return .= '</span>';
										$return .= '</div>';
									$return .= '</div>';
								$return .= '</div>';
								
								$return .= '<div class="mpavc-timeline-content">';
									$return .= '<h2><a href="'.get_permalink().'" '.$css_title.'>'.get_the_title().'</a></h2>';
									$return .= '<div class="mpavc-timeline-image">';
										$return .= mpavc_get_thumb('mpavc-header');										
									$return .= '</div>';
									$return .= '<span class="mpavc-date" '.$css_date.'>';
										$return .= get_the_date();
									$return .= '</span>';
								$return .= '</div>';
								
								
								
							$return .= '</div>';
							
							
							
							
						$count++;
						endwhile;
					endif;	
			$return .= '</section>';
		$return .= '<div class="mpavc-clear"></div>';
		$return .= '</div>';
		
		return $return;
    }	

	
	/*
	 * Addon Backend
	 */	
    function map_vc_addon() {
        if (function_exists("vc_map")) {

            vc_map(array(
                "name" => esc_html__("Timeline Style 1", "mpavc"),
                "base" => "mpavc_timeline_style1",
                "content_element" => true,
                "show_settings_on_create" => true,
                "category" => esc_html__("MP Addons", "mpavc"),
                'description' => esc_html__('add your posts', 'mpavc'),
                "icon" => MPAVC_URL . '/assets/img/vc-timeline-style1.png',
                "params" => array(
					array(
							"type" => "textfield",
							"class" => "",
							"heading" => esc_html__("News Display Name",'mpavc'),
							"param_name" => "name",
							"admin_label" => true,				  				  			  				  
					),
					
					// QUERY
					array(
					  "type" => "dropdown",
					  "class" => "",
					  "heading" => esc_html__("Source", 'mpavc'),
					  "param_name" => "source",
					  "value" => array(
										esc_html__('Wordpress Posts','mpavc') 		=> 'post',
										esc_html__('Custom Posts Type','mpavc')  	=> 'post_type',
					   ),
					   "group" => "Query"				   			   
					),

					array(
					  "type" => "dropdown",
					  "class" => "",
					  "heading" => esc_html__("All Posts/Sticky Posts", 'mpavc'),
					  "param_name" => "news_source",
					  "value" => array(
										esc_html__('All Posts','mpavc') 		 		=> 'all_posts',
										esc_html__('Only Sticky Posts','mpavc')  	=> 'sticky_posts',
					   ),
					   "group" => "Query",
					  "dependency" => array(
								'element' => 'source',
								'value' => array( 'post' )
					  ),					   				   			   
					),

					array(
					  "type" => "posttypes", 
					  "class" => "",
					  "heading" => esc_html__("Select Post Type Source",'mpavc'),
					  "param_name" => "posts_type",
					  "group" => "Query",
					  "dependency" => array(
								'element' => 'source',
								'value' => array( 'post_type' )
					  ),					  				  					  				  			  				  
					),
					array(
					  "type" => "checkbox", 
					  "class" => "",
					  "heading" => esc_html__("Categories",'mpavc'),
					  "param_name" => "categories",
					  "group" => "Query", 
					  "value" => mpavc_get_category_array(),	  
					  "dependency" => array(
								'element' => 'source',
								'value' => array( 'post' )
					  ),				  					  				  					  				  			  				  
					),				
					
					
					array(
					  "type" => "textfield", 
					  "class" => "",
					  "heading" => esc_html__("Categories Post Type",'mpavc'),
					  "param_name" => "categories_post_type",
					  "description" => esc_html__("Write Categories slug separate by comma(,) for example: cat-slug1, cat-slug2, cat-slug3 (Leave empty for all categories)","mpavc"),
					  "group" => "Query",
					  "dependency" => array(
								'element' => 'source',
								'value' => array( 'post_type' )
					  ),				  					  				  					  				  			  				  
					),

					array(
					  "type" => "dropdown",
					  "class" => "",
					  "heading" => esc_html__("Order", 'mpavc'),
					  "param_name" => "order",
					  "value" => array(
										esc_html__('DESC','mpavc')  	=> 'DESC',
										esc_html__('ASC','mpavc') 	=> 'ASC'
										
					   ),
					   "group" => "Query"				   			   
					),

					array(
					  "type" => "dropdown",
					  "class" => "",
					  "heading" => esc_html__("Order By", 'mpavc'),
					  "param_name" => "orderby",
					  "value" => array(
										esc_html__('Date','mpavc') 				=> 'date',
										esc_html__('ID','mpavc')  				=> 'ID',
										esc_html__('Author','mpavc') 			=> 'author',
										esc_html__('Title','mpavc')  			=> 'title',
										esc_html__('Name','mpavc') 				=> 'name',
										esc_html__('Modified','mpavc')  			=> 'modified',
										esc_html__('Parent','mpavc') 			=> 'parent',
										esc_html__('Rand','mpavc')  				=> 'rand',
										esc_html__('Comments Count','mpavc')  	=> 'comment_count',
										esc_html__('Views','mpavc')				=> 'views',
										esc_html__('None','mpavc')  				=> 'none',																																													
					   ),
					   "group" => "Query"				   			   
					),												

					array(
					  "type" => "dropdown",
					  "class" => "",
					  "heading" => esc_html__("Pagination", 'mpavc'),
					  "param_name" => "pagination",
					  "value" => array(
										esc_html__('No','mpavc')  						=> 'no',
										esc_html__('Yes','mpavc') 						=> 'yes'
										
					   ),				   
					  "group" => "Query"				   			   
					),

					array(
					  "type" => "textfield", 
					  "class" => "",
					  "heading" => esc_html__("Number Posts",'mpavc'),
					  "param_name" => "num_posts",
					  "description" => "ex 10",
					  "group" => "Query",
					  "dependency" => array(
								'element' => 'pagination',
								'value' => array( 'no' )
					  ),					  				  					  				  			  				  
					),

					array(
					  "type" => "dropdown",
					  "class" => "",
					  "heading" => esc_html__("Pagination Type", 'mpavc'),
					  "param_name" => "pagination_type",
					  "value" => array(
										esc_html__('Numeric','mpavc') 		=> 'numeric',
										esc_html__('Normal','mpavc')  		=> 'normal',
					  ),
					  "group" => "Query",
					  "dependency" => array(
								'element' => 'pagination',
								'value' => array( 'yes' )
					  ),				   				   			   
					),

					array(
					  "type" => "textfield", 
					  "class" => "",
					  "heading" => esc_html__("Number Posts For Page",'mpavc'),
					  "param_name" => "num_posts_page",
					  "description" => "ex 10",
					  "group" => "Query",
					  "dependency" => array(
								'element' => 'pagination',
								'value' => array( 'yes' )
					  ),					  				  					  				  			  				  
					),				
					
					// STYLE					
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Style", 'mpavc'),
						"param_name" => "custom_style",
						"value" => array(
										esc_html__('Off','mpavc') 	=> 'off',
										esc_html__('On','mpavc') 	=> 'on'
										
						),
						"group" => "Style"
					),				
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Title Color", 'mpavc'),
						"param_name" => "title_color",
						"value" => '#333333',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Date Color", 'mpavc'),
						"param_name" => "date_color",
						"value" => '#AAAAAA',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),					
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Link Hover Color", 'mpavc'),
						"param_name" => "h_color",
						"value" => '#e7685d',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),						
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Line Color", 'mpavc'),
						"param_name" => "line_color",
						"value" => '#000000',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),													
					// ANIMATION								  							  		  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate", 'mpavc'),
						"param_name" => "addon_animate",
						"value" => array(
										esc_html__('Off','mpavc') 	=> 'off',
										esc_html__('On','mpavc') 	=> 'on'
										
						),
						"dependency" => array(
							"element" => "pagination",
							"value" => array( "no", "yes" )
						),						
						"group" => "Animation"
					),			  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate Effects", 'mpavc'),
						"param_name" => "effect",
						"value" => mpavc_animation_effect(),
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"group" => "Animation"				   
					),				  
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Animate Delay (ms)",'mpavc'),
						"param_name" => "delay",
						"description" => "ex 1000",					  
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"value" => "0",
						"group" => "Animation"					  
					),
                ),
            ));


        }
    }

} // End Class

if (class_exists('WPBakeryShortCode')) {
    class WPBakeryShortCode_MPAVC_Timeline_Style1 extends WPBakeryShortCode {
    }
}

// Initialize Element Class
if (class_exists('MPAVC_Timeline_Style1')) {
    new MPAVC_Timeline_Style1();
}