<?php

/*
Addon: Title Box Style 1
*/

class MPAVC_Title_Box_Style1 {

	/*
	 * Contruct
	 */
    public function __construct() {

        add_action('wp_enqueue_scripts', array($this, 'load_scripts'));

        add_shortcode('mpavc_title_box_style1', array($this, 'shortcode_addon_func'));

        add_action('init', array($this, 'map_vc_addon'));

    }

    function load_scripts() {
		
		wp_enqueue_style( 'bootstrap' );
        wp_enqueue_style( 'mpavc-style' );
		wp_enqueue_style( 'font-awesome' );
		wp_enqueue_style( 'animations' );
		wp_enqueue_script( 'appear' );
		wp_enqueue_script( 'animations' );
		
    }
	
	/*
	 * Addon View
	 */
    public function shortcode_addon_func($atts, $content = null, $tag) {
		static $instance;
		$instance++;
		
        $date = '';

        extract(shortcode_atts(array(

            'title' 				=> '',
            'subtitle' 				=> '',
            'text' 					=> '',
            'custom_style' 			=> 'off',
            'title_color' 			=> '#FFFFFF',
            'subtitle_color' 		=> '#FFFFFF',
            'text_color' 			=> '#333333',
            'title_font_size' 		=> '30px',
            'title_font_weight' 	=> 'normal',
            'subtitle_font_size' 	=> '16px',
            'subtitle_font_weight' 	=> 'normal',
            'text_font_size' 		=> '14px',
            'text_font_weight' 		=> 'normal',			
			'addon_animate'			=> 'off',
			'effect'				=> 'fade-in',
			'delay'					=> '0',
			

        ), $atts));

		if($custom_style == 'on') :
			$css_subtitle 	= 'style="color:'.esc_html($subtitle_color).';font-size:'.esc_html($subtitle_font_size).';font-weight:'.esc_html($subtitle_font_weight).'"';
			$css_title 		= 'style="color:'.esc_html($title_color).';font-size:'.esc_html($title_font_size).';font-weight:'.esc_html($title_font_weight).'"';
			$css_text 		= 'style="color:'.esc_html($text_color).';font-size:'.esc_html($text_font_size).';font-weight:'.esc_html($text_font_weight).'"';
			$css_style_to_append = '<style>.mpavc-title-box-style1-'.esc_html($instance).' .mpavc-subtitle:after { color:'.esc_html($subtitle_color).'; line-height:'.esc_html($subtitle_font_size).';}</style>';
			$data_value = 'data-mpavc-custom-css="'.$css_style_to_append.'"';
			$js_class = 'mpavc-custom-js';			
		else :
			$css_subtitle = $css_title = $css_text = $js_class = $data_value = '';
		endif;

        $output = '<div class="mpavc mpavc-title-box mpavc-title-box-style1 mpavc-title-box-style1-'.esc_html($instance).mpavc_animate_class($addon_animate,$effect,$delay).'>';
			if($text) : $col = '4'; else : $col = '12'; endif;
			
			if(!is_rtl()) :
				
				$output .= '<div class="col-xs-'.esc_html($col).'">';
					if($subtitle) :
						$output .= '<span class="mpavc-subtitle '.esc_html($js_class).'" '.$css_subtitle.' '.$data_value.'>'.esc_html($subtitle).'</span>';
					endif;
					if($title) :
						$output .= '<span class="mpavc-title" '.$css_title.'>'.esc_html($title).'</span>';
					endif;
				$output .= '</div>';
				if($text) : 
					$output .= '<div class="col-xs-8">';
						$output .= '<span class="mpavc-text" '.$css_text.'>'.esc_html($text).'</span>';
					$output .= '</div>';
				endif;
			
			else:
				/*
				 * RTL 
				 */
				 
				if($text) : 
					$output .= '<div class="col-xs-8">';
						$output .= '<span class="mpavc-text" '.$css_text.'>'.esc_html($text).'</span>';
					$output .= '</div>';
				endif;				 
				$output .= '<div class="col-xs-'.esc_html($col).'">';
					if($subtitle) :
						$output .= '<span class="mpavc-subtitle mpavc-rtl" '.$css_subtitle.'>'.esc_html($subtitle).'</span>';
					endif;
					if($title) :
						$output .= '<span class="mpavc-title mpavc-rtl" '.$css_title.'>'.esc_html($title).'</span>';
					endif;
				$output .= '</div>';
			
			endif;	
			
        $output .= '<div class="mpavc-clear"></div></div>';

        return $output;
    }	

	
	/*
	 * Addon Backend
	 */	
    function map_vc_addon() {
        if (function_exists("vc_map")) {

            vc_map(array(
                "name" => esc_html__("Title Box Style 1", "mpavc"),
                "base" => "mpavc_title_box_style1",
                "content_element" => true,
                "show_settings_on_create" => true,
                "category" => esc_html__("MP Addons", "mpavc"),
                'description' => esc_html__('title box', 'mpavc'),
                "icon" => MPAVC_URL . '/assets/img/vc-title-box-style.png',
                "params" => array(
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Title",'mpavc'),
						"param_name" => "title",	
					),
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Sub Title",'mpavc'),
						"param_name" => "subtitle",	
					),					
					array(
						"type" => "textarea",
						"class" => "",
						"heading" => esc_html__("Text",'mpavc'),
						"param_name" => "text",	
					),					

					// STYLE					
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Style", 'mpavc'),
						"param_name" => "custom_style",
						"value" => array(
										esc_html__('Off','mpavc') 	=> 'off',
										esc_html__('On','mpavc') 	=> 'on'
										
						),
						"group" => "Style"
					),					
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Title Color", 'mpavc'),
						"param_name" => "title_color",
						"value" => '#FFFFFF',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Sub Title Color", 'mpavc'),
						"param_name" => "subtitle_color",
						"value" => '#FFFFFF',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),					
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Text Color", 'mpavc'),
						"param_name" => "text_color",
						"value" => '#333333',
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( 'on' )
						),
						"group" => "Style"				  
					),					
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Title Font size",'mpavc'),
						"param_name" => "title_font_size",
						"description" => "ex: 30px",					  
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),
						"value" => "30px",
						"group" => "Style"					  
					),					
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Title Font Weight", 'mpavc'),
						"param_name" => "title_font_weight",
						"value" => array(
										esc_html__('Normal','mpavc') 	=> 'normal',
										esc_html__('Bold','mpavc') 		=> 'bold',
										esc_html__('100','mpavc') 		=> '100',
										esc_html__('200','mpavc') 		=> '200',
										esc_html__('300','mpavc') 		=> '300',
										esc_html__('400','mpavc') 		=> '400',
										esc_html__('500','mpavc') 		=> '500',
										esc_html__('600','mpavc') 		=> '600',
										esc_html__('700','mpavc') 		=> '700',
										esc_html__('800','mpavc') 		=> '800',
										esc_html__('900','mpavc') 		=> '900'
										
						),
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),						
						"group" => "Style"
					),					
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Sub Title Font size",'mpavc'),
						"param_name" => "subtitle_font_size",
						"description" => "ex: 15px",					  
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),
						"value" => "16px",
						"group" => "Style"					  
					),					
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Sub Title Font Weight", 'mpavc'),
						"param_name" => "subtitle_font_weight",
						"value" => array(
										esc_html__('Normal','mpavc') 	=> 'normal',
										esc_html__('Bold','mpavc') 		=> 'bold',
										esc_html__('100','mpavc') 		=> '100',
										esc_html__('200','mpavc') 		=> '200',
										esc_html__('300','mpavc') 		=> '300',
										esc_html__('400','mpavc') 		=> '400',
										esc_html__('500','mpavc') 		=> '500',
										esc_html__('600','mpavc') 		=> '600',
										esc_html__('700','mpavc') 		=> '700',
										esc_html__('800','mpavc') 		=> '800',
										esc_html__('900','mpavc') 		=> '900'
										
						),
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),						
						"group" => "Style"
					),
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Text Font size",'mpavc'),
						"param_name" => "text_font_size",
						"description" => "ex: 14px",					  
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),
						"value" => "14px",
						"group" => "Style"					  
					),					
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Text Font Weight", 'mpavc'),
						"param_name" => "text_font_weight",
						"value" => array(
										esc_html__('Normal','mpavc') 	=> 'normal',
										esc_html__('Bold','mpavc') 		=> 'bold',
										esc_html__('100','mpavc') 		=> '100',
										esc_html__('200','mpavc') 		=> '200',
										esc_html__('300','mpavc') 		=> '300',
										esc_html__('400','mpavc') 		=> '400',
										esc_html__('500','mpavc') 		=> '500',
										esc_html__('600','mpavc') 		=> '600',
										esc_html__('700','mpavc') 		=> '700',
										esc_html__('800','mpavc') 		=> '800',
										esc_html__('900','mpavc') 		=> '900'
										
						),
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),						
						"group" => "Style"
					),										
					// ANIMATION								  							  		  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate", 'mpavc'),
						"param_name" => "addon_animate",
						"value" => array(
										esc_html__('Off','mpavc') 	=> 'off',
										esc_html__('On','mpavc') 	=> 'on'
										
						),
						"group" => "Animation"
					),			  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate Effects", 'mpavc'),
						"param_name" => "effect",
						"value" => mpavc_animation_effect(),
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"group" => "Animation"				   
					),				  
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Animate Delay (ms)",'mpavc'),
						"param_name" => "delay",
						"description" => "ex 1000",					  
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"value" => "0",
						"group" => "Animation"					  
					),
                ),
            ));


        }
    }

} // End Class

if (class_exists('WPBakeryShortCode')) {
    class WPBakeryShortCode_MPAVC_Title_Box_Style1 extends WPBakeryShortCode {
    }
}

// Initialize Element Class
if (class_exists('MPAVC_Title_Box_Style1')) {
    new MPAVC_Title_Box_Style1();
}

