<?php

/*
Addon: Title Box Style 4
*/

class MPAVC_Title_Box_Style4 {

	/*
	 * Contruct
	 */
    public function __construct() {

        add_action('wp_enqueue_scripts', array($this, 'load_scripts'));

        add_shortcode('mpavc_title_box_style4', array($this, 'shortcode_addon_func'));

        add_action('init', array($this, 'map_vc_addon'));

    }

    function load_scripts() {

		wp_enqueue_style( 'bootstrap' );
        wp_enqueue_style( 'mpavc-style' );
		wp_enqueue_style( 'font-awesome' );
		wp_enqueue_style( 'animations' );
		wp_enqueue_script( 'appear' );
		wp_enqueue_script( 'animations' );
		
    }
	
	/*
	 * Addon View
	 */
    public function shortcode_addon_func($atts, $content = null, $tag) {
		static $instance;
		$instance++;
		
        $date = '';

        extract(shortcode_atts(array(

            'title' 				=> '',
            'subtitle' 				=> '',
            'text' 					=> '',
            'separator' 			=> 'none',
            'custom_style' 			=> 'off',
            'title_color' 			=> '',
            'subtitle_color' 		=> '',
            'title_font_size' 		=> '30px',
            'title_font_weight' 	=> 'normal',
            'subtitle_font_size' 	=> '16px',
            'subtitle_font_weight' 	=> 'normal',			
            'separator_color' 		=> '#333333',			
            'separator_width' 		=> '5',			
            'separator_height' 		=> '2px',			
            'separator_padding' 	=> '2px',			
			'addon_animate'			=> 'off',
			'effect'				=> 'fade-in',
			'delay'					=> '0',
			

        ), $atts));

		if($custom_style == 'on') :
			$css_subtitle 	= 'style="color:'.esc_html($subtitle_color).';font-size:'.esc_html($subtitle_font_size).';font-weight:'.esc_html($subtitle_font_weight).'"';
			$css_title 		= 'style="color:'.esc_html($title_color).';font-size:'.esc_html($title_font_size).';font-weight:'.esc_html($title_font_weight).'"';
			$css_separator	= 'style="border-style:'.esc_html($separator).';border-top-width:'.esc_html($separator_height).';border-color:'.esc_html($separator_color).';width:'.esc_html($separator_width).'%;margin:'.esc_html($separator_padding).';"';
		else :
			$css_subtitle = $css_title = $css_text = '';
			$css_separator	= 'style="border-style:'.esc_html($separator).'"';
		endif;

        $output = '<div class="mpavc mpavc-title-box mpavc-title-box-style4 mpavc-title-box-style4-'.esc_html($instance).mpavc_animate_class($addon_animate,$effect,$delay).'>';
							
			$output .= '<div class="col-xs-12">';
				if($subtitle) :
					$output .= '<span class="mpavc-subtitle" '.$css_subtitle.'>'.esc_html($subtitle).'</span>';
				endif;
				if($separator != 'none') :
				    $output .= '<span class="mpavc-separator" '.$css_separator.'></span>';
				endif;
				if($title) :
					$output .= '<span class="mpavc-title" '.$css_title.'>'.esc_html($title).'</span>';
				endif;
			$output .= '</div>';
			
        $output .= '<div class="mpavc-clear"></div></div>';

        return $output;
    }	

	
	/*
	 * Addon Backend
	 */	
    function map_vc_addon() {
        if (function_exists("vc_map")) {

            vc_map(array(
                "name" => esc_html__("Title Box Style 4", "mpavc"),
                "base" => "mpavc_title_box_style4",
                "content_element" => true,
                "show_settings_on_create" => true,
                "category" => esc_html__("MP Addons", "mpavc"),
                'description' => esc_html__('title box', 'mpavc'),
                "icon" => MPAVC_URL . '/assets/img/vc-title-box-style.png',
                "params" => array(
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Title",'mpavc'),
						"param_name" => "title",	
					),
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Sub Title",'mpavc'),
						"param_name" => "subtitle",	
					),				
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Separator Type", 'mpavc'),
						"param_name" => "separator",
						"value" => array(
										esc_html__('Disable (Hidden)','mpavc') 	=> 'none',
										esc_html__('Line','mpavc') 				=> 'solid',
										esc_html__('Duble Line','mpavc') 		=> 'double',
										esc_html__('Dotted','mpavc') 			=> 'dotted',
										esc_html__('Ddashed','mpavc') 			=> 'dashed',										
										esc_html__('Groove','mpavc') 			=> 'groove',
										esc_html__('Ridge','mpavc') 			=> 'ridge',
										esc_html__('Inset','mpavc') 			=> 'inset',
										esc_html__('Outset','mpavc') 			=> 'outset',
										esc_html__('Initial','mpavc') 			=> 'initial',
						)
					),
					
										
					// STYLE					
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Style", 'mpavc'),
						"param_name" => "custom_style",
						"value" => array(
										esc_html__('Off','mpavc') 	=> 'off',
										esc_html__('On','mpavc') 	=> 'on'
										
						),
						"group" => "Style"
					),					
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Title Color", 'mpavc'),
						"param_name" => "title_color",
						"value" => '#FFFFFF',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),			
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Title Font size",'mpavc'),
						"param_name" => "title_font_size",
						"description" => "ex: 30px",					  
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),
						"value" => "30px",
						"group" => "Style"					  
					),					
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Title Font Weight", 'mpavc'),
						"param_name" => "title_font_weight",
						"value" => array(
										esc_html__('Normal','mpavc') 	=> 'normal',
										esc_html__('Bold','mpavc') 		=> 'bold',
										esc_html__('100','mpavc') 		=> '100',
										esc_html__('200','mpavc') 		=> '200',
										esc_html__('300','mpavc') 		=> '300',
										esc_html__('400','mpavc') 		=> '400',
										esc_html__('500','mpavc') 		=> '500',
										esc_html__('600','mpavc') 		=> '600',
										esc_html__('700','mpavc') 		=> '700',
										esc_html__('800','mpavc') 		=> '800',
										esc_html__('900','mpavc') 		=> '900'
										
						),
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),						
						"group" => "Style"
					),
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Sub Title Color", 'mpavc'),
						"param_name" => "subtitle_color",
						"value" => '#FFFFFF',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),						
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Sub Title Font size",'mpavc'),
						"param_name" => "subtitle_font_size",
						"description" => "ex: 16px",					  
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),
						"value" => "16px",
						"group" => "Style"					  
					),					
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Sub Title Font Weight", 'mpavc'),
						"param_name" => "subtitle_font_weight",
						"value" => array(
										esc_html__('Normal','mpavc') 	=> 'normal',
										esc_html__('Bold','mpavc') 		=> 'bold',
										esc_html__('100','mpavc') 		=> '100',
										esc_html__('200','mpavc') 		=> '200',
										esc_html__('300','mpavc') 		=> '300',
										esc_html__('400','mpavc') 		=> '400',
										esc_html__('500','mpavc') 		=> '500',
										esc_html__('600','mpavc') 		=> '600',
										esc_html__('700','mpavc') 		=> '700',
										esc_html__('800','mpavc') 		=> '800',
										esc_html__('900','mpavc') 		=> '900'
										
						),
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),						
						"group" => "Style"
					),

					// SEPARATOR
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Separator Color", 'mpavc'),
						"param_name" => "separator_color",
						"value" => '#333333',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),					
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Separator Width", 'mpavc'),
						"param_name" => "separator_width",
						"value" => array(
										esc_html__('5%','mpavc') 	=> '5',
										esc_html__('10%','mpavc') 	=> '10',
										esc_html__('15%','mpavc') 	=> '15',
										esc_html__('20%','mpavc') 	=> '20',
										esc_html__('25%','mpavc') 	=> '25',
										esc_html__('30%','mpavc') 	=> '30',
										esc_html__('35%','mpavc') 	=> '35',
										esc_html__('40%','mpavc') 	=> '40',
										esc_html__('50%','mpavc') 	=> '50',
										esc_html__('55%','mpavc') 	=> '55',
										esc_html__('60%','mpavc') 	=> '60',
										esc_html__('65%','mpavc') 	=> '65',
										esc_html__('70%','mpavc') 	=> '70',
										esc_html__('75%','mpavc') 	=> '75',
										esc_html__('80%','mpavc') 	=> '80',
										esc_html__('85%','mpavc') 	=> '85',
										esc_html__('90%','mpavc') 	=> '90',
										esc_html__('95%','mpavc') 	=> '95',
										esc_html__('100%','mpavc') 	=> '100',
										
						),
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),						
						"group" => "Style"
					),
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Separator Height",'mpavc'),
						"param_name" => "separator_height",
						"description" => "ex: 2px",					  
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),
						"value" => "2px",
						"group" => "Style"					  
					),	
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Separator Padding",'mpavc'),
						"param_name" => "separator_padding",
						"description" => "ex: 2px",					  
						"dependency" => array(
								"element" => "custom_style",
								"value" => array( "on" )
						),
						"value" => "2px",
						"group" => "Style"					  
					),
					
					// ANIMATION								  							  		  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate", 'mpavc'),
						"param_name" => "addon_animate",
						"value" => array(
										esc_html__('Off','mpavc') 	=> 'off',
										esc_html__('On','mpavc') 	=> 'on'
										
						),
						"group" => "Animation"
					),			  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate Effects", 'mpavc'),
						"param_name" => "effect",
						"value" => mpavc_animation_effect(),
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"group" => "Animation"				   
					),				  
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Animate Delay (ms)",'mpavc'),
						"param_name" => "delay",
						"description" => "ex 1000",					  
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"value" => "0",
						"group" => "Animation"					  
					),
                ),
            ));


        }
    }

} // End Class

if (class_exists('WPBakeryShortCode')) {
    class WPBakeryShortCode_MPAVC_Title_Box_Style4 extends WPBakeryShortCode {
    }
}

// Initialize Element Class
if (class_exists('MPAVC_Title_Box_Style4')) {
    new MPAVC_Title_Box_Style4();
}

