<?php

if (!class_exists('Mpavc_Main')) :

    /**
     * Main Mpavc_Main Class
     *
     */	 
	class Mpavc_Main {

		private static $instance;	
		
        public static function instance() {
            if (!isset(self::$instance) && !(self::$instance instanceof Mpavc_Main)) {

                self::$instance = new Mpavc_Main;

                add_action('plugins_loaded', array(self::$instance, 'load_plugin_textdomain'));

                add_action('plugins_loaded', array(self::$instance, 'includes_files'));

                add_action('plugins_loaded', array(self::$instance, 'include_addons'));

				add_action('wp_enqueue_scripts', array(self::$instance, 'load_general_scripts'));

            }
            return self::$instance;
        }

        /**
         * Load Plugin Text Domain
         */
        public function load_plugin_textdomain() {
			$path = dirname(plugin_basename( __FILE__ )) . '/languages/';
			$loaded = load_plugin_textdomain( 'mpavc', false, $path);
        }		
		
		
        /**
         * Include required files
         *
         */
        public function includes_files() {

            /* Load VC Field Types */
            include_once( plugin_dir_path( __FILE__ ) . 'includes/mpavc_functions.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'includes/mpavc_helper.php' );
			
        }		

        /**
         * Include VC Addons
         *
         */
        public function include_addons() {

			include_once( plugin_dir_path( __FILE__ ) . 'addons/date/class-mpavc-date.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/icon_with_text/class-mpavc-icon-text.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/logo/class-mpavc-logo.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/social/class-mpavc-social.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/separator/class-mpavc-separator.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/title_box/class-mpavc-title-box-style1.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/title_box/class-mpavc-title-box-style2.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/title_box/class-mpavc-title-box-style3.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/title_box/class-mpavc-title-box-style4.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/title_box/class-mpavc-title-box-style5.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/heading/class-mpavc-heading.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/icon/class-mpavc-icon.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/heading_line/class-mpavc-heading-line.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/counter/class-mpavc-counter.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/charts/class-mpavc-pie-chart.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/charts/class-mpavc-bar-chart.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/button/class-mpavc-button.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/interactive_box/class-mpavc-interactive-box-style1.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/interactive_box/class-mpavc-interactive-box-style2.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/team/class-mpavc-team-style1.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/team/class-mpavc-team-style2.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/team/class-mpavc-team-style3.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/team/class-mpavc-team-style4.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/team/class-mpavc-team-style5.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/team/class-mpavc-team-style6.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/team/class-mpavc-team-style7.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/team_carousel/class-mpavc-team-carousel-style1.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/team_carousel/class-mpavc-team-carousel-style2.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/team_carousel/class-mpavc-team-carousel-style3.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/team_carousel/class-mpavc-team-carousel-style4.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/team_carousel/class-mpavc-team-carousel-style5.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/team_carousel/class-mpavc-team-carousel-style6.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/team_carousel/class-mpavc-team-carousel-style7.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/logo_carousel/class-mpavc-logo-carousel.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/blog/class-mpavc-blog-posts-style1.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/blog/class-mpavc-blog-posts-style2.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/blog/class-mpavc-blog-posts-style3.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/blog/class-mpavc-blog-posts-style4.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/blog/class-mpavc-blog-posts-style5.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/blog/class-mpavc-blog-posts-style6.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/news/class-mpavc-news-posts-style1.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/news/class-mpavc-news-posts-style2.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/news/class-mpavc-news-posts-style3.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/news/class-mpavc-news-posts-style4.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/news/class-mpavc-news-posts-style5.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/news/class-mpavc-news-posts-style6.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/news_v2/class-mpavc-news-v2-posts-style1.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/news_v2/class-mpavc-news-v2-posts-style2.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/news_v2/class-mpavc-news-v2-posts-style3.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/news_v2/class-mpavc-news-v2-posts-style4.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/news_v2/class-mpavc-news-v2-posts-style5.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/blog_carousel/class-mpavc-blog-carousel-posts-style1.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/blog_carousel/class-mpavc-blog-carousel-posts-style2.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/blog_carousel/class-mpavc-blog-carousel-posts-style3.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/blog_carousel/class-mpavc-blog-carousel-posts-style4.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/blog_carousel/class-mpavc-blog-carousel-posts-style5.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/news_carousel/class-mpavc-news-carousel-posts-style1.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/news_carousel/class-mpavc-news-carousel-posts-style2.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/news_carousel/class-mpavc-news-carousel-posts-style3.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/news_carousel/class-mpavc-news-carousel-posts-style4.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/gallery/class-mpavc-gallery.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/gallery_instagram/class-mpavc-gallery-instagram.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/gallery_image_posts/class-mpavc-gallery-image-posts.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/map/class-mpavc-map.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/timeline/class-mpavc-timeline-style1.php' );
			
			include_once( plugin_dir_path( __FILE__ ) . 'addons/templates/vc-templates-help.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/templates/vc-templates.php' );
			
        }

        /**
         * Load general scripts
         */
        public function load_general_scripts() {

			if (!class_exists('Mulse_Main')) {
				wp_enqueue_style( 'mpavc-fonts',  plugin_dir_url( __FILE__ ) . 'assets/css/fonts.css' );
			}
			wp_register_style( 'bootstrap',  plugin_dir_url( __FILE__ ) . 'assets/css/bootstrap.css' );
			wp_register_style( 'mpavc-style',  plugin_dir_url( __FILE__ ) . 'assets/css/style.css' );
			wp_register_style( 'mpavc-style-blog',  plugin_dir_url( __FILE__ ) . 'assets/css/style_blog.css' );
			wp_register_style( 'mpavc-style-news',  plugin_dir_url( __FILE__ ) . 'assets/css/style_news.css' );
			wp_register_style( 'mpavc-style-news-v2',  plugin_dir_url( __FILE__ ) . 'assets/css/style_news_v2.css' );
			wp_register_style( 'animations',  plugin_dir_url( __FILE__ ) . 'assets/css/animations.min.css' );
			wp_register_style( 'mpavc-gallery',  plugin_dir_url( __FILE__ ) . 'assets/css/style_gallery.css' );
			wp_register_style( 'prettyphoto',  plugin_dir_url( __FILE__ ) . 'assets/css/gallery/prettyPhoto.css' );
			wp_register_style( 'magnific-popup',  plugin_dir_url( __FILE__ ) . 'assets/css/gallery/magnific-popup.css' );
			wp_register_style( 'lightgallery',  plugin_dir_url( __FILE__ ) . 'assets/css/gallery/lightGallery.css' );
			wp_register_style( 'owlcarousel',  plugin_dir_url( __FILE__ ) . 'assets/css/owl.carousel.min.css' );
			wp_enqueue_script( 'jquery');
			wp_register_script( 'appear',  plugin_dir_url( __FILE__ ) . 'assets/js/appear.min.js' );
			wp_register_script( 'animations',  plugin_dir_url( __FILE__ ) . 'assets/js/animations.min.js' );			
			wp_register_script( 'countTo',  plugin_dir_url( __FILE__ ) . 'assets/js/jquery.countTo.min.js' );			
			wp_register_script( 'easypiechart',  plugin_dir_url( __FILE__ ) . 'assets/js/jquery.easypiechart.min.js' );
			wp_register_script( 'owlcarousel',  plugin_dir_url( __FILE__ ) . 'assets/js/owl.carousel.min.js' );
			wp_register_script( 'prettyphoto',  plugin_dir_url( __FILE__ ) . 'assets/js/gallery/jquery.prettyPhoto.js' );
			wp_register_script( 'magnific-popup',  plugin_dir_url( __FILE__ ) . 'assets/js/gallery/jquery.magnific-popup.js' );
			wp_register_script( 'lightgallery',  plugin_dir_url( __FILE__ ) . 'assets/js/gallery/lightGallery.min.js' );
			wp_enqueue_script( 'mpavc-js',  plugin_dir_url( __FILE__ ) . 'assets/js/mpavc.js' );			
						
        }			

	}
	
	
endif; // End if class_exists check

function MPAVC() {
    return Mpavc_Main::instance();
}

// Get MPAVC Running
MPAVC();